// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Db.pas' rev: 3.00

#ifndef DbHPP
#define DbHPP
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------
namespace Db
{
    typedef TDateTimeBase TDateTimeAlias;
}

namespace Db
{
//-- type declarations -------------------------------------------------------
enum TDataSetState { dsInactive, dsBrowse, dsEdit, dsInsert, dsSetKey, dsCalcFields, dsFilter, dsNewValue, 
	dsOldValue, dsCurValue };

enum TDataEvent { deFieldChange, deRecordChange, deDataSetChange, deDataSetScroll, deLayoutChange, deUpdateRecord, 
	deUpdateState, deCheckBrowseMode, dePropertyChange, deFieldListChange, deFocusControl };

enum TUpdateStatus { usUnmodified, usModified, usInserted, usDeleted };

class DELPHICLASS EDatabaseError;
class PASCALIMPLEMENTATION EDatabaseError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EDatabaseError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EDatabaseError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EDatabaseError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EDatabaseError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EDatabaseError(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EDatabaseError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EDatabaseError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EDatabaseError(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EDatabaseError(void) { }
	
};

class DELPHICLASS TNamedItem;
class PASCALIMPLEMENTATION TNamedItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FName;
	
protected:
	virtual System::AnsiString __fastcall GetDisplayName(void);
	virtual void __fastcall SetDisplayName(const System::AnsiString Value);
	
__published:
	__property System::AnsiString Name = {read=FName, write=SetDisplayName};
public:
	/* TCollectionItem.Create */ __fastcall virtual TNamedItem(Classes::TCollection* Collection) : Classes::
		TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TNamedItem(void) { }
	
};

typedef void __fastcall (__closure *TDefUpdateMethod)(void);

class DELPHICLASS TDefCollection;
class DELPHICLASS TDataSet;
class DELPHICLASS TFieldDefs;
class PASCALIMPLEMENTATION TDefCollection : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TDataSet* FDataset;
	bool FUpdated;
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	virtual void __fastcall SetItemName(Classes::TCollectionItem* AItem);
	virtual void __fastcall Update(Classes::TCollectionItem* AItem);
	void __fastcall UpdateDefs(TDefUpdateMethod AMethod);
	
public:
	__fastcall TDefCollection(TDataSet* ADataset, System::TMetaClass* AClass);
	int __fastcall IndexOf(const System::AnsiString AName);
	TNamedItem* __fastcall Find(const System::AnsiString AName);
	__property TDataSet* Dataset = {read=FDataset};
	__property bool Updated = {read=FUpdated, write=FUpdated, nodefault};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TDefCollection(void) { }
	
};

class DELPHICLASS TFieldDef;
enum TFieldType { ftUnknown, ftString, ftSmallint, ftInteger, ftWord, ftBoolean, ftFloat, ftCurrency, 
	ftBCD, ftDate, ftTime, ftDateTime, ftBytes, ftVarBytes, ftAutoInc, ftBlob, ftMemo, ftGraphic, ftFmtMemo, 
	ftParadoxOle, ftDBaseOle, ftTypedBinary, ftCursor };

class PASCALIMPLEMENTATION TFieldDefs : public Db::TDefCollection 
{
	typedef Db::TDefCollection inherited;
	
private:
	TFieldDef* __fastcall GetFieldDef(int Index);
	void __fastcall SetFieldDef(int Index, TFieldDef* Value);
	
public:
	__fastcall TFieldDefs(TDataSet* ADataset);
	TFieldDef* __fastcall AddFieldDef(void);
	HIDESBASE TFieldDef* __fastcall Find(const System::AnsiString Name);
	HIDESBASE void __fastcall Update(void);
	HIDESBASE void __fastcall Add(const System::AnsiString N, TFieldType T, Word S, bool R);
	__property TFieldDef* Items[int Index] = {read=GetFieldDef, write=SetFieldDef/*, default*/};
public:
		
	/* TCollection.Destroy */ __fastcall virtual ~TFieldDefs(void) { }
	
};

class DELPHICLASS TDataLink;
class DELPHICLASS TDataSource;
class DELPHICLASS TField;
typedef void __fastcall (__closure *TDataChangeEvent)(System::TObject* Sender, TField* Field);

class PASCALIMPLEMENTATION TDataSource : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TDataSet* FDataSet;
	Classes::TList* FDataLinks;
	bool FEnabled;
	bool FAutoEdit;
	TDataSetState FState;
	Classes::TNotifyEvent FOnStateChange;
	TDataChangeEvent FOnDataChange;
	Classes::TNotifyEvent FOnUpdateData;
	void __fastcall AddDataLink(TDataLink* DataLink);
	void __fastcall DataEvent(TDataEvent Event, int Info);
	void __fastcall NotifyDataLinks(TDataEvent Event, int Info);
	void __fastcall RemoveDataLink(TDataLink* DataLink);
	void __fastcall SetDataSet(TDataSet* ADataSet);
	void __fastcall SetEnabled(bool Value);
	void __fastcall SetState(TDataSetState Value);
	void __fastcall UpdateState(void);
	
protected:
	__property Classes::TList* DataLinks = {read=FDataLinks};
	
public:
	__fastcall virtual TDataSource(Classes::TComponent* AOwner);
	__fastcall virtual ~TDataSource(void);
	void __fastcall Edit(void);
	bool __fastcall IsLinkedTo(TDataSet* DataSet);
	__property TDataSetState State = {read=FState, nodefault};
	
__published:
	__property bool AutoEdit = {read=FAutoEdit, write=FAutoEdit, default=1};
	__property TDataSet* DataSet = {read=FDataSet, write=SetDataSet};
	__property bool Enabled = {read=FEnabled, write=SetEnabled, default=1};
	__property Classes::TNotifyEvent OnStateChange = {read=FOnStateChange, write=FOnStateChange};
	__property TDataChangeEvent OnDataChange = {read=FOnDataChange, write=FOnDataChange};
	__property Classes::TNotifyEvent OnUpdateData = {read=FOnUpdateData, write=FOnUpdateData};
};

typedef TField* *TFieldRef;

class PASCALIMPLEMENTATION TDataLink : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TDataSource* FDataSource;
	TDataLink* FNext;
	int FBufferCount;
	int FFirstRecord;
	bool FReadOnly;
	bool FActive;
	bool FEditing;
	bool FUpdating;
	bool FDataSourceFixed;
	void __fastcall DataEvent(TDataEvent Event, int Info);
	int __fastcall GetActiveRecord(void);
	TDataSet* __fastcall GetDataSet(void);
	int __fastcall GetRecordCount(void);
	void __fastcall SetActive(bool Value);
	void __fastcall SetActiveRecord(int Value);
	void __fastcall SetBufferCount(int Value);
	void __fastcall SetDataSource(TDataSource* ADataSource);
	void __fastcall SetEditing(bool Value);
	void __fastcall SetReadOnly(bool Value);
	void __fastcall UpdateRange(void);
	void __fastcall UpdateState(void);
	
protected:
	virtual void __fastcall ActiveChanged(void);
	virtual void __fastcall CheckBrowseMode(void);
	virtual void __fastcall DataSetChanged(void);
	virtual void __fastcall DataSetScrolled(int Distance);
	virtual void __fastcall FocusControl(TFieldRef Field);
	virtual void __fastcall EditingChanged(void);
	virtual void __fastcall LayoutChanged(void);
	virtual void __fastcall RecordChanged(TField* Field);
	virtual void __fastcall UpdateData(void);
	
public:
	__fastcall TDataLink(void);
	__fastcall virtual ~TDataLink(void);
	bool __fastcall Edit(void);
	void __fastcall UpdateRecord(void);
	__property bool Active = {read=FActive, nodefault};
	__property int ActiveRecord = {read=GetActiveRecord, write=SetActiveRecord, nodefault};
	__property int BufferCount = {read=FBufferCount, write=SetBufferCount, nodefault};
	__property TDataSet* DataSet = {read=GetDataSet};
	__property TDataSource* DataSource = {read=FDataSource, write=SetDataSource};
	__property bool DataSourceFixed = {read=FDataSourceFixed, write=FDataSourceFixed, nodefault};
	__property bool Editing = {read=FEditing, nodefault};
	__property bool ReadOnly = {read=FReadOnly, write=SetReadOnly, nodefault};
	__property int RecordCount = {read=GetRecordCount, nodefault};
};

typedef char *TBufferList[268435455];

typedef TBufferList *PBufferList;

class DELPHICLASS TDataSetDesigner;
class PASCALIMPLEMENTATION TDataSetDesigner : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TDataSet* FDataSet;
	bool FSaveActive;
	
public:
	__fastcall TDataSetDesigner(TDataSet* DataSet);
	__fastcall virtual ~TDataSetDesigner(void);
	void __fastcall BeginDesign(void);
	virtual void __fastcall DataEvent(TDataEvent Event, int Info);
	void __fastcall EndDesign(void);
	__property TDataSet* DataSet = {read=FDataSet};
};

enum TFilterOption { foCaseInsensitive, foNoPartialCompare };

typedef Set<TFilterOption, foCaseInsensitive, foNoPartialCompare>  TFilterOptions;

class DELPHICLASS TCheckConstraints;
class DELPHICLASS TCheckConstraint;
class PASCALIMPLEMENTATION TCheckConstraints : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	Classes::TPersistent* FOwner;
	HIDESBASE TCheckConstraint* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, TCheckConstraint* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TCheckConstraints(Classes::TPersistent* Owner);
	HIDESBASE TCheckConstraint* __fastcall Add(void);
	__property TCheckConstraint* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TCheckConstraints(void) { }
	
};

typedef void __fastcall (__closure *TDataSetNotifyEvent)(TDataSet* DataSet);

enum TDataAction { daFail, daAbort, daRetry };

typedef void __fastcall (__closure *TDataSetErrorEvent)(TDataSet* DataSet, EDatabaseError* E, TDataAction 
	&Action);

typedef void __fastcall (__closure *TFilterRecordEvent)(TDataSet* DataSet, bool &Accept);

typedef void __fastcall (__closure *TDataOperation)(void);

typedef System::TMetaClass*TFieldClass;

enum TBookmarkFlag { bfCurrent, bfBOF, bfEOF, bfInserted };

enum TGetResult { grOK, grBOF, grEOF, grError };

enum TGetMode { gmCurrent, gmNext, gmPrior };

enum TBlobStreamMode { bmRead, bmWrite, bmReadWrite };

enum TLocateOption { loCaseInsensitive, loPartialKey };

typedef Set<TLocateOption, loCaseInsensitive, loPartialKey>  TLocateOptions;

enum Db__63 { rmExact, rmCenter };

typedef Set<Db__63, rmExact, rmCenter>  TResyncMode;

class PASCALIMPLEMENTATION TDataSet : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TList* FFields;
	TFieldDefs* FFieldDefs;
	Classes::TList* FDataSources;
	TDataLink* FFirstDataLink;
	int FBufferCount;
	int FRecordCount;
	int FActiveRecord;
	int FCurrentRecord;
	TBufferList *FBuffers;
	char *FCalcBuffer;
	int FBufListSize;
	int FBookmarkSize;
	int FCalcFieldsSize;
	bool FBOF;
	bool FEOF;
	bool FModified;
	bool FStreamedActive;
	bool FInternalCalcFields;
	TDataSetState FState;
	TDataEvent FEnableEvent;
	TDataSetState FDisableState;
	TDataSetDesigner* FDesigner;
	int FDisableCount;
	bool FFound;
	bool FDefaultFields;
	bool FAutoCalcFields;
	bool FFiltered;
	int FBlobFieldCount;
	System::AnsiString FFilterText;
	TFilterOptions FFilterOptions;
	TCheckConstraints* FConstraints;
	TDataSetNotifyEvent FBeforeOpen;
	TDataSetNotifyEvent FAfterOpen;
	TDataSetNotifyEvent FBeforeClose;
	TDataSetNotifyEvent FAfterClose;
	TDataSetNotifyEvent FBeforeInsert;
	TDataSetNotifyEvent FAfterInsert;
	TDataSetNotifyEvent FBeforeEdit;
	TDataSetNotifyEvent FAfterEdit;
	TDataSetNotifyEvent FBeforePost;
	TDataSetNotifyEvent FAfterPost;
	TDataSetNotifyEvent FBeforeCancel;
	TDataSetNotifyEvent FAfterCancel;
	TDataSetNotifyEvent FBeforeDelete;
	TDataSetNotifyEvent FAfterDelete;
	TDataSetNotifyEvent FBeforeScroll;
	TDataSetNotifyEvent FAfterScroll;
	TDataSetNotifyEvent FOnNewRecord;
	TDataSetNotifyEvent FOnCalcFields;
	TDataSetErrorEvent FOnEditError;
	TDataSetErrorEvent FOnPostError;
	TDataSetErrorEvent FOnDeleteError;
	TFilterRecordEvent FOnFilterRecord;
	void __fastcall AddDataSource(TDataSource* DataSource);
	void __fastcall AddField(TField* Field);
	void __fastcall AddRecord(const System::TVarRec * Values, const int Values_Size, bool Append);
	void __fastcall BeginInsertAppend(void);
	void __fastcall CheckCanModify(void);
	void __fastcall CheckFieldName(const System::AnsiString FieldName);
	void __fastcall CheckFieldNames(const System::AnsiString FieldNames);
	void __fastcall CheckOperation(TDataOperation Operation, TDataSetErrorEvent ErrorEvent);
	void __fastcall CheckRequiredFields(void);
	void __fastcall DoInternalOpen(void);
	void __fastcall DoInternalClose(void);
	void __fastcall EndInsertAppend(void);
	bool __fastcall GetActive(void);
	char * __fastcall GetBuffer(int Index);
	TField* __fastcall GetField(int Index);
	int __fastcall GetFieldCount(void);
	System::Variant __fastcall GetFieldValue(const System::AnsiString FieldName);
	bool __fastcall GetFound(void);
	void __fastcall MoveBuffer(int CurIndex, int NewIndex);
	void __fastcall RemoveDataSource(TDataSource* DataSource);
	void __fastcall RemoveField(TField* Field);
	void __fastcall SetActive(bool Value);
	void __fastcall SetBufferCount(int Value);
	void __fastcall SetField(int Index, TField* Value);
	void __fastcall SetFieldDefs(TFieldDefs* Value);
	void __fastcall SetFieldValue(const System::AnsiString FieldName, const System::Variant &Value);
	void __fastcall SetConstraints(TCheckConstraints* Value);
	void __fastcall UpdateBufferCount(void);
	
protected:
	virtual void __fastcall ActivateBuffers(void);
	void __fastcall BindFields(bool Binding);
	bool __fastcall BookmarkAvailable(void);
	virtual bool __fastcall BCDToCurr(void * BCD, System::Currency &Curr);
	virtual bool __fastcall CurrToBCD(const System::Currency Curr, void * BCD, int Precision, int Decimals
		);
	virtual void __fastcall CalculateFields(char * Buffer);
	virtual void __fastcall CheckActive(void);
	virtual void __fastcall CheckInactive(void);
	virtual void __fastcall ClearBuffers(void);
	virtual void __fastcall ClearCalcFields(char * Buffer);
	virtual void __fastcall CloseBlob(TField* Field);
	virtual void __fastcall CloseCursor(void);
	void __fastcall CreateFields(void);
	virtual void __fastcall DataEvent(TDataEvent Event, int Info);
	virtual void __fastcall DefChanged(System::TObject* Sender);
	virtual void __fastcall DestroyFields(void);
	virtual void __fastcall DoAfterCancel(void);
	virtual void __fastcall DoAfterClose(void);
	virtual void __fastcall DoAfterDelete(void);
	virtual void __fastcall DoAfterEdit(void);
	virtual void __fastcall DoAfterInsert(void);
	virtual void __fastcall DoAfterOpen(void);
	virtual void __fastcall DoAfterPost(void);
	virtual void __fastcall DoAfterScroll(void);
	virtual void __fastcall DoBeforeCancel(void);
	virtual void __fastcall DoBeforeClose(void);
	virtual void __fastcall DoBeforeDelete(void);
	virtual void __fastcall DoBeforeEdit(void);
	virtual void __fastcall DoBeforeInsert(void);
	virtual void __fastcall DoBeforeOpen(void);
	virtual void __fastcall DoBeforePost(void);
	virtual void __fastcall DoBeforeScroll(void);
	virtual void __fastcall DoOnCalcFields(void);
	virtual void __fastcall DoOnNewRecord(void);
	TField* __fastcall FieldByNumber(int FieldNo);
	virtual bool __fastcall FindRecord(bool Restart, bool GoForward);
	virtual void __fastcall FreeFieldBuffers(void);
	virtual System::AnsiString __fastcall GetBookmarkStr(void);
	virtual void __fastcall GetCalcFields(char * Buffer);
	virtual bool __fastcall GetCanModify(void);
	DYNAMIC void __fastcall GetChildren(Classes::TGetChildProc Proc, Classes::TComponent* Root);
	virtual TDataSource* __fastcall GetDataSource(void);
	virtual System::TMetaClass* __fastcall GetFieldClass(TFieldType FieldType);
	virtual System::Variant __fastcall GetStateFieldValue(TDataSetState State, TField* Field);
	virtual bool __fastcall GetIsIndexField(TField* Field);
	virtual int __fastcall GetNextRecords(void);
	virtual bool __fastcall GetNextRecord(void);
	virtual int __fastcall GetPriorRecords(void);
	virtual bool __fastcall GetPriorRecord(void);
	virtual int __fastcall GetRecordCount(void);
	virtual int __fastcall GetRecNo(void);
	virtual void __fastcall InitFieldDefs(void);
	virtual void __fastcall InitRecord(char * Buffer);
	virtual void __fastcall InternalCancel(void);
	virtual void __fastcall InternalEdit(void);
	virtual void __fastcall InternalRefresh(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall OpenCursor(bool InfoQuery);
	virtual void __fastcall RefreshInternalCalcFields(char * Buffer);
	void __fastcall RestoreState(const TDataSetState Value);
	virtual void __fastcall SetBookmarkStr(const System::AnsiString Value);
	void __fastcall SetBufListSize(int Value);
	DYNAMIC void __fastcall SetChildOrder(Classes::TComponent* Component, int Order);
	virtual void __fastcall SetCurrentRecord(int Index);
	virtual void __fastcall SetFiltered(bool Value);
	virtual void __fastcall SetFilterOptions(TFilterOptions Value);
	virtual void __fastcall SetFilterText(const System::AnsiString Value);
	void __fastcall SetFound(const bool Value);
	void __fastcall SetModified(bool Value);
	virtual void __fastcall SetName(const System::AnsiString Value);
	virtual void __fastcall SetStateFieldValue(TDataSetState State, TField* Field, const System::Variant 
		&Value);
	virtual void __fastcall SetOnFilterRecord(const TFilterRecordEvent Value);
	virtual void __fastcall SetRecNo(int Value);
	void __fastcall SetState(TDataSetState Value);
	TDataSetState __fastcall SetTempState(const TDataSetState Value);
	char * __fastcall TempBuffer(void);
	virtual void __fastcall UpdateIndexDefs(void);
	__property int ActiveRecord = {read=FActiveRecord, nodefault};
	__property int CurrentRecord = {read=FCurrentRecord, nodefault};
	__property int BlobFieldCount = {read=FBlobFieldCount, nodefault};
	__property int BookmarkSize = {read=FBookmarkSize, write=FBookmarkSize, nodefault};
	__property char * Buffers[int Index] = {read=GetBuffer};
	__property int BufferCount = {read=FBufferCount, nodefault};
	__property char * CalcBuffer = {read=FCalcBuffer};
	__property int CalcFieldsSize = {read=FCalcFieldsSize, nodefault};
	__property bool InternalCalcFields = {read=FInternalCalcFields, nodefault};
	__property TCheckConstraints* Constraints = {read=FConstraints, write=SetConstraints};
	virtual char * __fastcall AllocRecordBuffer(void) = 0;
	virtual void __fastcall FreeRecordBuffer(char * &Buffer) = 0;
	virtual void __fastcall GetBookmarkData(char * Buffer, void * Data) = 0;
	virtual TBookmarkFlag __fastcall GetBookmarkFlag(char * Buffer) = 0;
	virtual bool __fastcall GetFieldData(TField* Field, void * Buffer) = 0;
	virtual TGetResult __fastcall GetRecord(char * Buffer, TGetMode GetMode, bool DoCheck) = 0;
	virtual Word __fastcall GetRecordSize(void) = 0;
	virtual void __fastcall InternalAddRecord(void * Buffer, bool Append) = 0;
	virtual void __fastcall InternalClose(void) = 0;
	virtual void __fastcall InternalDelete(void) = 0;
	virtual void __fastcall InternalFirst(void) = 0;
	virtual void __fastcall InternalGotoBookmark(void * Bookmark) = 0;
	virtual void __fastcall InternalHandleException(void) = 0;
	virtual void __fastcall InternalInitFieldDefs(void) = 0;
	virtual void __fastcall InternalInitRecord(char * Buffer) = 0;
	virtual void __fastcall InternalLast(void) = 0;
	virtual void __fastcall InternalOpen(void) = 0;
	virtual void __fastcall InternalPost(void) = 0;
	virtual void __fastcall InternalSetToRecord(char * Buffer) = 0;
	virtual bool __fastcall IsCursorOpen(void) = 0;
	virtual void __fastcall SetBookmarkFlag(char * Buffer, TBookmarkFlag Value) = 0;
	virtual void __fastcall SetBookmarkData(char * Buffer, void * Data) = 0;
	virtual void __fastcall SetFieldData(TField* Field, void * Buffer) = 0;
	
public:
	__fastcall virtual TDataSet(Classes::TComponent* AOwner);
	__fastcall virtual ~TDataSet(void);
	char * __fastcall ActiveBuffer(void);
	void __fastcall Append(void);
	void __fastcall AppendRecord(const System::TVarRec * Values, const int Values_Size);
	virtual bool __fastcall BookmarkValid(void * Bookmark);
	virtual void __fastcall Cancel(void);
	void __fastcall CheckBrowseMode(void);
	void __fastcall ClearFields(void);
	void __fastcall Close(void);
	bool __fastcall ControlsDisabled(void);
	virtual int __fastcall CompareBookmarks(void * Bookmark1, void * Bookmark2);
	virtual Classes::TStream* __fastcall CreateBlobStream(TField* Field, TBlobStreamMode Mode);
	void __fastcall CursorPosChanged(void);
	void __fastcall Delete(void);
	void __fastcall DisableControls(void);
	void __fastcall Edit(void);
	void __fastcall EnableControls(void);
	TField* __fastcall FieldByName(const System::AnsiString FieldName);
	TField* __fastcall FindField(const System::AnsiString FieldName);
	bool __fastcall FindFirst(void);
	bool __fastcall FindLast(void);
	bool __fastcall FindNext(void);
	bool __fastcall FindPrior(void);
	void __fastcall First(void);
	virtual void __fastcall FreeBookmark(void * Bookmark);
	virtual void * __fastcall GetBookmark(void);
	virtual bool __fastcall GetCurrentRecord(char * Buffer);
	void __fastcall GetFieldList(Classes::TList* List, const System::AnsiString FieldNames);
	void __fastcall GetFieldNames(Classes::TStrings* List);
	void __fastcall GotoBookmark(void * Bookmark);
	HIDESBASE void __fastcall Insert(void);
	void __fastcall InsertRecord(const System::TVarRec * Values, const int Values_Size);
	bool __fastcall IsEmpty(void);
	bool __fastcall IsLinkedTo(TDataSource* DataSource);
	virtual bool __fastcall IsSequenced(void);
	void __fastcall Last(void);
	virtual bool __fastcall Locate(const System::AnsiString KeyFields, const System::Variant &KeyValues
		, TLocateOptions Options);
	virtual System::Variant __fastcall Lookup(const System::AnsiString KeyFields, const System::Variant 
		&KeyValues, const System::AnsiString ResultFields);
	int __fastcall MoveBy(int Distance);
	void __fastcall Next(void);
	void __fastcall Open(void);
	virtual void __fastcall Post(void);
	void __fastcall Prior(void);
	void __fastcall Refresh(void);
	virtual void __fastcall Resync(TResyncMode Mode);
	void __fastcall SetFields(const System::TVarRec * Values, const int Values_Size);
	virtual void __fastcall Translate(char * Src, char * Dest, bool ToOem);
	void __fastcall UpdateCursorPos(void);
	void __fastcall UpdateRecord(void);
	__property bool Bof = {read=FBOF, nodefault};
	__property System::AnsiString Bookmark = {read=GetBookmarkStr, write=SetBookmarkStr};
	__property bool CanModify = {read=GetCanModify, nodefault};
	__property TDataSource* DataSource = {read=GetDataSource};
	__property bool DefaultFields = {read=FDefaultFields, nodefault};
	__property TDataSetDesigner* Designer = {read=FDesigner};
	__property bool Eof = {read=FEOF, nodefault};
	__property int FieldCount = {read=GetFieldCount, nodefault};
	__property TFieldDefs* FieldDefs = {read=FFieldDefs, write=SetFieldDefs};
	__property TField* Fields[int Index] = {read=GetField, write=SetField};
	__property System::Variant FieldValues[System::AnsiString FieldName] = {read=GetFieldValue, write=SetFieldValue
		/*, default*/};
	__property bool Found = {read=GetFound, nodefault};
	__property bool Modified = {read=FModified, nodefault};
	__property int RecordCount = {read=GetRecordCount, nodefault};
	__property int RecNo = {read=GetRecNo, write=SetRecNo, nodefault};
	__property Word RecordSize = {read=GetRecordSize, nodefault};
	__property TDataSetState State = {read=FState, nodefault};
	__property System::AnsiString Filter = {read=FFilterText, write=SetFilterText};
	__property bool Filtered = {read=FFiltered, write=SetFiltered, default=0};
	__property TFilterOptions FilterOptions = {read=FFilterOptions, write=SetFilterOptions, default=0};
		
	__property bool Active = {read=GetActive, write=SetActive, default=0};
	__property bool AutoCalcFields = {read=FAutoCalcFields, write=FAutoCalcFields, default=1};
	__property TDataSetNotifyEvent BeforeOpen = {read=FBeforeOpen, write=FBeforeOpen};
	__property TDataSetNotifyEvent AfterOpen = {read=FAfterOpen, write=FAfterOpen};
	__property TDataSetNotifyEvent BeforeClose = {read=FBeforeClose, write=FBeforeClose};
	__property TDataSetNotifyEvent AfterClose = {read=FAfterClose, write=FAfterClose};
	__property TDataSetNotifyEvent BeforeInsert = {read=FBeforeInsert, write=FBeforeInsert};
	__property TDataSetNotifyEvent AfterInsert = {read=FAfterInsert, write=FAfterInsert};
	__property TDataSetNotifyEvent BeforeEdit = {read=FBeforeEdit, write=FBeforeEdit};
	__property TDataSetNotifyEvent AfterEdit = {read=FAfterEdit, write=FAfterEdit};
	__property TDataSetNotifyEvent BeforePost = {read=FBeforePost, write=FBeforePost};
	__property TDataSetNotifyEvent AfterPost = {read=FAfterPost, write=FAfterPost};
	__property TDataSetNotifyEvent BeforeCancel = {read=FBeforeCancel, write=FBeforeCancel};
	__property TDataSetNotifyEvent AfterCancel = {read=FAfterCancel, write=FAfterCancel};
	__property TDataSetNotifyEvent BeforeDelete = {read=FBeforeDelete, write=FBeforeDelete};
	__property TDataSetNotifyEvent AfterDelete = {read=FAfterDelete, write=FAfterDelete};
	__property TDataSetNotifyEvent BeforeScroll = {read=FBeforeScroll, write=FBeforeScroll};
	__property TDataSetNotifyEvent AfterScroll = {read=FAfterScroll, write=FAfterScroll};
	__property TDataSetNotifyEvent OnCalcFields = {read=FOnCalcFields, write=FOnCalcFields};
	__property TDataSetErrorEvent OnDeleteError = {read=FOnDeleteError, write=FOnDeleteError};
	__property TDataSetErrorEvent OnEditError = {read=FOnEditError, write=FOnEditError};
	__property TFilterRecordEvent OnFilterRecord = {read=FOnFilterRecord, write=SetOnFilterRecord};
	__property TDataSetNotifyEvent OnNewRecord = {read=FOnNewRecord, write=FOnNewRecord};
	__property TDataSetErrorEvent OnPostError = {read=FOnPostError, write=FOnPostError};
};


class PASCALIMPLEMENTATION TFieldDef : public Db::TNamedItem 
{
	typedef Db::TNamedItem inherited;
	
private:
	TFieldType FDataType;
	int FPrecision;
	Word FSize;
	bool FRequired;
	bool FInternalCalcField;
	void __fastcall SetDataType(TFieldType AType);
	System::TMetaClass* __fastcall GetFieldClass(void);
	int __fastcall GetFieldNo(void);
	void __fastcall SetFieldNo(int AFieldNo);
	void __fastcall SetPrecision(int APrecision);
	void __fastcall SetRequired(bool ARequired);
	void __fastcall SetSize(Word ASize);
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	TField* __fastcall CreateField(Classes::TComponent* Owner);
	__property System::TMetaClass* FieldClass = {read=GetFieldClass};
	__property bool InternalCalcField = {read=FInternalCalcField, write=FInternalCalcField, nodefault};
		
	
__published:
	__property int FieldNo = {read=GetFieldNo, write=SetFieldNo, stored=false, nodefault};
	__property TFieldType DataType = {read=FDataType, write=SetDataType, nodefault};
	__property int Precision = {read=FPrecision, write=SetPrecision, nodefault};
	__property bool Required = {read=FRequired, write=SetRequired, nodefault};
	__property Word Size = {read=FSize, write=SetSize, nodefault};
public:
	/* TCollectionItem.Create */ __fastcall virtual TFieldDef(Classes::TCollection* Collection) : Db::TNamedItem(
		Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TFieldDef(void) { }
	
};

enum Db__6 { ixPrimary, ixUnique, ixDescending, ixCaseInsensitive, ixExpression };

typedef Set<Db__6, ixPrimary, ixExpression>  TIndexOptions;

class DELPHICLASS TIndexDef;
class PASCALIMPLEMENTATION TIndexDef : public Db::TNamedItem 
{
	typedef Db::TNamedItem inherited;
	
private:
	System::AnsiString FSource;
	System::AnsiString FFieldExpression;
	TIndexOptions FOptions;
	void __fastcall SetOptions(TIndexOptions AOptions);
	void __fastcall SetSource(const System::AnsiString ASource);
	System::AnsiString __fastcall GetExpression(void);
	void __fastcall SetExpression(const System::AnsiString AExpression);
	System::AnsiString __fastcall GetFields(void);
	void __fastcall SetFields(const System::AnsiString AFields);
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* ASource);
	__property System::AnsiString FieldExpression = {read=FFieldExpression};
	
__published:
	__property TIndexOptions Options = {read=FOptions, write=SetOptions, nodefault};
	__property System::AnsiString Expression = {read=GetExpression, write=SetExpression};
	__property System::AnsiString Fields = {read=GetFields, write=SetFields};
	__property System::AnsiString Source = {read=FSource, write=SetSource};
public:
	/* TCollectionItem.Create */ __fastcall virtual TIndexDef(Classes::TCollection* Collection) : Db::TNamedItem(
		Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TIndexDef(void) { }
	
};

class DELPHICLASS TIndexDefs;
class PASCALIMPLEMENTATION TIndexDefs : public Db::TDefCollection 
{
	typedef Db::TDefCollection inherited;
	
private:
	TIndexDef* __fastcall GetIndexDef(int Index);
	void __fastcall SetIndexDef(int Index, TIndexDef* Value);
	
public:
	__fastcall TIndexDefs(TDataSet* ADataset);
	TIndexDef* __fastcall AddIndexDef(void);
	HIDESBASE TIndexDef* __fastcall Find(const System::AnsiString Name);
	HIDESBASE void __fastcall Update(void);
	TIndexDef* __fastcall FindIndexForFields(const System::AnsiString Fields);
	TIndexDef* __fastcall GetIndexForFields(const System::AnsiString Fields, bool CaseInsensitive);
	HIDESBASE void __fastcall Add(const System::AnsiString N, const System::AnsiString F, TIndexOptions 
		O);
	__property TIndexDef* Items[int Index] = {read=GetIndexDef, write=SetIndexDef/*, default*/};
public:
		
	/* TCollection.Destroy */ __fastcall virtual ~TIndexDefs(void) { }
	
};

enum TFieldKind { fkData, fkCalculated, fkLookup, fkInternalCalc };

typedef void __fastcall (__closure *TFieldNotifyEvent)(TField* Sender);

typedef void __fastcall (__closure *TFieldGetTextEvent)(TField* Sender, System::AnsiString &Text, bool 
	DisplayText);

typedef void __fastcall (__closure *TFieldSetTextEvent)(TField* Sender, const System::AnsiString Text
	);

typedef Set<char, 0, 255>  TFieldChars;

struct TLookupListEntry;
typedef TLookupListEntry *PLookupListEntry;

struct TLookupListEntry
{
	System::Variant Key;
	System::Variant Value;
} ;

class DELPHICLASS TLookupList;
class PASCALIMPLEMENTATION TLookupList : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* FList;
	
public:
	__fastcall TLookupList(void);
	__fastcall virtual ~TLookupList(void);
	void __fastcall Add(const System::Variant &AKey, const System::Variant &AValue);
	void __fastcall Clear(void);
	System::Variant __fastcall ValueOfKey(const System::Variant &AKey);
};

class PASCALIMPLEMENTATION TField : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TDataSet* FDataSet;
	System::AnsiString FFieldName;
	TFieldType FDataType;
	bool FReadOnly;
	TFieldKind FFieldKind;
	TAlignment FAlignment;
	bool FVisible;
	bool FRequired;
	bool FValidating;
	Word FSize;
	Word FOffset;
	int FFieldNo;
	int FDisplayWidth;
	System::AnsiString FDisplayLabel;
	System::AnsiString FEditMask;
	void *FValueBuffer;
	TDataSet* FLookupDataSet;
	System::AnsiString FKeyFields;
	System::AnsiString FLookupKeyFields;
	System::AnsiString FLookupResultField;
	bool FLookupCache;
	TLookupList* FLookupList;
	System::AnsiString FAttributeSet;
	System::AnsiString FCustomConstraint;
	System::AnsiString FImportedConstraint;
	System::AnsiString FConstraintErrorMessage;
	System::AnsiString FDefaultExpression;
	System::AnsiString FOrigin;
	TFieldChars FValidChars;
	TFieldNotifyEvent FOnChange;
	TFieldNotifyEvent FOnValidate;
	TFieldGetTextEvent FOnGetText;
	TFieldSetTextEvent FOnSetText;
	void __fastcall Bind(bool Binding);
	void __fastcall CalcLookupValue(void);
	bool __fastcall FieldKindStored(void);
	bool __fastcall GetCalculated(void);
	System::AnsiString __fastcall GetDisplayLabel(void);
	System::AnsiString __fastcall GetDisplayName(void);
	System::AnsiString __fastcall GetDisplayText(void);
	int __fastcall GetDisplayWidth(void);
	System::AnsiString __fastcall GetEditText(void);
	bool __fastcall GetHasConstraints(void);
	int __fastcall GetIndex(void);
	bool __fastcall GetIsIndexField(void);
	bool __fastcall GetLookup(void);
	TLookupList* __fastcall GetLookupList(void);
	System::Variant __fastcall GetCurValue(void);
	System::Variant __fastcall GetNewValue(void);
	System::Variant __fastcall GetOldValue(void);
	bool __fastcall IsDisplayLabelStored(void);
	bool __fastcall IsDisplayWidthStored(void);
	void __fastcall ReadAttributeSet(Classes::TReader* Reader);
	void __fastcall ReadCalculated(Classes::TReader* Reader);
	void __fastcall ReadLookup(Classes::TReader* Reader);
	void __fastcall SetAlignment(Classes::TAlignment Value);
	void __fastcall SetCalculated(bool Value);
	void __fastcall SetDataSet(TDataSet* ADataSet);
	void __fastcall SetDisplayLabel(System::AnsiString Value);
	void __fastcall SetDisplayWidth(int Value);
	void __fastcall SetEditMask(const System::AnsiString Value);
	void __fastcall SetEditText(const System::AnsiString Value);
	void __fastcall SetFieldKind(TFieldKind Value);
	void __fastcall SetFieldName(const System::AnsiString Value);
	void __fastcall SetIndex(int Value);
	void __fastcall SetLookup(bool Value);
	void __fastcall SetLookupDataSet(TDataSet* Value);
	void __fastcall SetLookupKeyFields(const System::AnsiString Value);
	void __fastcall SetLookupResultField(const System::AnsiString Value);
	void __fastcall SetKeyFields(const System::AnsiString Value);
	void __fastcall SetLookupCache(const bool Value);
	void __fastcall SetNewValue(const System::Variant &Value);
	void __fastcall SetReadOnly(const bool Value);
	void __fastcall SetVisible(bool Value);
	void __fastcall ValidateLookupInfo(bool All);
	void __fastcall WriteAttributeSet(Classes::TWriter* Writer);
	void __fastcall WriteCalculated(Classes::TWriter* Writer);
	void __fastcall WriteLookup(Classes::TWriter* Writer);
	
protected:
	DYNAMIC EDatabaseError* __fastcall AccessError(const System::AnsiString TypeName);
	void __fastcall CheckInactive(void);
	/* virtual class method */ virtual void __fastcall CheckTypeSize(int Value) { CheckTypeSize(__classid(TField)
		, Value); }
	/*         class method */ static void __fastcall CheckTypeSize(System::TMetaClass* vmt, int Value)
		;
	virtual void __fastcall Change(void);
	void __fastcall DataChanged(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall FreeBuffers(void);
	virtual bool __fastcall GetAsBoolean(void);
	virtual System::Currency __fastcall GetAsCurrency(void);
	virtual System::TDateTime __fastcall GetAsDateTime(void);
	virtual double __fastcall GetAsFloat(void);
	virtual int __fastcall GetAsInteger(void);
	virtual System::AnsiString __fastcall GetAsString(void);
	virtual System::Variant __fastcall GetAsVariant(void);
	virtual bool __fastcall GetCanModify(void);
	virtual Word __fastcall GetDataSize(void);
	virtual int __fastcall GetDefaultWidth(void);
	virtual bool __fastcall GetIsNull(void);
	DYNAMIC Classes::TComponent* __fastcall GetParentComponent(void);
	virtual void __fastcall GetText(System::AnsiString &Text, bool DisplayText);
	DYNAMIC bool __fastcall HasParent(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	void __fastcall PropertyChanged(bool LayoutAffected);
	virtual void __fastcall ReadState(Classes::TReader* Reader);
	virtual void __fastcall SetAsBoolean(bool Value);
	virtual void __fastcall SetAsCurrency(System::Currency Value);
	virtual void __fastcall SetAsDateTime(System::TDateTime Value);
	virtual void __fastcall SetAsFloat(double Value);
	virtual void __fastcall SetAsInteger(int Value);
	virtual void __fastcall SetAsString(const System::AnsiString Value);
	virtual void __fastcall SetAsVariant(const System::Variant &Value);
	void __fastcall SetDataType(TFieldType Value);
	virtual void __fastcall SetSize(Word Value);
	DYNAMIC void __fastcall SetParentComponent(Classes::TComponent* AParent);
	virtual void __fastcall SetText(const System::AnsiString Value);
	virtual void __fastcall SetVarValue(const System::Variant &Value);
	
public:
	__fastcall virtual TField(Classes::TComponent* AOwner);
	__fastcall virtual ~TField(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall AssignValue(const System::TVarRec &Value);
	virtual void __fastcall Clear(void);
	void __fastcall FocusControl(void);
	bool __fastcall GetData(void * Buffer);
	/* virtual class method */ virtual bool __fastcall IsBlob() { IsBlob(__classid(TField)); }
	/*         class method */ static bool __fastcall IsBlob(System::TMetaClass* vmt);
	virtual bool __fastcall IsValidChar(char InputChar);
	void __fastcall RefreshLookupList(void);
	void __fastcall SetData(void * Buffer);
	virtual void __fastcall SetFieldType(TFieldType Value);
	void __fastcall Validate(void * Buffer);
	__property bool AsBoolean = {read=GetAsBoolean, write=SetAsBoolean, nodefault};
	__property System::Currency AsCurrency = {read=GetAsCurrency, write=SetAsCurrency};
	__property System::TDateTime AsDateTime = {read=GetAsDateTime, write=SetAsDateTime};
	__property double AsFloat = {read=GetAsFloat, write=SetAsFloat};
	__property int AsInteger = {read=GetAsInteger, write=SetAsInteger, nodefault};
	__property System::AnsiString AsString = {read=GetAsString, write=SetAsString};
	__property System::Variant AsVariant = {read=GetAsVariant, write=SetAsVariant};
	__property System::AnsiString AttributeSet = {read=FAttributeSet, write=FAttributeSet};
	__property bool Calculated = {read=GetCalculated, write=SetCalculated, default=0};
	__property bool CanModify = {read=GetCanModify, nodefault};
	__property System::Variant CurValue = {read=GetCurValue};
	__property TDataSet* DataSet = {read=FDataSet, write=SetDataSet, stored=false};
	__property Word DataSize = {read=GetDataSize, nodefault};
	__property TFieldType DataType = {read=FDataType, nodefault};
	__property System::AnsiString DisplayName = {read=GetDisplayName};
	__property System::AnsiString DisplayText = {read=GetDisplayText};
	__property System::AnsiString EditMask = {read=FEditMask, write=SetEditMask};
	__property System::AnsiString EditMaskPtr = {read=FEditMask};
	__property int FieldNo = {read=FFieldNo, nodefault};
	__property bool IsIndexField = {read=GetIsIndexField, nodefault};
	__property bool IsNull = {read=GetIsNull, nodefault};
	__property bool Lookup = {read=GetLookup, write=SetLookup, nodefault};
	__property TLookupList* LookupList = {read=GetLookupList};
	__property System::Variant NewValue = {read=GetNewValue, write=SetNewValue};
	__property Word Offset = {read=FOffset, nodefault};
	__property System::Variant OldValue = {read=GetOldValue};
	__property Word Size = {read=FSize, write=SetSize, nodefault};
	__property System::AnsiString Text = {read=GetEditText, write=SetEditText};
	__property TFieldChars ValidChars = {read=FValidChars, write=FValidChars};
	__property System::Variant Value = {read=GetAsVariant, write=SetAsVariant};
	
__published:
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, default=0};
	__property System::AnsiString CustomConstraint = {read=FCustomConstraint, write=FCustomConstraint};
		
	__property System::AnsiString ConstraintErrorMessage = {read=FConstraintErrorMessage, write=FConstraintErrorMessage
		};
	__property System::AnsiString DefaultExpression = {read=FDefaultExpression, write=FDefaultExpression
		};
	__property System::AnsiString DisplayLabel = {read=GetDisplayLabel, write=SetDisplayLabel, stored=IsDisplayLabelStored
		};
	__property int DisplayWidth = {read=GetDisplayWidth, write=SetDisplayWidth, stored=IsDisplayWidthStored
		, nodefault};
	__property TFieldKind FieldKind = {read=FFieldKind, write=SetFieldKind, stored=FieldKindStored, nodefault
		};
	__property System::AnsiString FieldName = {read=FFieldName, write=SetFieldName};
	__property bool HasConstraints = {read=GetHasConstraints, nodefault};
	__property int Index = {read=GetIndex, write=SetIndex, stored=false, nodefault};
	__property System::AnsiString ImportedConstraint = {read=FImportedConstraint, write=FImportedConstraint
		};
	__property TDataSet* LookupDataSet = {read=FLookupDataSet, write=SetLookupDataSet};
	__property System::AnsiString LookupKeyFields = {read=FLookupKeyFields, write=SetLookupKeyFields};
	__property System::AnsiString LookupResultField = {read=FLookupResultField, write=SetLookupResultField
		};
	__property System::AnsiString KeyFields = {read=FKeyFields, write=SetKeyFields};
	__property bool LookupCache = {read=FLookupCache, write=SetLookupCache, default=0};
	__property System::AnsiString Origin = {read=FOrigin, write=FOrigin};
	__property bool ReadOnly = {read=FReadOnly, write=SetReadOnly, default=0};
	__property bool Required = {read=FRequired, write=FRequired, default=0};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
	__property TFieldNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TFieldGetTextEvent OnGetText = {read=FOnGetText, write=FOnGetText};
	__property TFieldSetTextEvent OnSetText = {read=FOnSetText, write=FOnSetText};
	__property TFieldNotifyEvent OnValidate = {read=FOnValidate, write=FOnValidate};
};

class DELPHICLASS TStringField;
class PASCALIMPLEMENTATION TStringField : public Db::TField 
{
	typedef Db::TField inherited;
	
private:
	bool FTransliterate;
	
protected:
	/* virtual class method */ virtual void __fastcall CheckTypeSize(int Value) { CheckTypeSize(__classid(TStringField)
		, Value); }
	/*         class method */ static void __fastcall CheckTypeSize(System::TMetaClass* vmt, int Value)
		;
	virtual bool __fastcall GetAsBoolean(void);
	virtual System::TDateTime __fastcall GetAsDateTime(void);
	virtual double __fastcall GetAsFloat(void);
	virtual int __fastcall GetAsInteger(void);
	virtual System::AnsiString __fastcall GetAsString(void);
	virtual System::Variant __fastcall GetAsVariant(void);
	virtual Word __fastcall GetDataSize(void);
	virtual int __fastcall GetDefaultWidth(void);
	virtual void __fastcall GetText(System::AnsiString &Text, bool DisplayText);
	bool __fastcall GetValue(System::AnsiString &Value);
	virtual void __fastcall SetAsBoolean(bool Value);
	virtual void __fastcall SetAsDateTime(System::TDateTime Value);
	virtual void __fastcall SetAsFloat(double Value);
	virtual void __fastcall SetAsInteger(int Value);
	virtual void __fastcall SetAsString(const System::AnsiString Value);
	virtual void __fastcall SetVarValue(const System::Variant &Value);
	
public:
	__fastcall virtual TStringField(Classes::TComponent* AOwner);
	__property System::AnsiString Value = {read=GetAsString, write=SetAsString};
	
__published:
	__property EditMask ;
	__property Size ;
	__property bool Transliterate = {read=FTransliterate, write=FTransliterate, default=1};
public:
	/* TField.Destroy */ __fastcall virtual ~TStringField(void) { }
	
};

class DELPHICLASS TNumericField;
class PASCALIMPLEMENTATION TNumericField : public Db::TField 
{
	typedef Db::TField inherited;
	
private:
	System::AnsiString FDisplayFormat;
	System::AnsiString FEditFormat;
	
protected:
	void __fastcall RangeError(Extended Value, Extended Min, Extended Max);
	void __fastcall SetDisplayFormat(const System::AnsiString Value);
	void __fastcall SetEditFormat(const System::AnsiString Value);
	
public:
	__fastcall virtual TNumericField(Classes::TComponent* AOwner);
	
__published:
	__property Alignment ;
	__property System::AnsiString DisplayFormat = {read=FDisplayFormat, write=SetDisplayFormat};
	__property System::AnsiString EditFormat = {read=FEditFormat, write=SetEditFormat};
public:
	/* TField.Destroy */ __fastcall virtual ~TNumericField(void) { }
	
};

class DELPHICLASS TIntegerField;
class PASCALIMPLEMENTATION TIntegerField : public Db::TNumericField 
{
	typedef Db::TNumericField inherited;
	
private:
	int FMinRange;
	int FMaxRange;
	int FMinValue;
	int FMaxValue;
	void __fastcall CheckRange(int Value, int Min, int Max);
	void __fastcall SetMaxValue(int Value);
	void __fastcall SetMinValue(int Value);
	
protected:
	virtual double __fastcall GetAsFloat(void);
	virtual int __fastcall GetAsInteger(void);
	virtual System::AnsiString __fastcall GetAsString(void);
	virtual System::Variant __fastcall GetAsVariant(void);
	virtual Word __fastcall GetDataSize(void);
	virtual void __fastcall GetText(System::AnsiString &Text, bool DisplayText);
	bool __fastcall GetValue(int &Value);
	virtual void __fastcall SetAsFloat(double Value);
	virtual void __fastcall SetAsInteger(int Value);
	virtual void __fastcall SetAsString(const System::AnsiString Value);
	virtual void __fastcall SetVarValue(const System::Variant &Value);
	
public:
	__fastcall virtual TIntegerField(Classes::TComponent* AOwner);
	__property int Value = {read=GetAsInteger, write=SetAsInteger, nodefault};
	
__published:
	__property int MaxValue = {read=FMaxValue, write=SetMaxValue, default=0};
	__property int MinValue = {read=FMinValue, write=SetMinValue, default=0};
public:
	/* TField.Destroy */ __fastcall virtual ~TIntegerField(void) { }
	
};

class DELPHICLASS TSmallintField;
class PASCALIMPLEMENTATION TSmallintField : public Db::TIntegerField 
{
	typedef Db::TIntegerField inherited;
	
protected:
	virtual Word __fastcall GetDataSize(void);
	
public:
	__fastcall virtual TSmallintField(Classes::TComponent* AOwner);
public:
	/* TField.Destroy */ __fastcall virtual ~TSmallintField(void) { }
	
};

class DELPHICLASS TWordField;
class PASCALIMPLEMENTATION TWordField : public Db::TIntegerField 
{
	typedef Db::TIntegerField inherited;
	
protected:
	virtual Word __fastcall GetDataSize(void);
	
public:
	__fastcall virtual TWordField(Classes::TComponent* AOwner);
public:
	/* TField.Destroy */ __fastcall virtual ~TWordField(void) { }
	
};

class DELPHICLASS TAutoIncField;
class PASCALIMPLEMENTATION TAutoIncField : public Db::TIntegerField 
{
	typedef Db::TIntegerField inherited;
	
public:
	__fastcall virtual TAutoIncField(Classes::TComponent* AOwner);
public:
	/* TField.Destroy */ __fastcall virtual ~TAutoIncField(void) { }
	
};

class DELPHICLASS TFloatField;
class PASCALIMPLEMENTATION TFloatField : public Db::TNumericField 
{
	typedef Db::TNumericField inherited;
	
private:
	bool FCurrency;
	bool FCheckRange;
	int FPrecision;
	double FMinValue;
	double FMaxValue;
	void __fastcall SetCurrency(bool Value);
	void __fastcall SetMaxValue(double Value);
	void __fastcall SetMinValue(double Value);
	void __fastcall SetPrecision(int Value);
	void __fastcall UpdateCheckRange(void);
	
protected:
	virtual double __fastcall GetAsFloat(void);
	virtual int __fastcall GetAsInteger(void);
	virtual System::AnsiString __fastcall GetAsString(void);
	virtual System::Variant __fastcall GetAsVariant(void);
	virtual Word __fastcall GetDataSize(void);
	virtual void __fastcall GetText(System::AnsiString &Text, bool DisplayText);
	virtual void __fastcall SetAsFloat(double Value);
	virtual void __fastcall SetAsInteger(int Value);
	virtual void __fastcall SetAsString(const System::AnsiString Value);
	virtual void __fastcall SetVarValue(const System::Variant &Value);
	
public:
	__fastcall virtual TFloatField(Classes::TComponent* AOwner);
	__property double Value = {read=GetAsFloat, write=SetAsFloat};
	
__published:
	__property bool currency = {read=FCurrency, write=SetCurrency, default=0};
	__property double MaxValue = {read=FMaxValue, write=SetMaxValue};
	__property double MinValue = {read=FMinValue, write=SetMinValue};
	__property int Precision = {read=FPrecision, write=SetPrecision, default=15};
public:
	/* TField.Destroy */ __fastcall virtual ~TFloatField(void) { }
	
};

class DELPHICLASS TCurrencyField;
class PASCALIMPLEMENTATION TCurrencyField : public Db::TFloatField 
{
	typedef Db::TFloatField inherited;
	
public:
	__fastcall virtual TCurrencyField(Classes::TComponent* AOwner);
	
__published:
	__property Currency ;
public:
	/* TField.Destroy */ __fastcall virtual ~TCurrencyField(void) { }
	
};

typedef System::AnsiString Db__02[2];

class DELPHICLASS TBooleanField;
class PASCALIMPLEMENTATION TBooleanField : public Db::TField 
{
	typedef Db::TField inherited;
	
private:
	System::AnsiString FDisplayValues;
	System::AnsiString FTextValues[2];
	void __fastcall LoadTextValues(void);
	void __fastcall SetDisplayValues(const System::AnsiString Value);
	
protected:
	virtual bool __fastcall GetAsBoolean(void);
	virtual System::AnsiString __fastcall GetAsString(void);
	virtual System::Variant __fastcall GetAsVariant(void);
	virtual Word __fastcall GetDataSize(void);
	virtual int __fastcall GetDefaultWidth(void);
	virtual void __fastcall SetAsBoolean(bool Value);
	virtual void __fastcall SetAsString(const System::AnsiString Value);
	virtual void __fastcall SetVarValue(const System::Variant &Value);
	
public:
	__fastcall virtual TBooleanField(Classes::TComponent* AOwner);
	__property bool Value = {read=GetAsBoolean, write=SetAsBoolean, nodefault};
	
__published:
	__property System::AnsiString DisplayValues = {read=FDisplayValues, write=SetDisplayValues};
public:
		
	/* TField.Destroy */ __fastcall virtual ~TBooleanField(void) { }
	
};

class DELPHICLASS TDateTimeField;
class PASCALIMPLEMENTATION TDateTimeField : public Db::TField 
{
	typedef Db::TField inherited;
	
private:
	System::AnsiString FDisplayFormat;
	bool __fastcall GetValue(System::TDateTime &Value);
	void __fastcall SetDisplayFormat(const System::AnsiString Value);
	
protected:
	virtual System::TDateTime __fastcall GetAsDateTime(void);
	virtual double __fastcall GetAsFloat(void);
	virtual System::AnsiString __fastcall GetAsString(void);
	virtual System::Variant __fastcall GetAsVariant(void);
	virtual Word __fastcall GetDataSize(void);
	virtual void __fastcall GetText(System::AnsiString &Text, bool DisplayText);
	virtual void __fastcall SetAsDateTime(System::TDateTime Value);
	virtual void __fastcall SetAsFloat(double Value);
	virtual void __fastcall SetAsString(const System::AnsiString Value);
	virtual void __fastcall SetVarValue(const System::Variant &Value);
	
public:
	__fastcall virtual TDateTimeField(Classes::TComponent* AOwner);
	__property System::TDateTime Value = {read=GetAsDateTime, write=SetAsDateTime};
	
__published:
	__property System::AnsiString DisplayFormat = {read=FDisplayFormat, write=SetDisplayFormat};
	__property EditMask ;
public:
	/* TField.Destroy */ __fastcall virtual ~TDateTimeField(void) { }
	
};

class DELPHICLASS TDateField;
class PASCALIMPLEMENTATION TDateField : public Db::TDateTimeField 
{
	typedef Db::TDateTimeField inherited;
	
protected:
	virtual Word __fastcall GetDataSize(void);
	
public:
	__fastcall virtual TDateField(Classes::TComponent* AOwner);
public:
	/* TField.Destroy */ __fastcall virtual ~TDateField(void) { }
	
};

class DELPHICLASS TTimeField;
class PASCALIMPLEMENTATION TTimeField : public Db::TDateTimeField 
{
	typedef Db::TDateTimeField inherited;
	
protected:
	virtual Word __fastcall GetDataSize(void);
	
public:
	__fastcall virtual TTimeField(Classes::TComponent* AOwner);
public:
	/* TField.Destroy */ __fastcall virtual ~TTimeField(void) { }
	
};

class DELPHICLASS TBinaryField;
class PASCALIMPLEMENTATION TBinaryField : public Db::TField 
{
	typedef Db::TField inherited;
	
protected:
	/* virtual class method */ virtual void __fastcall CheckTypeSize(int Value) { CheckTypeSize(__classid(TBinaryField)
		, Value); }
	/*         class method */ static void __fastcall CheckTypeSize(System::TMetaClass* vmt, int Value)
		;
	virtual System::AnsiString __fastcall GetAsString(void);
	virtual void __fastcall GetText(System::AnsiString &Text, bool DisplayText);
	virtual System::Variant __fastcall GetAsVariant(void);
	virtual void __fastcall SetAsString(const System::AnsiString Value);
	virtual void __fastcall SetText(const System::AnsiString Value);
	virtual void __fastcall SetVarValue(const System::Variant &Value);
	
public:
	__fastcall virtual TBinaryField(Classes::TComponent* AOwner);
	
__published:
	__property Size ;
public:
	/* TField.Destroy */ __fastcall virtual ~TBinaryField(void) { }
	
};

class DELPHICLASS TBytesField;
class PASCALIMPLEMENTATION TBytesField : public Db::TBinaryField 
{
	typedef Db::TBinaryField inherited;
	
protected:
	virtual Word __fastcall GetDataSize(void);
	
public:
	__fastcall virtual TBytesField(Classes::TComponent* AOwner);
public:
	/* TField.Destroy */ __fastcall virtual ~TBytesField(void) { }
	
};

class DELPHICLASS TVarBytesField;
class PASCALIMPLEMENTATION TVarBytesField : public Db::TBytesField 
{
	typedef Db::TBytesField inherited;
	
protected:
	virtual Word __fastcall GetDataSize(void);
	
public:
	__fastcall virtual TVarBytesField(Classes::TComponent* AOwner);
public:
	/* TField.Destroy */ __fastcall virtual ~TVarBytesField(void) { }
	
};

class DELPHICLASS TBCDField;
class PASCALIMPLEMENTATION TBCDField : public Db::TNumericField 
{
	typedef Db::TNumericField inherited;
	
private:
	bool FCurrency;
	bool FCheckRange;
	System::Currency FMinValue;
	System::Currency FMaxValue;
	int FPrecision;
	void __fastcall SetCurrency(bool Value);
	void __fastcall SetMaxValue(System::Currency Value);
	void __fastcall SetMinValue(System::Currency Value);
	void __fastcall UpdateCheckRange(void);
	
protected:
	/* virtual class method */ virtual void __fastcall CheckTypeSize(int Value) { CheckTypeSize(__classid(TBCDField)
		, Value); }
	/*         class method */ static void __fastcall CheckTypeSize(System::TMetaClass* vmt, int Value)
		;
	virtual System::Currency __fastcall GetAsCurrency(void);
	virtual double __fastcall GetAsFloat(void);
	virtual int __fastcall GetAsInteger(void);
	virtual System::AnsiString __fastcall GetAsString(void);
	virtual System::Variant __fastcall GetAsVariant(void);
	virtual Word __fastcall GetDataSize(void);
	virtual int __fastcall GetDefaultWidth(void);
	virtual void __fastcall GetText(System::AnsiString &Text, bool DisplayText);
	bool __fastcall GetValue(System::Currency &Value);
	virtual void __fastcall SetAsCurrency(System::Currency Value);
	virtual void __fastcall SetAsFloat(double Value);
	virtual void __fastcall SetAsInteger(int Value);
	virtual void __fastcall SetAsString(const System::AnsiString Value);
	virtual void __fastcall SetVarValue(const System::Variant &Value);
	
public:
	__fastcall virtual TBCDField(Classes::TComponent* AOwner);
	__property System::Currency Value = {read=GetAsCurrency, write=SetAsCurrency};
	
__published:
	__property bool currency = {read=FCurrency, write=SetCurrency, default=0};
	__property System::Currency MaxValue = {read=FMaxValue, write=SetMaxValue};
	__property System::Currency MinValue = {read=FMinValue, write=SetMinValue};
	__property Size ;
public:
	/* TField.Destroy */ __fastcall virtual ~TBCDField(void) { }
	
};

typedef TFieldType TBlobType;

class DELPHICLASS TBlobField;
class PASCALIMPLEMENTATION TBlobField : public Db::TField 
{
	typedef Db::TField inherited;
	
private:
	bool FModified;
	int FModifiedRecord;
	bool FTransliterate;
	TBlobType __fastcall GetBlobType(void);
	bool __fastcall GetModified(void);
	void __fastcall LoadFromBlob(TBlobField* Blob);
	void __fastcall LoadFromBitmap(Graphics::TBitmap* Bitmap);
	void __fastcall LoadFromStrings(Classes::TStrings* Strings);
	void __fastcall SaveToBitmap(Graphics::TBitmap* Bitmap);
	void __fastcall SaveToStrings(Classes::TStrings* Strings);
	void __fastcall SetBlobType(TBlobType Value);
	void __fastcall SetModified(bool Value);
	
protected:
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	virtual void __fastcall FreeBuffers(void);
	virtual System::AnsiString __fastcall GetAsString(void);
	virtual System::Variant __fastcall GetAsVariant(void);
	virtual int __fastcall GetBlobSize(void);
	virtual bool __fastcall GetIsNull(void);
	virtual void __fastcall GetText(System::AnsiString &Text, bool DisplayText);
	virtual void __fastcall SetAsString(const System::AnsiString Value);
	virtual void __fastcall SetText(const System::AnsiString Value);
	virtual void __fastcall SetVarValue(const System::Variant &Value);
	
public:
	__fastcall virtual TBlobField(Classes::TComponent* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Clear(void);
	/* virtual class method */ virtual bool __fastcall IsBlob() { IsBlob(__classid(TBlobField)); }
	/*         class method */ static bool __fastcall IsBlob(System::TMetaClass* vmt);
	void __fastcall LoadFromFile(const System::AnsiString FileName);
	void __fastcall LoadFromStream(Classes::TStream* Stream);
	void __fastcall SaveToFile(const System::AnsiString FileName);
	void __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall SetFieldType(TFieldType Value);
	__property int BlobSize = {read=GetBlobSize, nodefault};
	__property bool Modified = {read=GetModified, write=SetModified, nodefault};
	__property System::AnsiString Value = {read=GetAsString, write=SetAsString};
	__property bool Transliterate = {read=FTransliterate, write=FTransliterate, nodefault};
	
__published:
	__property TBlobType BlobType = {read=GetBlobType, write=SetBlobType, nodefault};
	__property Size ;
public:
	/* TField.Destroy */ __fastcall virtual ~TBlobField(void) { }
	
};

class DELPHICLASS TMemoField;
class PASCALIMPLEMENTATION TMemoField : public Db::TBlobField 
{
	typedef Db::TBlobField inherited;
	
public:
	__fastcall virtual TMemoField(Classes::TComponent* AOwner);
	
__published:
	__property Transliterate ;
public:
	/* TField.Destroy */ __fastcall virtual ~TMemoField(void) { }
	
};

class DELPHICLASS TGraphicField;
class PASCALIMPLEMENTATION TGraphicField : public Db::TBlobField 
{
	typedef Db::TBlobField inherited;
	
public:
	__fastcall virtual TGraphicField(Classes::TComponent* AOwner);
public:
	/* TField.Destroy */ __fastcall virtual ~TGraphicField(void) { }
	
};

class PASCALIMPLEMENTATION TCheckConstraint : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FImportedConstraint;
	System::AnsiString FCustomConstraint;
	System::AnsiString FErrorMessage;
	bool FFromDictionary;
	void __fastcall SetImportedConstraint(const System::AnsiString Value);
	void __fastcall SetCustomConstraint(const System::AnsiString Value);
	void __fastcall SetErrorMessage(const System::AnsiString Value);
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual System::AnsiString __fastcall GetDisplayName(void);
	
__published:
	__property System::AnsiString CustomConstraint = {read=FCustomConstraint, write=SetCustomConstraint
		};
	__property System::AnsiString ErrorMessage = {read=FErrorMessage, write=SetErrorMessage};
	__property bool FromDictionary = {read=FFromDictionary, write=FFromDictionary, nodefault};
	__property System::AnsiString ImportedConstraint = {read=FImportedConstraint, write=SetImportedConstraint
		};
public:
	/* TCollectionItem.Create */ __fastcall virtual TCheckConstraint(Classes::TCollection* Collection) : 
		Classes::TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TCheckConstraint(void) { }
	
};

typedef void *TBookmark;

typedef System::AnsiString TBookmarkStr;

typedef TBookmarkFlag *PBookmarkFlag;

enum TUpdateKind { ukModify, ukInsert, ukDelete };

struct TDateTimeRec
{
	
	union
	{
		TDateTimeAlias DateTime;
		int Time;
		int Date;
		
	};
} ;

//-- var, const, procedure ---------------------------------------------------
#define dsMaxBufferCount (int)(268435455)
#define dsMaxStringSize (Word)(8192)
#define dsEditModes (System::Set<TDataSetState, dsInactive, dsCurValue> () << dsEdit << dsInsert << dsSetKey \
	)
#define dsWriteModes (System::Set<TDataSetState, dsInactive, dsCurValue> () << dsEdit << dsInsert << dsSetKey \
	<< dsCalcFields << dsFilter << dsNewValue )
extern PACKAGE System::TMetaClass*DefaultFieldClasses[22];
extern PACKAGE void __fastcall (*RegisterFieldsProc)(System::TMetaClass* const * FieldClassess, const 
	int FieldClassess_Size);
extern PACKAGE void __fastcall DatabaseError(const System::AnsiString Message);
extern PACKAGE void __fastcall DatabaseErrorFmt(const System::AnsiString Message, const System::TVarRec 
	* Args, const int Args_Size);
extern PACKAGE void __fastcall DBError(Word Ident);
extern PACKAGE void __fastcall DBErrorFmt(Word Ident, const System::TVarRec * Args, const int Args_Size
	);
extern PACKAGE TField* __fastcall GetFieldProperty(TDataSet* DataSet, Classes::TComponent* Control, 
	const System::AnsiString FieldName);
extern PACKAGE void __fastcall DisposeMem(void *Buffer, int Size);
extern PACKAGE bool __fastcall BuffersEqual(void * Buf1, void * Buf2, int Size);
extern PACKAGE System::AnsiString __fastcall ExtractFieldName(const System::AnsiString Fields, int &
	Pos);
extern PACKAGE void __fastcall RegisterFields(System::TMetaClass* const * FieldClasses, const int FieldClasses_Size
	);

}	/* namespace Db */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Db;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Db
