// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Dialogs.pas' rev: 3.00

#ifndef DialogsHPP
#define DialogsHPP
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <CommDlg.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Dialogs
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TCommonDialog;
class PASCALIMPLEMENTATION TCommonDialog : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FCtl3D;
	void *FDefWndProc;
	Classes::THelpContext FHelpContext;
	HWND FHandle;
	void *FObjectInstance;
	char *FTemplate;
	Classes::TNotifyEvent FOnClose;
	Classes::TNotifyEvent FOnShow;
	MESSAGE void __fastcall WMDestroy(Messages::TWMNoParams &Message);
	MESSAGE void __fastcall WMInitDialog(Messages::TWMInitDialog &Message);
	MESSAGE void __fastcall WMNCDestroy(Messages::TWMNoParams &Message);
	void __fastcall MainWndProc(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall DefaultHandler(void *Message);
	DYNAMIC void __fastcall DoClose(void);
	DYNAMIC void __fastcall DoShow(void);
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	virtual bool __fastcall MessageHook(Messages::TMessage &Msg);
	virtual BOOL __fastcall TaskModalDialog(void * DialogFunc, void *DialogData);
	virtual bool __fastcall Execute(void) = 0;
	__property char * Template = {read=FTemplate, write=FTemplate};
	
public:
	__fastcall virtual TCommonDialog(Classes::TComponent* AOwner);
	__fastcall virtual ~TCommonDialog(void);
	__property HWND Handle = {read=FHandle, nodefault};
	
__published:
	__property bool Ctl3D = {read=FCtl3D, write=FCtl3D, default=1};
	__property Classes::THelpContext HelpContext = {read=FHelpContext, write=FHelpContext, default=0};
	__property Classes::TNotifyEvent OnClose = {read=FOnClose, write=FOnClose};
	__property Classes::TNotifyEvent OnShow = {read=FOnShow, write=FOnShow};
};

enum TOpenOption { ofReadOnly, ofOverwritePrompt, ofHideReadOnly, ofNoChangeDir, ofShowHelp, ofNoValidate, 
	ofAllowMultiSelect, ofExtensionDifferent, ofPathMustExist, ofFileMustExist, ofCreatePrompt, ofShareAware, 
	ofNoReadOnlyReturn, ofNoTestFileCreate, ofNoNetworkButton, ofNoLongNames, ofOldStyleDialog, ofNoDereferenceLinks 
	};

typedef Set<TOpenOption, ofReadOnly, ofNoDereferenceLinks>  TOpenOptions;

enum TFileEditStyle { fsEdit, fsComboBox };

class DELPHICLASS TOpenDialog;
class PASCALIMPLEMENTATION TOpenDialog : public Dialogs::TCommonDialog 
{
	typedef Dialogs::TCommonDialog inherited;
	
private:
	Classes::TStrings* FHistoryList;
	TOpenOptions FOptions;
	System::AnsiString FFilter;
	int FFilterIndex;
	int FCurrentFilterIndex;
	System::AnsiString FInitialDir;
	System::AnsiString FTitle;
	System::AnsiString FDefaultExt;
	System::AnsiString FFileName;
	Classes::TStrings* FFiles;
	TFileEditStyle FFileEditStyle;
	Classes::TNotifyEvent FOnSelectionChange;
	Classes::TNotifyEvent FOnFolderChange;
	Classes::TNotifyEvent FOnTypeChange;
	Forms::TCloseQueryEvent FOnCanClose;
	System::AnsiString __fastcall GetFileName(void);
	int __fastcall GetFilterIndex(void);
	void __fastcall ReadFileEditStyle(Classes::TReader* Reader);
	void __fastcall SetHistoryList(Classes::TStrings* Value);
	void __fastcall SetInitialDir(const System::AnsiString Value);
	
protected:
	bool __fastcall CanClose(tagOFNA &OpenFileName);
	DYNAMIC bool __fastcall DoCanClose(void);
	BOOL __fastcall DoExecute(void * Func);
	DYNAMIC void __fastcall DoSelectionChange(void);
	DYNAMIC void __fastcall DoFolderChange(void);
	DYNAMIC void __fastcall DoTypeChange(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	void __fastcall GetFileNames(tagOFNA &OpenFileName);
	virtual Windows::TRect __fastcall GetStaticRect(void);
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	
public:
	__fastcall virtual TOpenDialog(Classes::TComponent* AOwner);
	__fastcall virtual ~TOpenDialog(void);
	virtual bool __fastcall Execute(void);
	__property TFileEditStyle FileEditStyle = {read=FFileEditStyle, write=FFileEditStyle, nodefault};
	__property Classes::TStrings* Files = {read=FFiles};
	__property Classes::TStrings* HistoryList = {read=FHistoryList, write=SetHistoryList};
	
__published:
	__property System::AnsiString DefaultExt = {read=FDefaultExt, write=FDefaultExt};
	__property System::AnsiString FileName = {read=GetFileName, write=FFileName};
	__property System::AnsiString Filter = {read=FFilter, write=FFilter};
	__property int FilterIndex = {read=GetFilterIndex, write=FFilterIndex, default=1};
	__property System::AnsiString InitialDir = {read=FInitialDir, write=SetInitialDir};
	__property TOpenOptions Options = {read=FOptions, write=FOptions, default=4};
	__property System::AnsiString Title = {read=FTitle, write=FTitle};
	__property Forms::TCloseQueryEvent OnCanClose = {read=FOnCanClose, write=FOnCanClose};
	__property Classes::TNotifyEvent OnFolderChange = {read=FOnFolderChange, write=FOnFolderChange};
	__property Classes::TNotifyEvent OnSelectionChange = {read=FOnSelectionChange, write=FOnSelectionChange
		};
	__property Classes::TNotifyEvent OnTypeChange = {read=FOnTypeChange, write=FOnTypeChange};
};

class DELPHICLASS TSaveDialog;
class PASCALIMPLEMENTATION TSaveDialog : public Dialogs::TOpenDialog 
{
	typedef Dialogs::TOpenDialog inherited;
	
__published:
	virtual bool __fastcall Execute(void);
public:
	/* TOpenDialog.Create */ __fastcall virtual TSaveDialog(Classes::TComponent* AOwner) : Dialogs::TOpenDialog(
		AOwner) { }
	/* TOpenDialog.Destroy */ __fastcall virtual ~TSaveDialog(void) { }
	
};

enum TColorDialogOption { cdFullOpen, cdPreventFullOpen, cdShowHelp, cdSolidColor, cdAnyColor };

typedef Set<TColorDialogOption, cdFullOpen, cdAnyColor>  TColorDialogOptions;

typedef int TCustomColors[16];

class DELPHICLASS TColorDialog;
class PASCALIMPLEMENTATION TColorDialog : public Dialogs::TCommonDialog 
{
	typedef Dialogs::TCommonDialog inherited;
	
private:
	Graphics::TColor FColor;
	TColorDialogOptions FOptions;
	Classes::TStrings* FCustomColors;
	void __fastcall SetCustomColors(Classes::TStrings* Value);
	
public:
	__fastcall virtual TColorDialog(Classes::TComponent* AOwner);
	__fastcall virtual ~TColorDialog(void);
	virtual bool __fastcall Execute(void);
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=FColor, default=0};
	__property Ctl3D ;
	__property Classes::TStrings* CustomColors = {read=FCustomColors, write=SetCustomColors};
	__property TColorDialogOptions Options = {read=FOptions, write=FOptions, default=0};
};

enum TFontDialogOption { fdAnsiOnly, fdTrueTypeOnly, fdEffects, fdFixedPitchOnly, fdForceFontExist, 
	fdNoFaceSel, fdNoOEMFonts, fdNoSimulations, fdNoSizeSel, fdNoStyleSel, fdNoVectorFonts, fdShowHelp, 
	fdWysiwyg, fdLimitSize, fdScalableOnly, fdApplyButton };

typedef Set<TFontDialogOption, fdAnsiOnly, fdApplyButton>  TFontDialogOptions;

enum TFontDialogDevice { fdScreen, fdPrinter, fdBoth };

typedef void __fastcall (__closure *TFDApplyEvent)(System::TObject* Sender, HWND Wnd);

class DELPHICLASS TFontDialog;
class PASCALIMPLEMENTATION TFontDialog : public Dialogs::TCommonDialog 
{
	typedef Dialogs::TCommonDialog inherited;
	
private:
	Graphics::TFont* FFont;
	TFontDialogDevice FDevice;
	TFontDialogOptions FOptions;
	TFDApplyEvent FOnApply;
	int FMinFontSize;
	int FMaxFontSize;
	bool FFontCharsetModified;
	bool FFontColorModified;
	void __fastcall DoApply(HWND Wnd);
	void __fastcall SetFont(Graphics::TFont* Value);
	void __fastcall UpdateFromLogFont(const tagLOGFONTA &LogFont);
	
protected:
	DYNAMIC void __fastcall Apply(HWND Wnd);
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	
public:
	__fastcall virtual TFontDialog(Classes::TComponent* AOwner);
	__fastcall virtual ~TFontDialog(void);
	virtual bool __fastcall Execute(void);
	
__published:
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property TFontDialogDevice Device = {read=FDevice, write=FDevice, default=0};
	__property int MinFontSize = {read=FMinFontSize, write=FMinFontSize, nodefault};
	__property int MaxFontSize = {read=FMaxFontSize, write=FMaxFontSize, nodefault};
	__property TFontDialogOptions Options = {read=FOptions, write=FOptions, default=4};
	__property TFDApplyEvent OnApply = {read=FOnApply, write=FOnApply};
};

class DELPHICLASS TPrinterSetupDialog;
class PASCALIMPLEMENTATION TPrinterSetupDialog : public Dialogs::TCommonDialog 
{
	typedef Dialogs::TCommonDialog inherited;
	
public:
	virtual bool __fastcall Execute(void);
public:
	/* TCommonDialog.Create */ __fastcall virtual TPrinterSetupDialog(Classes::TComponent* AOwner) : Dialogs::
		TCommonDialog(AOwner) { }
	/* TCommonDialog.Destroy */ __fastcall virtual ~TPrinterSetupDialog(void) { }
	
};

enum TPrintRange { prAllPages, prSelection, prPageNums };

enum TPrintDialogOption { poPrintToFile, poPageNums, poSelection, poWarning, poHelp, poDisablePrintToFile 
	};

typedef Set<TPrintDialogOption, poPrintToFile, poDisablePrintToFile>  TPrintDialogOptions;

class DELPHICLASS TPrintDialog;
class PASCALIMPLEMENTATION TPrintDialog : public Dialogs::TCommonDialog 
{
	typedef Dialogs::TCommonDialog inherited;
	
private:
	int FFromPage;
	int FToPage;
	bool FCollate;
	TPrintDialogOptions FOptions;
	bool FPrintToFile;
	TPrintRange FPrintRange;
	int FMinPage;
	int FMaxPage;
	int FCopies;
	void __fastcall SetNumCopies(int Value);
	
public:
	virtual bool __fastcall Execute(void);
	
__published:
	__property bool Collate = {read=FCollate, write=FCollate, default=0};
	__property int Copies = {read=FCopies, write=SetNumCopies, default=0};
	__property int FromPage = {read=FFromPage, write=FFromPage, default=0};
	__property int MinPage = {read=FMinPage, write=FMinPage, default=0};
	__property int MaxPage = {read=FMaxPage, write=FMaxPage, default=0};
	__property TPrintDialogOptions Options = {read=FOptions, write=FOptions, default=0};
	__property bool PrintToFile = {read=FPrintToFile, write=FPrintToFile, default=0};
	__property TPrintRange PrintRange = {read=FPrintRange, write=FPrintRange, default=0};
	__property int ToPage = {read=FToPage, write=FToPage, default=0};
public:
	/* TCommonDialog.Create */ __fastcall virtual TPrintDialog(Classes::TComponent* AOwner) : Dialogs::
		TCommonDialog(AOwner) { }
	/* TCommonDialog.Destroy */ __fastcall virtual ~TPrintDialog(void) { }
	
};

enum TFindOption { frDown, frFindNext, frHideMatchCase, frHideWholeWord, frHideUpDown, frMatchCase, 
	frDisableMatchCase, frDisableUpDown, frDisableWholeWord, frReplace, frReplaceAll, frWholeWord, frShowHelp 
	};

typedef Set<TFindOption, frDown, frShowHelp>  TFindOptions;

typedef HWND __stdcall (*TFindReplaceFunc)(tagFINDREPLACEA &FindReplace);

class DELPHICLASS TFindDialog;
class PASCALIMPLEMENTATION TFindDialog : public Dialogs::TCommonDialog 
{
	typedef Dialogs::TCommonDialog inherited;
	
private:
	TFindOptions FOptions;
	tagPOINT FPosition;
	TFindReplaceFunc FFindReplaceFunc;
	Controls::TWinControl* FRedirector;
	Classes::TNotifyEvent FOnFind;
	Classes::TNotifyEvent FOnReplace;
	HWND FFindHandle;
	tagFINDREPLACEA FFindReplace;
	char FFindText[256];
	char FReplaceText[256];
	System::AnsiString __fastcall GetFindText(void);
	int __fastcall GetLeft(void);
	tagPOINT __fastcall GetPosition(void);
	System::AnsiString __fastcall GetReplaceText(void);
	int __fastcall GetTop(void);
	void __fastcall SetFindText(const System::AnsiString Value);
	void __fastcall SetLeft(int Value);
	void __fastcall SetPosition(const tagPOINT &Value);
	void __fastcall SetReplaceText(const System::AnsiString Value);
	void __fastcall SetTop(int Value);
	__property System::AnsiString ReplaceText = {read=GetReplaceText, write=SetReplaceText};
	__property Classes::TNotifyEvent OnReplace = {read=FOnReplace, write=FOnReplace};
	
protected:
	virtual bool __fastcall MessageHook(Messages::TMessage &Msg);
	DYNAMIC void __fastcall Find(void);
	DYNAMIC void __fastcall Replace(void);
	
public:
	__fastcall virtual TFindDialog(Classes::TComponent* AOwner);
	__fastcall virtual ~TFindDialog(void);
	void __fastcall CloseDialog(void);
	virtual bool __fastcall Execute(void);
	__property int Left = {read=GetLeft, write=SetLeft, nodefault};
	__property tagPOINT Position = {read=GetPosition, write=SetPosition};
	__property int Top = {read=GetTop, write=SetTop, nodefault};
	
__published:
	__property System::AnsiString FindText = {read=GetFindText, write=SetFindText};
	__property TFindOptions Options = {read=FOptions, write=FOptions, default=1};
	__property Classes::TNotifyEvent OnFind = {read=FOnFind, write=FOnFind};
};

class DELPHICLASS TReplaceDialog;
class PASCALIMPLEMENTATION TReplaceDialog : public Dialogs::TFindDialog 
{
	typedef Dialogs::TFindDialog inherited;
	
public:
	__fastcall virtual TReplaceDialog(Classes::TComponent* AOwner);
	
__published:
	__property ReplaceText ;
	__property OnReplace ;
public:
	/* TFindDialog.Destroy */ __fastcall virtual ~TReplaceDialog(void) { }
	
};

enum TMsgDlgType { mtWarning, mtError, mtInformation, mtConfirmation, mtCustom };

enum TMsgDlgBtn { mbYes, mbNo, mbOK, mbCancel, mbAbort, mbRetry, mbIgnore, mbAll, mbNoToAll, mbYesToAll, 
	mbHelp };

typedef Set<TMsgDlgBtn, mbYes, mbHelp>  TMsgDlgButtons;

//-- var, const, procedure ---------------------------------------------------
#define MaxCustomColors (Byte)(16)
#define mbYesNoCancel (System::Set<TMsgDlgBtn, mbYes, mbHelp> () << mbYes << mbNo << mbCancel )
#define mbOKCancel (System::Set<TMsgDlgBtn, mbYes, mbHelp> () << mbOK << mbCancel )
#define mbAbortRetryIgnore (System::Set<TMsgDlgBtn, mbYes, mbHelp> () << mbAbort << mbRetry << mbIgnore \
	)
extern PACKAGE Forms::TForm* __fastcall CreateMessageDialog(const System::AnsiString Msg, TMsgDlgType 
	DlgType, TMsgDlgButtons Buttons);
extern PACKAGE int __fastcall MessageDlg(const System::AnsiString Msg, TMsgDlgType DlgType, TMsgDlgButtons 
	Buttons, int HelpCtx);
extern PACKAGE int __fastcall MessageDlgPos(const System::AnsiString Msg, TMsgDlgType DlgType, TMsgDlgButtons 
	Buttons, int HelpCtx, int X, int Y);
extern PACKAGE int __fastcall MessageDlgPosHelp(const System::AnsiString Msg, TMsgDlgType DlgType, TMsgDlgButtons 
	Buttons, int HelpCtx, int X, int Y, const System::AnsiString HelpFileName);
extern PACKAGE void __fastcall ShowMessage(const System::AnsiString Msg);
extern PACKAGE void __fastcall ShowMessageFmt(const System::AnsiString Msg, const System::TVarRec * 
	Params, const int Params_Size);
extern PACKAGE void __fastcall ShowMessagePos(const System::AnsiString Msg, int X, int Y);
extern PACKAGE bool __fastcall InputQuery(const System::AnsiString ACaption, const System::AnsiString 
	APrompt, System::AnsiString &Value);
extern PACKAGE System::AnsiString __fastcall InputBox(const System::AnsiString ACaption, const System::AnsiString 
	APrompt, const System::AnsiString ADefault);

}	/* namespace Dialogs */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Dialogs;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Dialogs
