// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'EditIntf.pas' rev: 3.00

#ifndef EditIntfHPP
#define EditIntfHPP
#include <VirtIntf.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Editintf
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 1)
struct TEditPos
{
	short Col;
	int Line;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TCharPos
{
	short CharIndex;
	int Line;
} ;
#pragma pack(pop)

class DELPHICLASS TIEditReader;
class PASCALIMPLEMENTATION TIEditReader : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual int __stdcall GetText(int Position, char * Buffer, int Count) = 0;
public:
	/* TInterface.Create */ __fastcall TIEditReader(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIEditReader(void) { }
	
};

class DELPHICLASS TIEditWriter;
class PASCALIMPLEMENTATION TIEditWriter : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual bool __stdcall CopyTo(int Pos) = 0;
	virtual bool __stdcall DeleteTo(int Pos) = 0;
	virtual bool __stdcall Insert(char * Text) = 0;
	virtual int __stdcall Position(void) = 0;
	virtual TCharPos __stdcall GetCurrentPos(void) = 0;
	__property TCharPos CurrentPos = {read=GetCurrentPos};
public:
	/* TInterface.Create */ __fastcall TIEditWriter(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIEditWriter(void) { }
	
};

class DELPHICLASS TIEditView;
class PASCALIMPLEMENTATION TIEditView : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual TEditPos __stdcall GetPos(int Index) = 0;
	virtual void __stdcall SetPos(int Index, const TEditPos Value) = 0;
	virtual tagSIZE __stdcall GetViewSize(void) = 0;
	virtual TCharPos __stdcall PosToCharPos(int Pos) = 0;
	virtual int __stdcall CharPosToPos(const TCharPos CharPos) = 0;
	virtual void __stdcall ConvertPos(bool EdPosToCharPos, TEditPos &EditPos, TCharPos &CharPos) = 0;
	virtual void __stdcall GetAttributeAtPos(const TEditPos &EdPos, int &Element, int &LineFlag) = 0;
	__property TEditPos CursorPos = {read=GetPos, write=SetPos, index=0};
	__property TEditPos TopPos = {read=GetPos, write=SetPos, index=1};
	__property tagSIZE ViewSize = {read=GetViewSize};
public:
	/* TInterface.Create */ __fastcall TIEditView(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIEditView(void) { }
	
};

enum TSyntaxHighlighter { shNone, shPascal, shC, shSQL, shQuery };

enum TBlockType { btInclusive, btLine, btColumn, btNonInclusive, btUnknown };

class DELPHICLASS TIEditorInterface;
class PASCALIMPLEMENTATION TIEditorInterface : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual TIEditReader* __stdcall CreateReader(void) = 0;
	virtual TIEditWriter* __stdcall CreateWriter(void) = 0;
	virtual System::AnsiString __stdcall FileName(void) = 0;
	virtual int __stdcall LinesInBuffer(void) = 0;
	virtual bool __stdcall BufferModified(void) = 0;
	virtual bool __stdcall MarkModified(void) = 0;
	virtual TSyntaxHighlighter __stdcall SetSyntaxHighlighter(TSyntaxHighlighter SyntaxHighlighter) = 0
		;
	virtual int __stdcall GetViewCount(void) = 0;
	virtual TIEditView* __stdcall GetView(int Index) = 0;
	virtual TIEditWriter* __stdcall CreateUndoableWriter(void) = 0;
	virtual TCharPos __stdcall GetBlockAfter(void) = 0;
	virtual TCharPos __stdcall GetBlockStart(void) = 0;
	virtual TBlockType __stdcall GetBlockType(void) = 0;
	virtual bool __stdcall GetBlockVisible(void) = 0;
	virtual void __stdcall SetBlockAfter(const TCharPos Value) = 0;
	virtual void __stdcall SetBlockStart(const TCharPos Value) = 0;
	virtual void __stdcall SetBlockType(TBlockType Value) = 0;
	virtual void __stdcall SetBlockVisible(bool Value) = 0;
	__property TCharPos BlockStart = {read=GetBlockStart, write=SetBlockStart};
	__property TCharPos BlockAfter = {read=GetBlockAfter, write=SetBlockAfter};
	__property TBlockType BlockType = {read=GetBlockType, write=SetBlockType, nodefault};
	__property bool BlockVisible = {read=GetBlockVisible, write=SetBlockVisible, nodefault};
public:
	/* TInterface.Create */ __fastcall TIEditorInterface(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIEditorInterface(void) { }
	
};

enum TPropertyType { ptUnknown, ptInteger, ptChar, ptEnumeration, ptFloat, ptString, ptSet, ptClass, 
	ptMethod, ptWChar, ptLString, ptLWString, ptVariant };

class DELPHICLASS TIComponentInterface;
typedef bool __stdcall (*TGetChildCallback)(void * Param, TIComponentInterface* ComponentInterface);
	

class PASCALIMPLEMENTATION TIComponentInterface : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual System::AnsiString __stdcall GetComponentType(void) = 0;
	virtual void * __stdcall GetComponentHandle(void) = 0;
	virtual TIComponentInterface* __stdcall GetParent(void) = 0;
	virtual bool __stdcall IsTControl(void) = 0;
	virtual int __stdcall GetPropCount(void) = 0;
	virtual System::AnsiString __stdcall GetPropName(int Index) = 0;
	virtual TPropertyType __stdcall GetPropType(int Index) = 0;
	virtual TPropertyType __stdcall GetPropTypeByName(const System::AnsiString Name) = 0;
	virtual bool __stdcall GetPropValue(int Index, void *Value) = 0;
	virtual bool __stdcall GetPropValueByName(const System::AnsiString Name, void *Value) = 0;
	virtual bool __stdcall SetProp(int Index, const void *Value) = 0;
	virtual bool __stdcall SetPropByName(const System::AnsiString Name, const void *Value) = 0;
	virtual bool __stdcall GetChildren(void * Param, TGetChildCallback Proc) = 0;
	virtual int __stdcall GetControlCount(void) = 0;
	virtual TIComponentInterface* __stdcall GetControl(int Index) = 0;
	virtual int __stdcall GetComponentCount(void) = 0;
	virtual TIComponentInterface* __stdcall GetComponent(int Index) = 0;
	virtual bool __stdcall Select(void) = 0;
	virtual bool __stdcall Focus(void) = 0;
	virtual bool __stdcall Delete(void) = 0;
public:
	/* TInterface.Create */ __fastcall TIComponentInterface(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIComponentInterface(void) { }
	
};

class DELPHICLASS TIFormInterface;
class PASCALIMPLEMENTATION TIFormInterface : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual System::AnsiString __stdcall FileName(void) = 0;
	virtual bool __stdcall FormModified(void) = 0;
	virtual bool __stdcall MarkModified(void) = 0;
	virtual TIComponentInterface* __stdcall GetFormComponent(void) = 0;
	virtual TIComponentInterface* __stdcall FindComponent(const System::AnsiString Name) = 0;
	virtual TIComponentInterface* __stdcall GetComponentFromHandle(void * ComponentHandle) = 0;
	virtual int __stdcall GetSelCount(void) = 0;
	virtual TIComponentInterface* __stdcall GetSelComponent(int Index) = 0;
	virtual TIComponentInterface* __stdcall GetCreateParent(void) = 0;
	virtual TIComponentInterface* __stdcall CreateComponent(TIComponentInterface* Container, const System::AnsiString 
		TypeName, int X, int Y, int W, int H) = 0;
public:
	/* TInterface.Create */ __fastcall TIFormInterface(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIFormInterface(void) { }
	
};

enum TResHeaderValue { hvFlags, hvLanguage, hvDataVersion, hvVersion, hvCharacteristics };

class DELPHICLASS TIResourceEntry;
class PASCALIMPLEMENTATION TIResourceEntry : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual char * __stdcall GetResourceType(void) = 0;
	virtual char * __stdcall GetResourceName(void) = 0;
	virtual bool __stdcall Change(char * NewType, char * NewName) = 0;
	virtual bool __stdcall GetHeaderValue(TResHeaderValue HeaderValue, int &Value) = 0;
	virtual bool __stdcall SetHeaderValue(TResHeaderValue HeaderValue, int Value) = 0;
	virtual void * __stdcall GetData(void) = 0;
	virtual int __stdcall GetDataSize(void) = 0;
	virtual bool __stdcall SetDataSize(int NewSize) = 0;
	virtual void * __stdcall GetEntryHandle(void) = 0;
public:
	/* TInterface.Create */ __fastcall TIResourceEntry(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIResourceEntry(void) { }
	
};

class DELPHICLASS TIResourceFile;
class PASCALIMPLEMENTATION TIResourceFile : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual System::AnsiString __stdcall FileName(void) = 0;
	virtual int __stdcall GetEntryCount(void) = 0;
	virtual TIResourceEntry* __stdcall GetEntry(int Index) = 0;
	virtual TIResourceEntry* __stdcall GetEntryFromHandle(void * EntryHandle) = 0;
	virtual TIResourceEntry* __stdcall FindEntry(char * ResType, char * Name) = 0;
	virtual bool __stdcall DeleteEntry(void * EntryHandle) = 0;
	virtual TIResourceEntry* __stdcall CreateEntry(char * ResType, char * Name, Word Flags, Word LanguageId
		, int DataVersion, int Version, int Characteristics) = 0;
public:
	/* TInterface.Create */ __fastcall TIResourceFile(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIResourceFile(void) { }
	
};

enum TNotifyCode { ncModuleDeleted, ncModuleRenamed, ncEditorModified, ncFormModified, ncEditorSelected, 
	ncFormSelected, ncBeforeSave, ncAfterSave, ncFormSaving, ncProjResModified };

class DELPHICLASS TIModuleNotifier;
class PASCALIMPLEMENTATION TIModuleNotifier : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual void __stdcall Notify(TNotifyCode NotifyCode) = 0;
	virtual void __stdcall ComponentRenamed(void * ComponentHandle, const System::AnsiString OldName, const 
		System::AnsiString NewName) = 0;
public:
	/* TInterface.Create */ __fastcall TIModuleNotifier(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIModuleNotifier(void) { }
	
};

class DELPHICLASS TIModuleInterface;
class PASCALIMPLEMENTATION TIModuleInterface : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual TIEditorInterface* __stdcall GetEditorInterface(void) = 0;
	virtual TIFormInterface* __stdcall GetFormInterface(void) = 0;
	virtual TIModuleInterface* __stdcall GetAncestorModule(void) = 0;
	virtual TIResourceFile* __stdcall GetProjectResource(void) = 0;
	virtual bool __stdcall IsProjectModule(void) = 0;
	virtual bool __stdcall Close(void) = 0;
	virtual bool __stdcall Save(bool ForceSave) = 0;
	virtual bool __stdcall Rename(const System::AnsiString NewName) = 0;
	virtual bool __stdcall GetFileSystem(System::AnsiString &FileSystem) = 0;
	virtual bool __stdcall SetFileSystem(const System::AnsiString FileSystem) = 0;
	virtual bool __stdcall ShowSource(void) = 0;
	virtual bool __stdcall ShowForm(void) = 0;
	virtual bool __stdcall AddNotifier(TIModuleNotifier* AModuleNotifier) = 0;
	virtual bool __stdcall RemoveNotifier(TIModuleNotifier* AModuleNotifier) = 0;
	virtual TIEditorInterface* __stdcall GetAuxEditorInterface(void) = 0;
public:
	/* TInterface.Create */ __fastcall TIModuleInterface(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIModuleInterface(void) { }
	
};

class DELPHICLASS TIProjectCreator;
class PASCALIMPLEMENTATION TIProjectCreator : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual bool __stdcall Existing(void) = 0;
	virtual System::AnsiString __stdcall GetFileName(void) = 0;
	virtual System::AnsiString __stdcall GetFileSystem(void) = 0;
	virtual System::AnsiString __stdcall NewProjectSource(const System::AnsiString ProjectName) = 0;
	virtual void __stdcall NewDefaultModule(void) = 0;
	virtual void __stdcall NewProjectResource(TIModuleInterface* Module) = 0;
public:
	/* TInterface.Create */ __fastcall TIProjectCreator(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIProjectCreator(void) { }
	
};

class DELPHICLASS TIProjectCreatorEx;
class PASCALIMPLEMENTATION TIProjectCreatorEx : public Editintf::TIProjectCreator 
{
	typedef Editintf::TIProjectCreator inherited;
	
public:
	virtual System::AnsiString __stdcall GetOptionName(void) = 0;
	virtual System::AnsiString __stdcall NewOptionSource(const System::AnsiString ProjectName) = 0;
public:
		
	/* TInterface.Create */ __fastcall TIProjectCreatorEx(void) : Editintf::TIProjectCreator() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIProjectCreatorEx(void) { }
	
};

class DELPHICLASS TIModuleCreator;
class PASCALIMPLEMENTATION TIModuleCreator : public Virtintf::TInterface 
{
	typedef Virtintf::TInterface inherited;
	
public:
	virtual bool __stdcall Existing(void) = 0;
	virtual System::AnsiString __stdcall GetAncestorName(void) = 0;
	virtual System::AnsiString __stdcall GetFileName(void) = 0;
	virtual System::AnsiString __stdcall GetFileSystem(void) = 0;
	virtual System::AnsiString __stdcall GetFormName(void) = 0;
	virtual System::AnsiString __stdcall NewModuleSource(const System::AnsiString UnitIdent, const System::AnsiString 
		FormIdent, const System::AnsiString AncestorIdent) = 0;
	virtual void __stdcall FormCreated(TIFormInterface* Form) = 0;
public:
	/* TInterface.Create */ __fastcall TIModuleCreator(void) : Virtintf::TInterface() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIModuleCreator(void) { }
	
};

class DELPHICLASS TIModuleCreatorEx;
class PASCALIMPLEMENTATION TIModuleCreatorEx : public Editintf::TIModuleCreator 
{
	typedef Editintf::TIModuleCreator inherited;
	
public:
	virtual System::AnsiString __stdcall GetIntfName(void) = 0;
	virtual System::AnsiString __stdcall NewIntfSource(const System::AnsiString UnitIdent, const System::AnsiString 
		FormIdent, const System::AnsiString AncestorIdent) = 0;
public:
	/* TInterface.Create */ __fastcall TIModuleCreatorEx(void) : Editintf::TIModuleCreator() { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TIModuleCreatorEx(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define cursorPos (int)(0)
#define ViewTopPos (int)(1)
#define atWhiteSpace (Byte)(0)
#define atComment (Byte)(1)
#define atReservedWord (Byte)(2)
#define atIdentifier (Byte)(3)
#define atSymbol (Byte)(4)
#define atString (Byte)(5)
#define atNumber (Byte)(6)
#define atFloat (Byte)(7)
#define atOctal (Byte)(8)
#define atHex (Byte)(9)
#define atCharacter (Byte)(10)
#define atPreproc (Byte)(11)
#define atIllegal (Byte)(12)
#define atAssembler (Byte)(13)
#define SyntaxOff (Byte)(14)
#define MarkedBlock (Byte)(15)
#define SearchMatch (Byte)(16)
#define lfCurrentCSIP (Byte)(1)
#define lfBreakpointEnabled (Byte)(2)
#define lfBreakpointDisabled (Byte)(4)
#define lfBreakpointInvalid (Byte)(8)
#define lfErrorLine (Byte)(16)
#define lfBreakpointVerified (Byte)(32)

}	/* namespace Editintf */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Editintf;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// EditIntf
