/* This file is included specially and does not have a normal header guard */
#pragma option push -b -a4 -Vx- -Ve- -w-inl -w-aus -w-sig
#ifndef __STD_EXCEPTION

/***************************************************************************
 *
 * exception - declarations for the Standard Library exception class
 *
 * $Id: exception,v 1.23 1996/08/28 01:28:39 smithey Exp $
 *
 ***************************************************************************
 *
 * (c) Copyright 1994, 1995 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 *
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 **************************************************************************/

#include <stdcomp.h>

#ifndef __EXCEPT_H
#  include <except.h>
#endif

#include "rw/stddefs.h"

#ifndef __RWSTD_EXCEPTION_SEEN

#ifndef _RWSTD_EXCEPTION_HANDLER_IN_STD

typedef void (*terminate_handler) ();
extern terminate_handler set_terminate(terminate_handler f) _RWSTD_THROW_SPEC_NULL;
extern void terminate( );

typedef void (*unexpected_handler) ();
extern unexpected_handler set_unexpected( unexpected_handler f)  _RWSTD_THROW_SPEC_NULL;
extern void unexpected();

#endif /* _RWSTD_EXCEPTION_HANDLER_IN_STD */

#ifndef _RWSTD_NO_NAMESPACE
namespace __rwstd {
#endif

extern const char _RWSTDExportFunc(*) __rw_stdexcept_NoNamedException;
extern const char _RWSTDExportFunc(*) __rw_stdexcept_BadException;

#ifndef _RWSTD_NO_NAMESPACE 
}
#endif

#ifndef _RWSTD_NO_NAMESPACE 
namespace std {
#endif

//
// Temporarily turn off the warnings under the Borland compiler that
// say 'Functions containing ... cannot be inlined'
//
#if defined(__BORLANDC__)
#pragma option -w-inl
#endif

#ifdef _RWSTD_EXCEPTION_DEFINED
// MSVC < 4.2  has its own (non-standard) exception class.  We need to use it
// in order to allow the use of MSVC typeinfo exception classes 
// derived from it.
#if defined(_MSC_VER) 
#ifndef _RWSTD_NO_NAMESPACE 
}
#endif
#if _MSC_VER < 1011
#include <exception.h>
#else
// MSVC 4.2
// Here we must use their standard exception class since they've already 
// compiled it into their libraries
//
#include _RWSTD_MS42_HEADER(exception) 
#endif /*  _MSC_VER < 1011 */
#ifndef _RWSTD_NO_NAMESPACE 
namespace std {
#endif
#else
#include <stdexcept.h>
#endif /* _MSC_VER */

#else
class _RWSTDExport exception     
{ 
  public:
    exception () _RWSTD_THROW_SPEC_NULL
    { ; }
    exception (const exception&) _RWSTD_THROW_SPEC_NULL 
    { ; }
    exception& operator= (const exception&)  _RWSTD_THROW_SPEC_NULL
    { return *this; }
    virtual ~exception ()  _RWSTD_THROW_SPEC_NULL
#ifndef HPPA_WA
    { ; }  
#else
    ;
#endif
    virtual const char * what () const  _RWSTD_THROW_SPEC_NULL
    {
        return  __RWSTD::__rw_stdexcept_NoNamedException;
    }
};

#endif /* _RWSTD_EXCEPTION_DEFINED */

#if !defined(_RWSTD_BAD_EXCEPTION_DEFINED)
class _RWSTDExport bad_exception : public exception     
{ 
  public:
    bad_exception () _RWSTD_THROW_SPEC_NULL : exception( )
    { ; }
    bad_exception(const bad_exception&) _RWSTD_THROW_SPEC_NULL
    { ; }
    bad_exception& operator=(const bad_exception&) _RWSTD_THROW_SPEC_NULL
    { return *this; }
    virtual ~bad_exception ()  _RWSTD_THROW_SPEC_NULL
#ifndef HPPA_WA
    { ; }  
#else
    ;
#endif
 
    virtual const char * what () const  _RWSTD_THROW_SPEC_NULL
    {
        return __RWSTD::__rw_stdexcept_BadException;
    }
};
#endif  /* _RWSTD_BAD_EXCEPTION_DEFINED */

#define __RWSTD_EXCEPTION_SEEN

#ifndef _RWSTD_NO_NAMESPACE 
} 
#endif

//
// Yes, the exception hierarchy has been seen!
//
#endif /*__RWSTD_EXCEPTION_SEEN*/

//
// Yes, the complete file has been processed!
//
#define __STD_EXCEPTION

#endif /*__STD_EXCEPTION */

#pragma option pop
