// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'FileCtrl.pas' rev: 3.00

#ifndef FileCtrlHPP
#define FileCtrlHPP
#include <Buttons.hpp>
#include <StdCtrls.hpp>
#include <Menus.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Filectrl
{
//-- type declarations -------------------------------------------------------
enum TFileAttr { ftReadOnly, ftHidden, ftSystem, ftVolumeID, ftDirectory, ftArchive, ftNormal };

typedef Set<TFileAttr, ftReadOnly, ftNormal>  TFileType;

enum TDriveType { dtUnknown, dtNoDrive, dtFloppy, dtFixed, dtNetwork, dtCDROM, dtRAM };

class DELPHICLASS TFileListBox;
class DELPHICLASS TDirectoryListBox;
class DELPHICLASS TDriveComboBox;
enum TTextCase { tcLowerCase, tcUpperCase };

class PASCALIMPLEMENTATION TDriveComboBox : public Stdctrls::TCustomComboBox 
{
	typedef Stdctrls::TCustomComboBox inherited;
	
private:
	TDirectoryListBox* FDirList;
	char FDrive;
	TTextCase FTextCase;
	void __fastcall SetDirListBox(TDirectoryListBox* Value);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Message);
	void __fastcall SetDrive(char NewDrive);
	void __fastcall SetTextCase(TTextCase NewTextCase);
	void __fastcall ReadBitmaps(void);
	void __fastcall ResetItemHeight(void);
	
protected:
	Graphics::TBitmap* FloppyBMP;
	Graphics::TBitmap* FixedBMP;
	Graphics::TBitmap* NetworkBMP;
	Graphics::TBitmap* CDROMBMP;
	Graphics::TBitmap* RAMBMP;
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall DrawItem(int Index, const Windows::TRect &Rect, Stdctrls::TOwnerDrawState State
		);
	DYNAMIC void __fastcall Click(void);
	virtual void __fastcall BuildList(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TDriveComboBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TDriveComboBox(void);
	__property Text ;
	__property char Drive = {read=FDrive, write=SetDrive, nodefault};
	
__published:
	__property Color ;
	__property Ctl3D ;
	__property TDirectoryListBox* DirList = {read=FDirList, write=SetDirListBox};
	__property DragMode ;
	__property DragCursor ;
	__property Enabled ;
	__property Font ;
	__property ImeMode ;
	__property ImeName ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property TTextCase TextCase = {read=FTextCase, write=SetTextCase, default=0};
	__property Visible ;
	__property OnChange ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnDropDown ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnStartDrag ;
public:
	/* TWinControl.CreateParented */ __fastcall TDriveComboBox(HWND ParentWindow) : Stdctrls::TCustomComboBox(
		ParentWindow) { }
	
};

class PASCALIMPLEMENTATION TDirectoryListBox : public Stdctrls::TCustomListBox 
{
	typedef Stdctrls::TCustomListBox inherited;
	
private:
	TFileListBox* FFileList;
	TDriveComboBox* FDriveCombo;
	Stdctrls::TLabel* FDirLabel;
	bool FInSetDir;
	bool FPreserveCase;
	bool FCaseSensitive;
	char __fastcall GetDrive(void);
	void __fastcall SetFileListBox(TFileListBox* Value);
	void __fastcall SetDirLabel(Stdctrls::TLabel* Value);
	void __fastcall SetDirLabelCaption(void);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Message);
	void __fastcall SetDrive(char Value);
	void __fastcall DriveChange(char NewDrive);
	void __fastcall SetDir(const System::AnsiString NewDirectory);
	virtual void __fastcall SetDirectory(const System::AnsiString NewDirectory);
	void __fastcall ResetItemHeight(void);
	
protected:
	Graphics::TBitmap* ClosedBMP;
	Graphics::TBitmap* OpenedBMP;
	Graphics::TBitmap* CurrentBMP;
	System::AnsiString FDirectory;
	Classes::TNotifyEvent FOnChange;
	virtual void __fastcall Change(void);
	DYNAMIC void __fastcall DblClick(void);
	virtual void __fastcall ReadBitmaps(void);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall DrawItem(int Index, const Windows::TRect &Rect, Stdctrls::TOwnerDrawState State
		);
	int __fastcall ReadDirectoryNames(const System::AnsiString ParentDirectory, Classes::TStringList* DirectoryList
		);
	virtual void __fastcall BuildList(void);
	DYNAMIC void __fastcall KeyPress(char &Key);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TDirectoryListBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TDirectoryListBox(void);
	System::AnsiString __fastcall DisplayCase(const System::AnsiString S);
	int __fastcall FileCompareText(const System::AnsiString A, const System::AnsiString B);
	System::AnsiString __fastcall GetItemPath(int Index);
	void __fastcall OpenCurrent(void);
	HIDESBASE void __fastcall Update(void);
	__property char Drive = {read=GetDrive, write=SetDrive, nodefault};
	__property System::AnsiString Directory = {read=FDirectory, write=SetDirectory};
	__property bool PreserveCase = {read=FPreserveCase, nodefault};
	__property bool CaseSensitive = {read=FCaseSensitive, nodefault};
	
__published:
	__property Align ;
	__property Color ;
	__property Columns ;
	__property Ctl3D ;
	__property Stdctrls::TLabel* DirLabel = {read=FDirLabel, write=SetDirLabel};
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property TFileListBox* FileList = {read=FFileList, write=SetFileListBox};
	__property Font ;
	__property ImeMode ;
	__property ImeName ;
	__property IntegralHeight ;
	__property ItemHeight ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
public:
	/* TWinControl.CreateParented */ __fastcall TDirectoryListBox(HWND ParentWindow) : Stdctrls::TCustomListBox(
		ParentWindow) { }
	
};

class DELPHICLASS TFilterComboBox;
class PASCALIMPLEMENTATION TFilterComboBox : public Stdctrls::TCustomComboBox 
{
	typedef Stdctrls::TCustomComboBox inherited;
	
private:
	System::AnsiString FFilter;
	TFileListBox* FFileList;
	Classes::TStringList* MaskList;
	bool __fastcall IsFilterStored(void);
	System::AnsiString __fastcall GetMask(void);
	void __fastcall SetFilter(const System::AnsiString NewFilter);
	void __fastcall SetFileListBox(TFileListBox* Value);
	
protected:
	DYNAMIC void __fastcall Change(void);
	virtual void __fastcall CreateWnd(void);
	DYNAMIC void __fastcall Click(void);
	void __fastcall BuildList(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TFilterComboBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TFilterComboBox(void);
	__property System::AnsiString Mask = {read=GetMask};
	__property Text ;
	
__published:
	__property Color ;
	__property Ctl3D ;
	__property DragMode ;
	__property DragCursor ;
	__property Enabled ;
	__property TFileListBox* FileList = {read=FFileList, write=SetFileListBox};
	__property System::AnsiString Filter = {read=FFilter, write=SetFilter, stored=IsFilterStored};
	__property Font ;
	__property ImeName ;
	__property ImeMode ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnChange ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnDropDown ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnStartDrag ;
public:
	/* TWinControl.CreateParented */ __fastcall TFilterComboBox(HWND ParentWindow) : Stdctrls::TCustomComboBox(
		ParentWindow) { }
	
};

class PASCALIMPLEMENTATION TFileListBox : public Stdctrls::TCustomListBox 
{
	typedef Stdctrls::TCustomListBox inherited;
	
private:
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Message);
	char __fastcall GetDrive(void);
	System::AnsiString __fastcall GetFileName(void);
	bool __fastcall IsMaskStored(void);
	void __fastcall SetDrive(char Value);
	void __fastcall SetFileEdit(Stdctrls::TEdit* Value);
	void __fastcall SetDirectory(const System::AnsiString NewDirectory);
	void __fastcall SetFileType(TFileType NewFileType);
	void __fastcall SetMask(const System::AnsiString NewMask);
	void __fastcall SetFileName(const System::AnsiString NewFile);
	void __fastcall SetShowGlyphs(bool Value);
	void __fastcall ResetItemHeight(void);
	
protected:
	System::AnsiString FDirectory;
	System::AnsiString FMask;
	TFileType FFileType;
	Stdctrls::TEdit* FFileEdit;
	TDirectoryListBox* FDirList;
	TFilterComboBox* FFilterCombo;
	Graphics::TBitmap* ExeBMP;
	Graphics::TBitmap* DirBMP;
	Graphics::TBitmap* UnknownBMP;
	Classes::TNotifyEvent FOnChange;
	int FLastSel;
	bool FShowGlyphs;
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall ReadBitmaps(void);
	DYNAMIC void __fastcall Click(void);
	virtual void __fastcall Change(void);
	virtual void __fastcall ReadFileNames(void);
	virtual void __fastcall DrawItem(int Index, const Windows::TRect &Rect, Stdctrls::TOwnerDrawState State
		);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual System::AnsiString __fastcall GetFilePath(void);
	
public:
	__fastcall virtual TFileListBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TFileListBox(void);
	HIDESBASE void __fastcall Update(void);
	virtual void __fastcall ApplyFilePath(const System::AnsiString EditText);
	__property char Drive = {read=GetDrive, write=SetDrive, nodefault};
	__property System::AnsiString Directory = {read=FDirectory, write=ApplyFilePath};
	__property System::AnsiString FileName = {read=GetFilePath, write=ApplyFilePath};
	
__published:
	__property Align ;
	__property Color ;
	__property Ctl3D ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property ExtendedSelect ;
	__property Stdctrls::TEdit* FileEdit = {read=FFileEdit, write=SetFileEdit};
	__property TFileType FileType = {read=FFileType, write=SetFileType, default=64};
	__property Font ;
	__property ImeMode ;
	__property ImeName ;
	__property IntegralHeight ;
	__property ItemHeight ;
	__property System::AnsiString Mask = {read=FMask, write=SetMask, stored=IsMaskStored};
	__property MultiSelect ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property bool ShowGlyphs = {read=FShowGlyphs, write=SetShowGlyphs, default=0};
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
public:
	/* TWinControl.CreateParented */ __fastcall TFileListBox(HWND ParentWindow) : Stdctrls::TCustomListBox(
		ParentWindow) { }
	
};

enum TSelectDirOpt { sdAllowCreate, sdPerformCreate, sdPrompt };

typedef Set<TSelectDirOpt, sdAllowCreate, sdPrompt>  TSelectDirOpts;

//-- var, const, procedure ---------------------------------------------------
#define WNTYPE_DRIVE (Byte)(1)
extern PACKAGE System::AnsiString __fastcall MinimizeName(const System::AnsiString Filename, Graphics::TCanvas* 
	Canvas, int MaxLen);
extern PACKAGE void __fastcall ProcessPath(const System::AnsiString EditText, char &Drive, System::AnsiString 
	&DirPart, System::AnsiString &FilePart);
extern PACKAGE bool __fastcall SelectDirectory(System::AnsiString &Directory, TSelectDirOpts Options
	, int HelpCtx);
extern PACKAGE bool __fastcall DirectoryExists(const System::AnsiString Name);
extern PACKAGE void __fastcall ForceDirectories(System::AnsiString Dir);

}	/* namespace Filectrl */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Filectrl;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// FileCtrl
