#ifndef __LOCIMPL_CC
#define __LOCIMPL_CC
#pragma option push -b -a4 -Vx- -Ve- -w-inl -w-aus -w-sig

/***************************************************************************
 *
 * rw/locimpl.cc - Template definitions for the Standard Library locale
 *                 private implementation classes.
 *
 * $Id: locimpl.cc,v 1.17 1996/10/02 01:48:00 smithey Exp $
 *
 ***************************************************************************
 *
 * (c) Copyright 1994, 1995 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 **************************************************************************/

#ifndef _RWSTD_NO_NAMESPACE
namespace __rwstd {
#endif

// -------------------------------------------
// Template digit_map<charT> member templates.
// -------------------------------------------

template <class charT>
void 
digit_map<charT>::init (const ctype<charT> &ct)
{
  ct.widen(punct_chars,punct_chars+sizeof punct_chars,punct_array);
  ct.widen(digit_chars,digit_chars+sizeof digit_chars,digit_array);
  memcpy(value_array,char_values,sizeof value_array);
  inited=true;
}

template <class charT>
const digit_map<charT>&
digit_map<charT>::get_digit_map (const ctype<charT>& ct)
{
  if (!ct.digit_map_.inited)
    (_RWSTD_CONST_CAST(digit_map<char_type>&,ct.digit_map_))
        .init(ct);
  return ct.digit_map_;
}

template <class charT>
int digit_map<charT>::eval (charT c) const {
  const charT *end=digit_array+sizeof value_array;
  for (const charT *p=digit_array; p<end; p++)
    if (*p==c)
      return value_array[p-digit_array];
  return -1;
}


#ifndef _RWSTD_NO_NAMESPACE
} // namespace __rwstd
#endif

#pragma option pop
#endif /* __LOCIMPL_CC */
