#ifndef __STD_NEW
#define __STD_NEW
#define _INC_NEW  /* MSC guard name */
#define __NEW_H   /* Old Borland guard name */
#pragma option push -b -a4 -Vx- -Ve- -w-inl -w-aus -w-sig

/***************************************************************************
 *
 * new - declarations for the Standard Library new header
 *
 * $Id: new,v 1.13 1996/08/28 01:29:35 smithey Exp $
 *
 ***************************************************************************
 *
 * (c) Copyright 1994, 1995 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 **************************************************************************/

#include <stdcomp.h>
#include "rw/stddefs.h"
#ifndef _RWSTD_HEADER_REQUIRES_HPP
#include <exception>
#else
#include <exception.hpp>
#endif

typedef void (*new_handler) ();

#if !defined(_MSC_VER) || defined(__BORLANDC__)
extern new_handler set_new_handler( new_handler new_p );
#endif

#ifndef _RWSTD_NO_NAMESPACE 
namespace __rwstd {
#endif

extern const char _RWSTDExportFunc(*) __rw_stdexcept_BadAllocException;

#ifndef _RWSTD_NO_NAMESPACE 
}
namespace std {
#endif

#if !defined(_RWSTD_BAD_ALLOC_DEFINED)
class _RWSTDExport bad_alloc : public exception     
{ 
  public:
    bad_alloc () _RWSTD_THROW_SPEC_NULL : exception( )
    { ; }
    bad_alloc(const bad_alloc&) _RWSTD_THROW_SPEC_NULL
    { ; }
    bad_alloc& operator=(const bad_alloc&) _RWSTD_THROW_SPEC_NULL
    { return *this; }
    virtual ~bad_alloc ()  _RWSTD_THROW_SPEC_NULL
#ifdef HPPA_WA
;
#else
{;}
#endif

    virtual const char * what () const  _RWSTD_THROW_SPEC_NULL
    {
        return __RWSTD::__rw_stdexcept_BadAllocException;
    }
};
#endif /*_RWSTD_BAD_ALLOC_DEFINED */

struct nothrow {};

#ifndef _RWSTD_NO_NAMESPACE 
} 
#endif

#ifndef _RWSTD_NO_NEW_BRACKETS
#ifndef _RWSTD_NO_THROW_SPEC_ON_NEW
extern void *operator new(size_t, void*)  _RWSTD_THROW_SPEC_NULL;
inline void* operator new[] ( size_t, void* ptr)  _RWSTD_THROW_SPEC_NULL
 { return ptr; }
#else
extern void *operator new(size_t, void*);
inline void* operator new[] ( size_t, void* ptr)  
 { return ptr; }
#endif // _RWSTD_NO_THROW_SPEC_ON_NEW
#else
#if defined(_MSC_VER) && !defined(__BORLANDC__)
#include <new.h>
extern void *operator new(size_t, void* ptr);
#else
#ifndef _RWSTD_NO_THROW_SPEC_ON_NEW
static inline  void *operator new(size_t, void* ptr) _RWSTD_THROW_SPEC_NULL
 { return ptr; }
#else
static inline  void *operator new(size_t, void* ptr)
 { return ptr; }
#endif // _RWSTD_NO_THROW_SPEC_ON_NEW
#endif // _MSC_VER
#endif // _RWSTD_NO_NEW_BRACKETS

#pragma option pop
#endif /*__STD_NEW */
