// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'quickrpt.pas' rev: 3.00

#ifndef quickrptHPP
#define quickrptHPP
#include <qrexpbld.hpp>
#include <QRPrgres.hpp>
#include <qr2const.hpp>
#include <qrprntr.hpp>
#include <DBTables.hpp>
#include <Db.hpp>
#include <Printers.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Forms.hpp>
#include <DsgnIntf.hpp>
#include <Buttons.hpp>
#include <Graphics.hpp>
#include <SysUtils.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Quickrpt
{
//-- type declarations -------------------------------------------------------
typedef System::TMetaClass*TQRNewComponentClass;

typedef void __fastcall (__closure *TQROnNeedDataEvent)(System::TObject* Sender, bool &MoreData);

enum TQRNotifyOperation { qrMasterDataAdvance, qrBandPrinted, qrBandSizeChange };

typedef void __fastcall (__closure *TQRNotifyOperationEvent)(System::TObject* Sender, TQRNotifyOperation 
	Operation);

class DELPHICLASS TQRController;
class DELPHICLASS TQRCustomBand;
class DELPHICLASS TQRBasePanel;
class DELPHICLASS TQRFrame;
class PASCALIMPLEMENTATION TQRFrame : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TColor FColor;
	bool FBottom;
	bool FLeft;
	Controls::TControl* FParent;
	TPenStyle FPenStyle;
	bool FRight;
	bool FTop;
	int FWidth;
	void __fastcall SetColor(Graphics::TColor Value);
	void __fastcall SetParent(Controls::TControl* Value);
	void __fastcall SetStyle(Graphics::TPenStyle Value);
	void __fastcall SetValue(int index, bool Value);
	void __fastcall SetWidth(int Value);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	void __fastcall PaintIt(Graphics::TCanvas* ACanvas, const Windows::TRect &Rect, Extended XFact, Extended 
		YFact);
	void __fastcall SetPen(Graphics::TPen* aPen);
	virtual void __fastcall ReadMode(Classes::TReader* Reader);
	virtual void __fastcall WriteDummy(Classes::TWriter* Writer);
	
public:
	__fastcall TQRFrame(void);
	bool __fastcall AnyFrame(void);
	__property Controls::TControl* Parent = {read=FParent, write=SetParent};
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, nodefault};
	__property bool DrawTop = {read=FTop, write=SetValue, index=0, nodefault};
	__property bool DrawBottom = {read=FBottom, write=SetValue, index=1, nodefault};
	__property bool DrawLeft = {read=FLeft, write=SetValue, index=2, nodefault};
	__property bool DrawRight = {read=FRight, write=SetValue, index=3, nodefault};
	__property Graphics::TPenStyle Style = {read=FPenStyle, write=SetStyle, default=0};
	__property int Width = {read=FWidth, write=SetWidth, default=1};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TQRFrame(void) { }
	
};

enum TQRUnit { MM, Inches, Pixels, Characters, Native };

class PASCALIMPLEMENTATION TQRBasePanel : public Extctrls::TCustomPanel 
{
	typedef Extctrls::TCustomPanel inherited;
	
private:
	int FFontSize;
	int FZoom;
	TQRFrame* FFrame;
	TQRFrame* __fastcall GetFrame(void);
	void __fastcall SetFrame(TQRFrame* Value);
	
protected:
	virtual void __fastcall SetZoom(int Value);
	virtual void __fastcall Paint(void);
	virtual void __fastcall PaintRuler(TQRUnit Units);
	void __fastcall PrepareComponents(void);
	void __fastcall UnprepareComponents(void);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	
public:
	__fastcall virtual TQRBasePanel(Classes::TComponent* AOwner);
	__fastcall virtual ~TQRBasePanel(void);
	__property int Zoom = {read=FZoom, write=SetZoom, nodefault};
	__property int FontSize = {read=FFontSize, write=FFontSize, nodefault};
	
__published:
	__property TQRFrame* Frame = {read=GetFrame, write=SetFrame};
public:
	/* TWinControl.CreateParented */ __fastcall TQRBasePanel(HWND ParentWindow) : Extctrls::TCustomPanel(
		ParentWindow) { }
	
};

typedef void __fastcall (__closure *TQRBandAfterPrintEvent)(TQRCustomBand* Sender, bool BandPrinted)
	;

typedef void __fastcall (__closure *TQRBandBeforePrintEvent)(TQRCustomBand* Sender, bool &PrintBand)
	;

class DELPHICLASS TQuickRep;
class DELPHICLASS TQRCreateReportThread;
class PASCALIMPLEMENTATION TQRCreateReportThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	Qrprntr::TQRPrinter* FQRPrinter;
	TQuickRep* FQuickRep;
	
public:
	__fastcall TQRCreateReportThread(TQuickRep* AReport);
	virtual void __fastcall Execute(void);
	__property TQuickRep* QuickRep = {read=FQuickRep, write=FQuickRep};
public:
	/* TThread.Destroy */ __fastcall virtual ~TQRCreateReportThread(void) { }
	
};

class DELPHICLASS TQuickRepBands;
class PASCALIMPLEMENTATION TQuickRepBands : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TQuickRep* FOwner;
	TQRCustomBand* __fastcall BandInList(Qrprntr::TQRBandType BandType);
	void __fastcall SetBand(Qrprntr::TQRBandType BandType, bool Value);
	TQRCustomBand* __fastcall GetBand(int Index);
	bool __fastcall GetHasBand(int Index);
	void __fastcall SetHasBand(int Index, bool Value);
	
public:
	__fastcall TQuickRepBands(TQuickRep* AOwner);
	__property TQRCustomBand* TitleBand = {read=GetBand, index=1};
	__property TQRCustomBand* PageHeaderBand = {read=GetBand, index=2};
	__property TQRCustomBand* ColumnHeaderBand = {read=GetBand, index=3};
	__property TQRCustomBand* DetailBand = {read=GetBand, index=4};
	__property TQRCustomBand* ColumnFooterBand = {read=GetBand, index=5};
	__property TQRCustomBand* PageFooterBand = {read=GetBand, index=6};
	__property TQRCustomBand* SummaryBand = {read=GetBand, index=7};
	
__published:
	__property bool HasTitle = {read=GetHasBand, write=SetHasBand, stored=false, index=1, nodefault};
	__property bool HasPageHeader = {read=GetHasBand, write=SetHasBand, stored=false, index=2, nodefault
		};
	__property bool HasColumnHeader = {read=GetHasBand, write=SetHasBand, stored=false, index=3, nodefault
		};
	__property bool HasDetail = {read=GetHasBand, write=SetHasBand, stored=false, index=4, nodefault};
	__property bool HasPageFooter = {read=GetHasBand, write=SetHasBand, stored=false, index=6, nodefault
		};
	__property bool HasSummary = {read=GetHasBand, write=SetHasBand, stored=false, index=7, nodefault};
		
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TQuickRepBands(void) { }
	
};

typedef void __fastcall (__closure *TQRReportBeforePrintEvent)(TQuickRep* Sender, bool &PrintReport)
	;

class DELPHICLASS TQRDesigner;
class DELPHICLASS TControlHandle;
typedef Shortint THandlePosition;

enum THandleOperation { hoCreate, hoParent, hoDestroy, hoMove, hoShow, hoHide };

class PASCALIMPLEMENTATION TQRDesigner : public Controls::TControl 
{
	typedef Controls::TControl inherited;
	
private:
	Controls::TControl* FEditControl;
	bool FEditing;
	bool FIsAdding;
	Classes::TNotifyEvent FOnSelectComponent;
	TQuickRep* FReport;
	bool FSizing;
	TControlHandle* Handles[8];
	Windows::TRect MoveRect;
	System::TMetaClass*NewComponentClass;
	THandlePosition SizePosition;
	int SizeStartX;
	int SizeStartY;
	void __fastcall DrawControlHandles(Controls::TControl* Control, bool Visible);
	void __fastcall HandleOperation(THandleOperation Operation);
	void __fastcall SetOnSelectComponent(Classes::TNotifyEvent Value);
	void __fastcall UpdateHandlePositions(Controls::TControl* Control);
	
protected:
	Windows::TRect __fastcall ReleaseFocusFrame(void);
	void __fastcall MoveFocusFrame(const Windows::TRect &Rect);
	virtual void __fastcall SetEditControl(Controls::TControl* AControl);
	void __fastcall SizeBegin(int X, int Y, THandlePosition aPosition);
	void __fastcall SizeTo(int X, int Y);
	void __fastcall SizeEnd(int X, int Y);
	
public:
	__fastcall virtual TQRDesigner(Classes::TComponent* AOwner);
	__fastcall virtual ~TQRDesigner(void);
	void __fastcall AddComponent(System::TMetaClass* aNewComponentType);
	void __fastcall AddIt(Controls::TWinControl* aParent, int X, int Y);
	void __fastcall Edit(TQuickRep* AReport);
	void __fastcall GetHandles(void);
	void __fastcall SetFocusFrame(void);
	void __fastcall StopEdit(void);
	__property Controls::TControl* EditControl = {read=FEditControl, write=SetEditControl};
	__property bool Editing = {read=FEditing, write=FEditing, nodefault};
	__property bool IsAdding = {read=FIsAdding, nodefault};
	__property Classes::TNotifyEvent OnSelectComponent = {read=FOnSelectComponent, write=SetOnSelectComponent
		};
	__property bool Sizing = {read=FSizing, write=FSizing, nodefault};
};

typedef void __fastcall (__closure *TQRNotifyEvent)(TQuickRep* Sender);

enum TQuickReportOption { FirstPageHeader, LastPageFooter, Compression };

typedef Set<TQuickReportOption, FirstPageHeader, Compression>  TQuickReportOptions;

class DELPHICLASS TQRPage;
class DELPHICLASS TQRUnitBase;
class PASCALIMPLEMENTATION TQRUnitBase : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FResolution;
	TQRUnit FUnits;
	TQRUnit SavedUnits;
	TQuickRep* FParentReport;
	bool FParentUpdating;
	int FZoom;
	virtual Extended __fastcall LoadUnit(Extended Value, TQRUnit aUnit, bool Horizontal);
	virtual Extended __fastcall SaveUnit(Extended Value, TQRUnit aUnit, bool Horizontal);
	
protected:
	virtual TQRUnit __fastcall GetUnits(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall ReadValues(Classes::TReader* Reader);
	virtual void __fastcall SetParentSizes(void);
	virtual void __fastcall SetUnits(TQRUnit Value);
	virtual void __fastcall WriteValues(Classes::TWriter* Writer);
	void __fastcall SetPixels(void);
	void __fastcall RestoreUnit(void);
	
public:
	__fastcall TQRUnitBase(void);
	__property TQuickRep* ParentReport = {read=FParentReport, write=FParentReport};
	__property bool ParentUpdating = {read=FParentUpdating, write=FParentUpdating, nodefault};
	__property int Resolution = {read=FResolution, nodefault};
	__property TQRUnit Units = {read=GetUnits, write=SetUnits, nodefault};
	__property int Zoom = {read=FZoom, write=FZoom, nodefault};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TQRUnitBase(void) { }
	
};

class PASCALIMPLEMENTATION TQRPage : public Quickrpt::TQRUnitBase 
{
	typedef Quickrpt::TQRUnitBase inherited;
	
private:
	Extended FBottomMargin;
	Extended FColumnSpace;
	int FColumns;
	Extended FLeftMargin;
	Extended FLength;
	TPrinterOrientation FOrientation;
	TQRPaperSize FPaperSize;
	Extended FRightMargin;
	bool FRuler;
	Extended FTopMargin;
	Extended FWidth;
	TQuickRep* Parent;
	Qrprntr::TQRPaperSize __fastcall GetPaperSize(void);
	bool __fastcall GetRuler(void);
	Extended __fastcall GetValue(int Index);
	void __fastcall SetColumns(int Value);
	void __fastcall SetOrientation(Printers::TPrinterOrientation Value);
	void __fastcall SetPaperSize(Qrprntr::TQRPaperSize Value);
	void __fastcall SetRuler(bool Value);
	void __fastcall SetValue(int Index, Extended Value);
	
protected:
	virtual void __fastcall ReadValues(Classes::TReader* Reader);
	virtual void __fastcall SetParentSizes(void);
	virtual void __fastcall SetUnits(TQRUnit Value);
	virtual void __fastcall WriteValues(Classes::TWriter* Writer);
	void __fastcall FixZoom(void);
	
public:
	__fastcall TQRPage(TQuickRep* AParent);
	
__published:
	__property Extended BottomMargin = {read=GetValue, write=SetValue, stored=false, index=0};
	__property Extended ColumnSpace = {read=GetValue, write=SetValue, stored=false, index=6};
	__property int Columns = {read=FColumns, write=SetColumns, nodefault};
	__property Extended LeftMargin = {read=GetValue, write=SetValue, stored=false, index=4};
	__property Extended Length = {read=GetValue, write=SetValue, stored=false, index=1};
	__property Printers::TPrinterOrientation Orientation = {read=FOrientation, write=SetOrientation, nodefault
		};
	__property Qrprntr::TQRPaperSize PaperSize = {read=GetPaperSize, write=SetPaperSize, nodefault};
	__property Extended RightMargin = {read=GetValue, write=SetValue, stored=false, index=5};
	__property bool Ruler = {read=GetRuler, write=SetRuler, default=1};
	__property Extended TopMargin = {read=GetValue, write=SetValue, stored=false, index=2};
	__property Extended Width = {read=GetValue, write=SetValue, stored=false, index=3};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TQRPage(void) { }
	
};

class DELPHICLASS TQuickRepPrinterSettings;
class PASCALIMPLEMENTATION TQuickRepPrinterSettings : public Qrprntr::TQRPrinterSettings 
{
	typedef Qrprntr::TQRPrinterSettings inherited;
	
__published:
	__property Copies ;
	__property Duplex ;
	__property FirstPage ;
	__property LastPage ;
	__property OutputBin ;
public:
	/* TQRPrinterSettings.Create */ __fastcall TQuickRepPrinterSettings(void) : Qrprntr::TQRPrinterSettings(
		) { }
	
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TQuickRepPrinterSettings(void) { }
	
};

enum TQRState { qrAvailable, qrPrepare, qrPreview, qrPrint, qrEdit };

class DELPHICLASS TQRBand;
class DELPHICLASS TQRPrintable;
class PASCALIMPLEMENTATION TQuickRep : public Quickrpt::TQRBasePanel 
{
	typedef Quickrpt::TQRBasePanel inherited;
	
private:
	TQRCreateReportThread* BGThread;
	TQRController* aController;
	Classes::TList* BandRegList;
	Qrprntr::TQRAfterPrintEvent FAfterPrintEvent;
	Qrprntr::TQRAfterPreviewEvent FAfterPreviewEvent;
	Classes::TList* FAllDataSets;
	bool FAvailable;
	Classes::TList* FBandList;
	TQuickRepBands* FBands;
	TQRReportBeforePrintEvent FBeforePrintEvent;
	int FColumnTopPosition;
	int FCurrentColumn;
	int FCurrentX;
	int FCurrentY;
	Classes::TStrings* FDescription;
	TQRDesigner* FDesigner;
	Qrprntr::TQRExportFilter* FExportFilter;
	bool FExporting;
	bool FFinalPass;
	bool FHideBands;
	bool FLastPage;
	TQRNotifyEvent FOnEndPageEvent;
	TQROnNeedDataEvent FOnNeedDataEvent;
	Classes::TNotifyEvent FOnPreviewEvent;
	TQRNotifyEvent FOnStartPageEvent;
	TQuickReportOptions FOptions;
	TQRPage* FPage;
	int FPageCount;
	Extended FPageFooterSize;
	TQuickRepPrinterSettings* FPrinterSettings;
	System::AnsiString FReportTitle;
	int FRotateBands;
	bool FShowProgress;
	bool FSnapToGrid;
	TQRState FState;
	Qrprntr::TQRPrinter* FQRPrinter;
	bool NewColumnForced;
	bool NewPageForced;
	int ReferenceDC;
	TQRUnit __fastcall GetUnits(void);
	Db::TDataSet* __fastcall GetDataSet(void);
	bool __fastcall GetPrintIfEmpty(void);
	int __fastcall GetRecordCount(void);
	int __fastcall GetRecordNumber(void);
	void __fastcall PrintBand(TQRCustomBand* ABand);
	void __fastcall PrintPageBackground(void);
	void __fastcall SetExportFilter(Qrprntr::TQRExportFilter* Value);
	void __fastcall SetUnits(TQRUnit Value);
	void __fastcall SetDataSet(Db::TDataSet* Value);
	void __fastcall SetDescription(Classes::TStrings* Value);
	void __fastcall SetPrintIfEmpty(bool Value);
	void __fastcall SetPrinterValues(void);
	
protected:
	int __fastcall AvailableSpace(void);
	bool __fastcall PrepareQRPrinter(void);
	void __fastcall CreateReport(bool CompositeReport);
	void __fastcall ForceNewColumn(void);
	void __fastcall ForceNewPage(void);
	DYNAMIC void __fastcall GetChildren(Classes::TGetChildProc Proc, Classes::TComponent* Root);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual void __fastcall PaintColumns(void);
	virtual void __fastcall PaintMargins(void);
	virtual void __fastcall PaintFrame(void);
	virtual void __fastcall PaintRuler(TQRUnit Units);
	void __fastcall PreviewFinished(System::TObject* Sender);
	void __fastcall PrintFinished(System::TObject* Sender);
	void __fastcall RebuildBandList(void);
	void __fastcall RegisterBand(TQRCustomBand* aBand);
	void __fastcall SetHideBands(bool Value);
	void __fastcall SetRotateBands(int Value);
	virtual void __fastcall SetZoom(int Value);
	
public:
	__fastcall virtual TQuickRep(Classes::TComponent* AOwner);
	__fastcall TQuickRep(Classes::TComponent* AOwner, int Dummy);
	__fastcall virtual ~TQuickRep(void);
	TQRBand* __fastcall CreateBand(Qrprntr::TQRBandType BandType);
	int __fastcall TextHeight(Graphics::TFont* aFont, System::AnsiString aText);
	int __fastcall TextWidth(Graphics::TFont* aFont, System::AnsiString aText);
	void __fastcall AddBand(TQRCustomBand* aBand);
	void __fastcall AddNotifyClient(TQRPrintable* Value);
	void __fastcall Edit(TQRDesigner* ADesigner);
	void __fastcall ExportToFilter(Qrprntr::TQRExportFilter* AFilter);
	void __fastcall EndPage(void);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	void __fastcall NewColumn(void);
	void __fastcall NewPage(void);
	virtual void __fastcall Paint(void);
	void __fastcall Print(void);
	void __fastcall PrintBackground(void);
	void __fastcall PrinterSetup(void);
	void __fastcall Prepare(void);
	void __fastcall Preview(void);
	void __fastcall ResetPageFooterSize(void);
	void __fastcall RemoveBand(TQRCustomBand* aBand);
	void __fastcall SetBandValues(void);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	__property Classes::TList* AllDataSets = {read=FAllDataSets, write=FAllDataSets};
	__property bool Available = {read=FAvailable, nodefault};
	__property Classes::TList* BandList = {read=FBandList};
	__property int ColumnTopPosition = {read=FColumnTopPosition, write=FColumnTopPosition, nodefault};
	__property int CurrentColumn = {read=FCurrentColumn, nodefault};
	__property int CurrentX = {read=FCurrentX, write=FCurrentX, nodefault};
	__property int CurrentY = {read=FCurrentY, write=FCurrentY, nodefault};
	__property TQRDesigner* Designer = {read=FDesigner};
	__property Qrprntr::TQRExportFilter* ExportFilter = {read=FExportFilter, write=SetExportFilter};
	__property bool Exporting = {read=FExporting, nodefault};
	__property bool FinalPass = {read=FFinalPass, nodefault};
	__property bool HideBands = {read=FHideBands, write=SetHideBands, nodefault};
	__property int PageNumber = {read=FPageCount, nodefault};
	__property Qrprntr::TQRPrinter* Printer = {read=FQRPrinter};
	__property Qrprntr::TQRPrinter* QRPrinter = {read=FQRPrinter, write=FQRPrinter};
	__property int RecordCount = {read=GetRecordCount, nodefault};
	__property int RecordNumber = {read=GetRecordNumber, nodefault};
	__property int RotateBands = {read=FRotateBands, write=SetRotateBands, nodefault};
	__property TQRState State = {read=FState, write=FState, nodefault};
	
__published:
	__property Qrprntr::TQRAfterPrintEvent AfterPrint = {read=FAfterPrintEvent, write=FAfterPrintEvent}
		;
	__property Qrprntr::TQRAfterPreviewEvent AfterPreview = {read=FAfterPreviewEvent, write=FAfterPreviewEvent
		};
	__property TQuickRepBands* Bands = {read=FBands, write=FBands};
	__property TQRReportBeforePrintEvent BeforePrint = {read=FBeforePrintEvent, write=FBeforePrintEvent
		};
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property Classes::TStrings* Description = {read=FDescription, write=SetDescription};
	__property Font ;
	__property TQRNotifyEvent OnEndPage = {read=FOnEndPageEvent, write=FOnEndPageEvent};
	__property TQROnNeedDataEvent OnNeedData = {read=FOnNeedDataEvent, write=FOnNeedDataEvent};
	__property Classes::TNotifyEvent OnPreview = {read=FOnPreviewEvent, write=FOnPreviewEvent};
	__property TQRNotifyEvent OnStartPage = {read=FOnStartPageEvent, write=FOnStartPageEvent};
	__property TQuickReportOptions Options = {read=FOptions, write=FOptions, nodefault};
	__property TQRPage* Page = {read=FPage, write=FPage};
	__property bool PrintIfEmpty = {read=GetPrintIfEmpty, write=SetPrintIfEmpty, nodefault};
	__property TQuickRepPrinterSettings* PrinterSettings = {read=FPrinterSettings, write=FPrinterSettings
		};
	__property System::AnsiString ReportTitle = {read=FReportTitle, write=FReportTitle};
	__property bool ShowProgress = {read=FShowProgress, write=FShowProgress, default=1};
	__property bool SnapToGrid = {read=FSnapToGrid, write=FSnapToGrid, nodefault};
	__property TQRUnit Units = {read=GetUnits, write=SetUnits, stored=true, nodefault};
	__property Zoom ;
public:
	/* TWinControl.CreateParented */ __fastcall TQuickRep(HWND ParentWindow) : Quickrpt::TQRBasePanel(ParentWindow
		) { }
	
};

class DELPHICLASS TQRBandSize;
class PASCALIMPLEMENTATION TQRBandSize : public Quickrpt::TQRUnitBase 
{
	typedef Quickrpt::TQRUnitBase inherited;
	
private:
	Extended FWidth;
	Extended FLength;
	TQRCustomBand* Parent;
	Extended __fastcall GetValue(int Index);
	void __fastcall SetValue(int Index, Extended Value);
	
protected:
	virtual void __fastcall ReadValues(Classes::TReader* Reader);
	virtual void __fastcall SetParentSizes(void);
	virtual void __fastcall WriteValues(Classes::TWriter* Writer);
	void __fastcall FixZoom(void);
	
public:
	__fastcall TQRBandSize(TQRCustomBand* AParent);
	__property Extended Length = {read=GetValue, write=SetValue, stored=false, index=0};
	
__published:
	__property Extended Height = {read=GetValue, write=SetValue, stored=false, index=0};
	__property Extended Width = {read=GetValue, write=SetValue, stored=false, index=1};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TQRBandSize(void) { }
	
};

class DELPHICLASS TQRChildBand;
class PASCALIMPLEMENTATION TQRCustomBand : public Quickrpt::TQRBasePanel 
{
	typedef Quickrpt::TQRBasePanel inherited;
	
private:
	Windows::TRect BandFrameRect;
	bool ButtonDown;
	int FExpanded;
	int LastX;
	int LastY;
	Windows::TRect MoveRect;
	TQRBandAfterPrintEvent FAfterPrintEvent;
	bool FAlignToBottom;
	TQRBandBeforePrintEvent FBeforePrintEvent;
	bool FEnabled;
	bool FForceNewColumn;
	bool FForceNewPage;
	TQRCustomBand* FLinkBand;
	TQuickRep* FParentReport;
	bool FParentUpdating;
	TQRBandType FQRBandType;
	int LoadedHeight;
	TQRBandSize* FSize;
	void __fastcall SetLinkBand(TQRCustomBand* Value);
	TQRBandSize* __fastcall GetBandSize(void);
	bool __fastcall GetHasChild(void);
	TQRChildBand* __fastcall GetChild(void);
	void __fastcall SetBandType(Qrprntr::TQRBandType Value);
	void __fastcall SetHasChild(bool Value);
	
protected:
	TQRUnit __fastcall GetUnits(void);
	int __fastcall StretchHeight(bool IncludeNext);
	void __fastcall AdvancePaper(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall Loaded(void);
	void __fastcall MakeSpace(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual void __fastcall Paint(void);
	virtual void __fastcall PaintRuler(TQRUnit Units);
	void __fastcall Print(void);
	virtual void __fastcall ReadAlign(Classes::TReader* Reader);
	virtual void __fastcall ReadRuler(Classes::TReader* Reader);
	virtual void __fastcall ReadLinkband(Classes::TReader* Reader);
	void __fastcall ReleaseFocusFrame(void);
	virtual void __fastcall SetParent(Controls::TWinControl* AParent);
	void __fastcall SetBandSize(TQRBandSize* Value);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	void __fastcall SetUnits(TQRUnit Value);
	virtual void __fastcall SetZoom(int Value);
	virtual void __fastcall WriteDummy(Classes::TWriter* Writer);
	__property int Expanded = {read=FExpanded, write=FExpanded, nodefault};
	__property bool ParentUpdating = {read=FParentUpdating, write=FParentUpdating, nodefault};
	__property TQRUnit Units = {read=GetUnits, write=SetUnits, nodefault};
	
public:
	__fastcall virtual TQRCustomBand(Classes::TComponent* AOwner);
	__fastcall virtual ~TQRCustomBand(void);
	TQRPrintable* __fastcall AddPrintable(System::TMetaClass* PrintableClass);
	bool __fastcall CanExpand(Extended Value);
	bool __fastcall ExpandBand(Extended Value, Extended &NewTop, Extended &OfsX);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	__property Qrprntr::TQRBandType BandType = {read=FQRBandType, write=SetBandType, nodefault};
	__property TQRChildBand* ChildBand = {read=GetChild};
	__property TQuickRep* ParentReport = {read=FParentReport, write=FParentReport};
	__property TQRCustomBand* LinkBand = {read=FLinkBand, write=SetLinkBand};
	
__published:
	__property TQRBandAfterPrintEvent AfterPrint = {read=FAfterPrintEvent, write=FAfterPrintEvent};
	__property bool AlignToBottom = {read=FAlignToBottom, write=FAlignToBottom, nodefault};
	__property TQRBandBeforePrintEvent BeforePrint = {read=FBeforePrintEvent, write=FBeforePrintEvent};
		
	__property Color ;
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=1};
	__property Font ;
	__property bool ForceNewColumn = {read=FForceNewColumn, write=FForceNewColumn, nodefault};
	__property bool ForceNewPage = {read=FForceNewPage, write=FForceNewPage, nodefault};
	__property bool HasChild = {read=GetHasChild, write=SetHasChild, stored=false, nodefault};
	__property ParentFont ;
	__property TQRBandSize* Size = {read=GetBandSize, write=SetBandSize};
public:
	/* TWinControl.CreateParented */ __fastcall TQRCustomBand(HWND ParentWindow) : Quickrpt::TQRBasePanel(
		ParentWindow) { }
	
};

class PASCALIMPLEMENTATION TQRController : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TComponent* FMaster;
	Db::TDataSet* FDataSet;
	TQRCustomBand* FDetail;
	TQRCustomBand* FFooter;
	TQRCustomBand* FHeader;
	TQROnNeedDataEvent FOnNeedDataEvent;
	int FDetailNumber;
	TQuickRep* FParentReport;
	bool FPrintBefore;
	bool FPrintIfEmpty;
	Classes::TComponent* FSelfCheck;
	Classes::TList* GroupList;
	Classes::TList* NotifyList;
	Classes::TList* PrintAfterList;
	Classes::TList* PrintBeforeList;
	void __fastcall SetMaster(Classes::TComponent* Value);
	bool __fastcall CheckGroups(void);
	void __fastcall CheckLastGroupFooters(void);
	void __fastcall PrintGroupHeaders(void);
	void __fastcall PrintGroupFooters(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	void __fastcall NotifyClients(TQRNotifyOperation Operation);
	void __fastcall SetDataSet(Db::TDataSet* Value);
	
protected:
	virtual void __fastcall SetPrintBefore(bool Value);
	void __fastcall AddAfter(TQRController* aController);
	void __fastcall RegisterBands(void);
	void __fastcall AddBefore(TQRController* aController);
	void __fastcall BuildTree(void);
	void __fastcall Execute(void);
	void __fastcall Prepare(void);
	
public:
	__fastcall virtual TQRController(Classes::TComponent* AOwner);
	__fastcall virtual ~TQRController(void);
	void __fastcall AddNotifyClient(TQRPrintable* Value);
	__property Db::TDataSet* DataSet = {read=FDataSet, write=SetDataSet};
	__property int DetailNumber = {read=FDetailNumber, nodefault};
	__property TQRCustomBand* Detail = {read=FDetail, write=FDetail};
	__property TQRCustomBand* Footer = {read=FFooter, write=FFooter};
	__property TQRCustomBand* Header = {read=FHeader, write=FHeader};
	__property Classes::TComponent* Master = {read=FMaster, write=SetMaster};
	__property TQROnNeedDataEvent OnNeedData = {read=FOnNeedDataEvent, write=FOnNeedDataEvent};
	__property TQuickRep* ParentReport = {read=FParentReport, write=FParentReport};
	__property bool PrintBefore = {read=FPrintBefore, write=SetPrintBefore, nodefault};
	__property bool PrintIfEmpty = {read=FPrintIfEmpty, write=FPrintIfEmpty, nodefault};
	__property Classes::TComponent* SelfCheck = {read=FSelfCheck, write=FSelfCheck};
};

class PASCALIMPLEMENTATION TQRBand : public Quickrpt::TQRCustomBand 
{
	typedef Quickrpt::TQRCustomBand inherited;
	
__published:
	__property BandType ;
public:
	/* TQRCustomBand.Create */ __fastcall virtual TQRBand(Classes::TComponent* AOwner) : Quickrpt::TQRCustomBand(
		AOwner) { }
	/* TQRCustomBand.Destroy */ __fastcall virtual ~TQRBand(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TQRBand(HWND ParentWindow) : Quickrpt::TQRCustomBand(ParentWindow
		) { }
	
};

class PASCALIMPLEMENTATION TQRChildBand : public Quickrpt::TQRCustomBand 
{
	typedef Quickrpt::TQRCustomBand inherited;
	
private:
	TQRCustomBand* FParentBand;
	void __fastcall SetParentBand(TQRCustomBand* Value);
	
public:
	__fastcall virtual TQRChildBand(Classes::TComponent* AOwner);
	
__published:
	__property TQRCustomBand* ParentBand = {read=FParentBand, write=SetParentBand};
public:
	/* TQRCustomBand.Destroy */ __fastcall virtual ~TQRChildBand(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TQRChildBand(HWND ParentWindow) : Quickrpt::TQRCustomBand(
		ParentWindow) { }
	
};

class DELPHICLASS TQRControllerBand;
class PASCALIMPLEMENTATION TQRControllerBand : public Quickrpt::TQRCustomBand 
{
	typedef Quickrpt::TQRCustomBand inherited;
	
private:
	TQRController* FController;
	Classes::TComponent* FMaster;
	
protected:
	bool __fastcall GetPrintIfEmpty(void);
	virtual void __fastcall RegisterBands(void);
	virtual void __fastcall SetMaster(Classes::TComponent* Value);
	virtual void __fastcall SetParent(Controls::TWinControl* AParent);
	void __fastcall SetPrintIfEmpty(bool Value);
	__property TQRController* Controller = {read=FController, write=FController};
	
public:
	__fastcall virtual TQRControllerBand(Classes::TComponent* AOwner);
	__fastcall virtual ~TQRControllerBand(void);
	__property bool PrintIfEmpty = {read=GetPrintIfEmpty, write=SetPrintIfEmpty, nodefault};
	
__published:
	__property Classes::TComponent* Master = {read=FMaster, write=SetMaster};
public:
	/* TWinControl.CreateParented */ __fastcall TQRControllerBand(HWND ParentWindow) : Quickrpt::TQRCustomBand(
		ParentWindow) { }
	
};

class DELPHICLASS TQRSubDetailGroupBands;
class DELPHICLASS TQRSubDetail;
class PASCALIMPLEMENTATION TQRSubDetail : public Quickrpt::TQRControllerBand 
{
	typedef Quickrpt::TQRControllerBand inherited;
	
private:
	TQRSubDetailGroupBands* FBands;
	Db::TDataSet* __fastcall GetDataSet(void);
	TQRCustomBand* __fastcall GetFooterBand(void);
	TQRCustomBand* __fastcall GetHeaderBand(void);
	TQROnNeedDataEvent __fastcall GetOnNeedData(void);
	bool __fastcall GetPrintBefore(void);
	void __fastcall SetDataSet(Db::TDataSet* Value);
	void __fastcall SetFooterBand(TQRCustomBand* Value);
	void __fastcall SetHeaderBand(TQRCustomBand* Value);
	void __fastcall SetOnNeedData(TQROnNeedDataEvent Value);
	void __fastcall SetPrintBefore(bool Value);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual void __fastcall RegisterBands(void);
	
public:
	__fastcall virtual TQRSubDetail(Classes::TComponent* AOwner);
	__fastcall virtual ~TQRSubDetail(void);
	void __fastcall AddNotifyClient(TQRPrintable* Value);
	
__published:
	__property TQRSubDetailGroupBands* Bands = {read=FBands, write=FBands};
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property TQRCustomBand* FooterBand = {read=GetFooterBand, write=SetFooterBand};
	__property TQRCustomBand* HeaderBand = {read=GetHeaderBand, write=SetHeaderBand};
	__property TQROnNeedDataEvent OnNeedData = {read=GetOnNeedData, write=SetOnNeedData};
	__property bool PrintBefore = {read=GetPrintBefore, write=SetPrintBefore, nodefault};
	__property PrintIfEmpty ;
public:
	/* TWinControl.CreateParented */ __fastcall TQRSubDetail(HWND ParentWindow) : Quickrpt::TQRControllerBand(
		ParentWindow) { }
	
};

class PASCALIMPLEMENTATION TQRSubDetailGroupBands : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TQRSubDetail* Owner;
	TQRCustomBand* __fastcall GetFooterBand(void);
	bool __fastcall GetHasFooter(void);
	bool __fastcall GetHasHeader(void);
	TQRCustomBand* __fastcall GetHeaderBand(void);
	void __fastcall SetHasFooter(bool Value);
	void __fastcall SetHasHeader(bool Value);
	
public:
	__fastcall TQRSubDetailGroupBands(TQRSubDetail* AOwner);
	__property TQRCustomBand* FooterBand = {read=GetFooterBand};
	__property TQRCustomBand* HeaderBand = {read=GetHeaderBand};
	
__published:
	__property bool HasFooter = {read=GetHasFooter, write=SetHasFooter, stored=false, nodefault};
	__property bool HasHeader = {read=GetHasHeader, write=SetHasHeader, stored=false, nodefault};
public:
		
	/* TPersistent.Destroy */ __fastcall virtual ~TQRSubDetailGroupBands(void) { }
	
};

class DELPHICLASS TQRGroup;
class PASCALIMPLEMENTATION TQRGroup : public Quickrpt::TQRCustomBand 
{
	typedef Quickrpt::TQRCustomBand inherited;
	
private:
	Qrprntr::TQREvaluator* Evaluator;
	System::AnsiString FExpression;
	TQRBand* FFooterBand;
	Classes::TComponent* FMaster;
	bool FReprint;
	Qrprntr::TQREvResult GroupValue;
	bool HasResult;
	void __fastcall SetFooterBand(TQRBand* Value);
	void __fastcall SetMaster(Classes::TComponent* Value);
	
protected:
	__property bool Reprint = {read=FReprint, write=FReprint, nodefault};
	void __fastcall Check(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	void __fastcall Prepare(void);
	virtual void __fastcall ReadValues(Classes::TReader* Reader);
	virtual void __fastcall ReadDataSource(Classes::TReader* Reader);
	virtual void __fastcall ReadDataField(Classes::TReader* Reader);
	virtual void __fastcall ReadHeaderBand(Classes::TReader* Reader);
	virtual void __fastcall ReadOnNeedData(Classes::TReader* Reader);
	void __fastcall SetExpression(System::AnsiString Value);
	virtual void __fastcall SetParent(Controls::TWinControl* AParent);
	void __fastcall Unprepare(void);
	virtual void __fastcall WriteValues(Classes::TWriter* Writer);
	
public:
	__fastcall virtual TQRGroup(Classes::TComponent* AOwner);
	__fastcall virtual ~TQRGroup(void);
	
__published:
	__property System::AnsiString Expression = {read=FExpression, write=SetExpression};
	__property TQRBand* FooterBand = {read=FFooterBand, write=SetFooterBand};
	__property Classes::TComponent* Master = {read=FMaster, write=SetMaster};
public:
	/* TWinControl.CreateParented */ __fastcall TQRGroup(HWND ParentWindow) : Quickrpt::TQRCustomBand(ParentWindow
		) { }
	
};

class DELPHICLASS TQRPrintableSize;
class PASCALIMPLEMENTATION TQRPrintableSize : public Quickrpt::TQRUnitBase 
{
	typedef Quickrpt::TQRUnitBase inherited;
	
private:
	Extended FHeight;
	Extended FLeft;
	Extended FTop;
	Extended FWidth;
	TQRPrintable* Parent;
	Extended __fastcall GetValue(int Index);
	void __fastcall SetValue(int Index, Extended Value);
	
protected:
	virtual void __fastcall SetParentSizes(void);
	virtual void __fastcall ReadValues(Classes::TReader* Reader);
	virtual void __fastcall WriteValues(Classes::TWriter* Writer);
	void __fastcall FixZoom(void);
	
public:
	__fastcall TQRPrintableSize(TQRPrintable* AParent);
	
__published:
	__property Extended Height = {read=GetValue, write=SetValue, stored=false, index=0};
	__property Extended Left = {read=GetValue, write=SetValue, stored=false, index=1};
	__property Extended Top = {read=GetValue, write=SetValue, stored=false, index=2};
	__property Extended Width = {read=GetValue, write=SetValue, stored=false, index=3};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TQRPrintableSize(void) { }
	
};

class PASCALIMPLEMENTATION TQRPrintable : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	bool AlignUpdating;
	TAlignment FAlignment;
	bool FAlignToBand;
	bool ButtonDown;
	TQRFrame* FFrame;
	bool FIsPrinting;
	TQuickRep* FParentReport;
	Qrprntr::TQRPrinter* FQRPrinter;
	TQRPrintableSize* FSize;
	int LastX;
	int LastY;
	int LoadedTop;
	int LoadedWidth;
	int LoadedHeight;
	int LoadedLeft;
	bool __fastcall GetTransparent(void);
	void __fastcall SetTransparent(bool Value);
	int __fastcall GetZoom(void);
	void __fastcall SetAlignToBand(bool Value);
	void __fastcall SetFrame(TQRFrame* Value);
	
protected:
	virtual void __fastcall AlignIt(void);
	virtual void __fastcall Loaded(void);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	void __fastcall PaintCorners(void);
	virtual void __fastcall SetParent(Controls::TWinControl* AParent);
	void __fastcall SetZoom(int Value);
	virtual void __fastcall Paint(void);
	virtual void __fastcall Prepare(void);
	virtual void __fastcall Print(int OfsX, int OfsY);
	virtual void __fastcall QRNotification(System::TObject* Sender, TQRNotifyOperation Operation);
	void __fastcall ReleaseFocusFrame(void);
	virtual void __fastcall SetAlignment(Classes::TAlignment Value);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	virtual void __fastcall UnPrepare(void);
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, nodefault};
	__property bool AlignToBand = {read=FAlignToBand, write=SetAlignToBand, nodefault};
	__property bool IsPrinting = {read=FIsPrinting, write=FIsPrinting, nodefault};
	__property Qrprntr::TQRPrinter* QRPrinter = {read=FQRPrinter, write=FQRPrinter};
	__property bool Transparent = {read=GetTransparent, write=SetTransparent, nodefault};
	
public:
	__fastcall virtual TQRPrintable(Classes::TComponent* AOwner);
	__fastcall virtual ~TQRPrintable(void);
	__property TQuickRep* ParentReport = {read=FParentReport, write=FParentReport};
	__property int Zoom = {read=GetZoom, write=SetZoom, nodefault};
	
__published:
	__property Enabled ;
	__property TQRFrame* Frame = {read=FFrame, write=SetFrame};
	__property TQRPrintableSize* Size = {read=FSize, write=FSize};
public:
	/* TWinControl.CreateParented */ __fastcall TQRPrintable(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	
};

class DELPHICLASS TQRCompositeReport;
class PASCALIMPLEMENTATION TQRCompositeReport : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TNotifyEvent FOnAddReports;
	Classes::TNotifyEvent FOnFinished;
	TQuickReportOptions FOptions;
	TQuickRepPrinterSettings* FPrinterSettings;
	Qrprntr::TQRPrinter* FQRPrinter;
	Classes::TList* FReports;
	System::AnsiString FReportTitle;
	void __fastcall CreateComposite(void);
	
public:
	__fastcall virtual TQRCompositeReport(Classes::TComponent* AOwner);
	__fastcall virtual ~TQRCompositeReport(void);
	void __fastcall Prepare(void);
	void __fastcall Preview(void);
	void __fastcall Print(void);
	__property Classes::TList* Reports = {read=FReports, write=FReports};
	
__published:
	__property Classes::TNotifyEvent OnAddReports = {read=FOnAddReports, write=FOnAddReports};
	__property Classes::TNotifyEvent OnFinished = {read=FOnFinished, write=FOnFinished};
	__property TQuickReportOptions Options = {read=FOptions, write=FOptions, nodefault};
	__property TQuickRepPrinterSettings* PrinterSettings = {read=FPrinterSettings, write=FPrinterSettings
		};
	__property System::AnsiString ReportTitle = {read=FReportTitle, write=FReportTitle};
};

class PASCALIMPLEMENTATION TControlHandle : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	THandlePosition FPosition;
	TQRDesigner* QRDesigner;
	void __fastcall SetPosition(THandlePosition Value);
	void __fastcall SetPos(int x, int y);
	tagPOINT __fastcall GetCenter(void);
	
protected:
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	virtual void __fastcall SetParent(Controls::TWinControl* aParent);
	
public:
	__fastcall virtual TControlHandle(TQRDesigner* aQRDesigner, THandlePosition aPosition);
	HIDESBASE void __fastcall Hide(void);
	HIDESBASE void __fastcall Show(void);
	virtual void __fastcall Paint(void);
	__property THandlePosition Position = {read=FPosition, write=SetPosition, nodefault};
	__property tagPOINT Center = {read=GetCenter};
public:
	/* TCustomControl.Create */ __fastcall virtual TControlHandle(Classes::TComponent* AOwner) : Controls::
		TCustomControl(AOwner) { }
	/* TCustomControl.Destroy */ __fastcall virtual ~TControlHandle(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TControlHandle(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	
};

enum TQRPrintOrder { qrColByCol, qrRowByRow };

typedef void __fastcall (__closure *TQRFilterEvent)(bool &PrintRecord);

enum TQR1PaperSize { qrpDefault, qrpLetter, qrpLegal, qrpA3, qrpA4, qrpA5, qrpCustom };

class DELPHICLASS TQuickReport;
class PASCALIMPLEMENTATION TQuickReport : public Quickrpt::TQuickRep 
{
	typedef Quickrpt::TQuickRep inherited;
	
private:
	Classes::TNotifyEvent FAfterDetail;
	Classes::TNotifyEvent FAfterPrint;
	Classes::TNotifyEvent FBeforeDetail;
	TQRReportBeforePrintEvent FBeforePrint;
	int FColumnMarginInches;
	int FColumnMarginMM;
	int FColumns;
	Db::TDataSource* FDataSource;
	bool FDisplayPrintDialog;
	int FLeftMarginInches;
	int FLeftMarginMM;
	Classes::TNotifyEvent FOnEndPage;
	Classes::TNotifyEvent FOnStartPage;
	TQRFilterEvent FOnFilterEvent;
	TPrinterOrientation FOrientation;
	TQRFrame* FPageFrame;
	int FPaperLength;
	TQR1PaperSize FPaperSize;
	int FPaperWidth;
	TQRPrintOrder FPrintOrder;
	System::AnsiString FReportTitle;
	bool FRestartData;
	bool FShowProgress;
	bool FSQLCompatible;
	bool FTitleBeforeHD;
	
protected:
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TQuickReport(Classes::TComponent* AOwner);
	__fastcall virtual ~TQuickReport(void);
	
__published:
	__property Classes::TNotifyEvent AfterDetail = {read=FAfterDetail, write=FAfterDetail};
	__property Classes::TNotifyEvent AfterPrint = {read=FAfterPrint, write=FAfterPrint};
	__property Classes::TNotifyEvent BeforeDetail = {read=FBeforeDetail, write=FBeforeDetail};
	__property TQRReportBeforePrintEvent BeforePrint = {read=FBeforePrint, write=FBeforePrint};
	__property int ColumnMarginInches = {read=FColumnMarginInches, write=FColumnMarginInches, nodefault
		};
	__property int ColumnMarginMM = {read=FColumnMarginMM, write=FColumnMarginMM, nodefault};
	__property int Columns = {read=FColumns, write=FColumns, nodefault};
	__property Db::TDataSource* DataSource = {read=FDataSource, write=FDataSource};
	__property bool DisplayPrintDialog = {read=FDisplayPrintDialog, write=FDisplayPrintDialog, nodefault
		};
	__property int LeftMarginInches = {read=FLeftMarginInches, write=FLeftMarginInches, nodefault};
	__property int LeftMarginMM = {read=FLeftMarginMM, write=FLeftMarginMM, nodefault};
	__property Classes::TNotifyEvent OnEndPage = {read=FOnEndPage, write=FOnEndPage};
	__property Classes::TNotifyEvent OnStartPage = {read=FOnStartPage, write=FOnStartPage};
	__property Printers::TPrinterOrientation Orientation = {read=FOrientation, write=FOrientation, nodefault
		};
	__property TQRFrame* PageFrame = {read=FPageFrame, write=FPageFrame};
	__property int PaperLength = {read=FPaperLength, write=FPaperLength, nodefault};
	__property TQR1PaperSize PaperSize = {read=FPaperSize, write=FPaperSize, nodefault};
	__property int PaperWidth = {read=FPaperWidth, write=FPaperWidth, nodefault};
	__property TQRPrintOrder PrintOrder = {read=FPrintOrder, write=FPrintOrder, nodefault};
	__property System::AnsiString ReportTitle = {read=FReportTitle, write=FReportTitle};
	__property bool RestartData = {read=FRestartData, write=FRestartData, nodefault};
	__property bool ShowProgress = {read=FShowProgress, write=FShowProgress, default=1};
	__property bool SQLCompatible = {read=FSQLCompatible, write=FSQLCompatible, nodefault};
	__property bool TitleBeforeHeader = {read=FTitleBeforeHD, write=FTitleBeforeHD, nodefault};
	__property TQRFilterEvent OnFilter = {read=FOnFilterEvent, write=FOnFilterEvent};
public:
	/* TQuickRep.CreateNew */ __fastcall TQuickReport(Classes::TComponent* AOwner, int Dummy) : Quickrpt::
		TQuickRep(AOwner, Dummy) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TQuickReport(HWND ParentWindow) : Quickrpt::TQuickRep(ParentWindow
		) { }
	
};

class DELPHICLASS TQRDetailLink;
class PASCALIMPLEMENTATION TQRDetailLink : public Quickrpt::TQRSubDetail 
{
	typedef Quickrpt::TQRSubDetail inherited;
	
private:
	System::AnsiString DataSourceName;
	System::AnsiString DetailBandName;
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall ReadDataSource(Classes::TReader* Reader);
	virtual void __fastcall ReadDetailBand(Classes::TReader* Reader);
	virtual void __fastcall ReadOnFilter(Classes::TReader* Reader);
	void __fastcall WriteValues(Classes::TWriter* Writer);
public:
	/* TQRSubDetail.Create */ __fastcall virtual TQRDetailLink(Classes::TComponent* AOwner) : Quickrpt::
		TQRSubDetail(AOwner) { }
	/* TQRSubDetail.Destroy */ __fastcall virtual ~TQRDetailLink(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TQRDetailLink(HWND ParentWindow) : Quickrpt::TQRSubDetail(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::AnsiString __fastcall UniqueName(Classes::TComponent* AComponent, System::AnsiString 
	Start);
extern PACKAGE void __fastcall SetQRHiColor(void);
extern PACKAGE void __fastcall SetQRLoColor(void);

}	/* namespace Quickrpt */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Quickrpt;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// quickrpt
