// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Registry.pas' rev: 3.00

#ifndef RegistryHPP
#define RegistryHPP
#include <IniFiles.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Registry
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS ERegistryException;
class PASCALIMPLEMENTATION ERegistryException : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall ERegistryException(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall ERegistryException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall ERegistryException(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall ERegistryException(int Ident, const System::TVarRec * Args, 
		const int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall ERegistryException(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall ERegistryException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall ERegistryException(int Ident, int AHelpContext) : Sysutils::
		Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall ERegistryException(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~ERegistryException(void) { }
	
};

struct TRegKeyInfo
{
	int NumSubKeys;
	int MaxSubKeyLen;
	int NumValues;
	int MaxValueLen;
	int MaxDataLen;
	_FILETIME FileTime;
} ;

enum TRegDataType { rdUnknown, rdString, rdExpandString, rdInteger, rdBinary };

struct TRegDataInfo
{
	TRegDataType RegData;
	int DataSize;
} ;

class DELPHICLASS TRegistry;
class PASCALIMPLEMENTATION TRegistry : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	HKEY FCurrentKey;
	HKEY FRootKey;
	bool FLazyWrite;
	System::AnsiString FCurrentPath;
	bool FCloseRootKey;
	void __fastcall SetRootKey(HKEY Value);
	
protected:
	void __fastcall ChangeKey(HKEY Value, const System::AnsiString Path);
	HKEY __fastcall GetBaseKey(bool Relative);
	int __fastcall GetData(const System::AnsiString Name, void * Buffer, int BufSize, TRegDataType &RegData
		);
	HKEY __fastcall GetKey(const System::AnsiString Key);
	void __fastcall PutData(const System::AnsiString Name, void * Buffer, int BufSize, TRegDataType RegData
		);
	void __fastcall SetCurrentKey(HKEY Value);
	
public:
	__fastcall TRegistry(void);
	__fastcall virtual ~TRegistry(void);
	void __fastcall CloseKey(void);
	bool __fastcall CreateKey(const System::AnsiString Key);
	bool __fastcall DeleteKey(const System::AnsiString Key);
	bool __fastcall DeleteValue(const System::AnsiString Name);
	bool __fastcall GetDataInfo(const System::AnsiString ValueName, TRegDataInfo &Value);
	int __fastcall GetDataSize(const System::AnsiString ValueName);
	TRegDataType __fastcall GetDataType(const System::AnsiString ValueName);
	bool __fastcall GetKeyInfo(TRegKeyInfo &Value);
	void __fastcall GetKeyNames(Classes::TStrings* Strings);
	void __fastcall GetValueNames(Classes::TStrings* Strings);
	bool __fastcall HasSubKeys(void);
	bool __fastcall KeyExists(const System::AnsiString Key);
	bool __fastcall LoadKey(const System::AnsiString Key, const System::AnsiString FileName);
	void __fastcall MoveKey(const System::AnsiString OldName, const System::AnsiString NewName, bool Delete
		);
	bool __fastcall OpenKey(const System::AnsiString Key, bool CanCreate);
	System::Currency __fastcall ReadCurrency(const System::AnsiString Name);
	int __fastcall ReadBinaryData(const System::AnsiString Name, void *Buffer, int BufSize);
	bool __fastcall ReadBool(const System::AnsiString Name);
	System::TDateTime __fastcall ReadDate(const System::AnsiString Name);
	System::TDateTime __fastcall ReadDateTime(const System::AnsiString Name);
	double __fastcall ReadFloat(const System::AnsiString Name);
	int __fastcall ReadInteger(const System::AnsiString Name);
	System::AnsiString __fastcall ReadString(const System::AnsiString Name);
	System::TDateTime __fastcall ReadTime(const System::AnsiString Name);
	bool __fastcall RegistryConnect(const System::AnsiString UNCName);
	void __fastcall RenameValue(const System::AnsiString OldName, const System::AnsiString NewName);
	bool __fastcall ReplaceKey(const System::AnsiString Key, const System::AnsiString FileName, const System::AnsiString 
		BackUpFileName);
	bool __fastcall RestoreKey(const System::AnsiString Key, const System::AnsiString FileName);
	bool __fastcall SaveKey(const System::AnsiString Key, const System::AnsiString FileName);
	bool __fastcall UnLoadKey(const System::AnsiString Key);
	bool __fastcall ValueExists(const System::AnsiString Name);
	void __fastcall WriteCurrency(const System::AnsiString Name, System::Currency Value);
	void __fastcall WriteBinaryData(const System::AnsiString Name, void *Buffer, int BufSize);
	void __fastcall WriteBool(const System::AnsiString Name, bool Value);
	void __fastcall WriteDate(const System::AnsiString Name, System::TDateTime Value);
	void __fastcall WriteDateTime(const System::AnsiString Name, System::TDateTime Value);
	void __fastcall WriteFloat(const System::AnsiString Name, double Value);
	void __fastcall WriteInteger(const System::AnsiString Name, int Value);
	void __fastcall WriteString(const System::AnsiString Name, const System::AnsiString Value);
	void __fastcall WriteExpandString(const System::AnsiString Name, const System::AnsiString Value);
	void __fastcall WriteTime(const System::AnsiString Name, System::TDateTime Value);
	__property HKEY CurrentKey = {read=FCurrentKey, nodefault};
	__property System::AnsiString CurrentPath = {read=FCurrentPath};
	__property bool LazyWrite = {read=FLazyWrite, write=FLazyWrite, nodefault};
	__property HKEY RootKey = {read=FRootKey, write=SetRootKey, nodefault};
};

class DELPHICLASS TRegIniFile;
class PASCALIMPLEMENTATION TRegIniFile : public Registry::TRegistry 
{
	typedef Registry::TRegistry inherited;
	
private:
	System::AnsiString FFileName;
	
public:
	__fastcall TRegIniFile(const System::AnsiString FileName);
	HIDESBASE System::AnsiString __fastcall ReadString(const System::AnsiString Section, const System::AnsiString 
		Ident, const System::AnsiString Default);
	HIDESBASE int __fastcall ReadInteger(const System::AnsiString Section, const System::AnsiString Ident
		, int Default);
	HIDESBASE void __fastcall WriteInteger(const System::AnsiString Section, const System::AnsiString Ident
		, int Value);
	HIDESBASE void __fastcall WriteString(const System::AnsiString Section, const System::AnsiString Ident
		, const System::AnsiString Value);
	HIDESBASE bool __fastcall ReadBool(const System::AnsiString Section, const System::AnsiString Ident
		, bool Default);
	HIDESBASE void __fastcall WriteBool(const System::AnsiString Section, const System::AnsiString Ident
		, bool Value);
	void __fastcall ReadSection(const System::AnsiString Section, Classes::TStrings* Strings);
	void __fastcall ReadSections(Classes::TStrings* Strings);
	void __fastcall ReadSectionValues(const System::AnsiString Section, Classes::TStrings* Strings);
	void __fastcall EraseSection(const System::AnsiString Section);
	HIDESBASE void __fastcall DeleteKey(const System::AnsiString Section, const System::AnsiString Ident
		);
	__property System::AnsiString FileName = {read=FFileName};
public:
	/* TRegistry.Destroy */ __fastcall virtual ~TRegIniFile(void) { }
	
};

class DELPHICLASS TRegistryIniFile;
class PASCALIMPLEMENTATION TRegistryIniFile : public Inifiles::TCustomIniFile 
{
	typedef Inifiles::TCustomIniFile inherited;
	
private:
	TRegIniFile* FRegIniFile;
	
public:
	__fastcall TRegistryIniFile(const System::AnsiString FileName);
	__fastcall virtual ~TRegistryIniFile(void);
	virtual System::TDateTime __fastcall ReadDate(const System::AnsiString Section, const System::AnsiString 
		Name, System::TDateTime Default);
	virtual System::TDateTime __fastcall ReadDateTime(const System::AnsiString Section, const System::AnsiString 
		Name, System::TDateTime Default);
	virtual int __fastcall ReadInteger(const System::AnsiString Section, const System::AnsiString Ident
		, int Default);
	virtual double __fastcall ReadFloat(const System::AnsiString Section, const System::AnsiString Name
		, double Default);
	virtual System::AnsiString __fastcall ReadString(const System::AnsiString Section, const System::AnsiString 
		Ident, const System::AnsiString Default);
	virtual System::TDateTime __fastcall ReadTime(const System::AnsiString Section, const System::AnsiString 
		Name, System::TDateTime Default);
	virtual void __fastcall WriteDate(const System::AnsiString Section, const System::AnsiString Name, 
		System::TDateTime Value);
	virtual void __fastcall WriteDateTime(const System::AnsiString Section, const System::AnsiString Name
		, System::TDateTime Value);
	virtual void __fastcall WriteFloat(const System::AnsiString Section, const System::AnsiString Name, 
		double Value);
	virtual void __fastcall WriteInteger(const System::AnsiString Section, const System::AnsiString Ident
		, int Value);
	virtual void __fastcall WriteString(const System::AnsiString Section, const System::AnsiString Ident
		, const System::AnsiString Value);
	virtual void __fastcall WriteTime(const System::AnsiString Section, const System::AnsiString Name, 
		System::TDateTime Value);
	virtual void __fastcall ReadSection(const System::AnsiString Section, Classes::TStrings* Strings);
	virtual void __fastcall ReadSections(Classes::TStrings* Strings);
	virtual void __fastcall ReadSectionValues(const System::AnsiString Section, Classes::TStrings* Strings
		);
	virtual void __fastcall EraseSection(const System::AnsiString Section);
	virtual void __fastcall DeleteKey(const System::AnsiString Section, const System::AnsiString Ident)
		;
	virtual void __fastcall UpdateFile(void);
	__property TRegIniFile* RegIniFile = {read=FRegIniFile};
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Registry */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Registry;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Registry
