// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SysUtils.pas' rev: 3.00

#ifndef SysUtilsHPP
#define SysUtilsHPP
#include <SysConst.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Sysutils
{
//-- type declarations -------------------------------------------------------
typedef Set<char, 0, 255>  TSysCharSet;

#pragma pack(push, 1)
struct WordRec
{
	Byte Lo;
	Byte Hi;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct LongRec
{
	Word Lo;
	Word Hi;
} ;
#pragma pack(pop)

struct TMethod
{
	void *Code;
	void *Data;
} ;

typedef Byte TByteArray[32768];

typedef TByteArray *PByteArray;

typedef Word TWordArray[16384];

typedef TWordArray *PWordArray;

typedef void __fastcall (*TProcedure)(void);

typedef System::AnsiString TFileName;

struct TSearchRec
{
	int Time;
	int Size;
	int Attr;
	System::AnsiString Name;
	int ExcludeAttr;
	int FindHandle;
	_WIN32_FIND_DATAA FindData;
} ;

struct TFileRec
{
	int Handle;
	int Mode;
	Cardinal RecSize;
	Byte Private[28];
	Byte UserData[32];
	char Name[260];
} ;

typedef char TTextBuf[128];

typedef TTextBuf *PTextBuf;

struct TTextRec
{
	int Handle;
	int Mode;
	Cardinal BufSize;
	Cardinal BufPos;
	Cardinal BufEnd;
	char *BufPtr;
	void *OpenFunc;
	void *InOutFunc;
	void *FlushFunc;
	void *CloseFunc;
	Byte UserData[32];
	char Name[260];
	char Buffer[128];
} ;

enum TFloatValue { fvExtended, fvCurrency };

enum TFloatFormat { ffGeneral, ffExponent, ffFixed, ffNumber, ffCurrency };

#pragma pack(push, 1)
struct TFloatRec
{
	short Exponent;
	bool Negative;
	char Digits[21];
} ;
#pragma pack(pop)

struct TTimeStamp
{
	int Time;
	int Date;
} ;

enum TMbcsByteType { mbSingleByte, mbLeadByte, mbTrailByte };

#pragma pack(push, 1)
struct TSysLocale
{
	int DefaultLCID;
	Word PriLangID;
	Word SubLangID;
	bool FarEast;
} ;
#pragma pack(pop)

class DELPHICLASS Exception;
class PASCALIMPLEMENTATION Exception : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	System::AnsiString FMessage;
	int FHelpContext;
	
public:
	__fastcall Exception(const System::AnsiString Msg);
	__fastcall Exception(const System::AnsiString Msg, const System::TVarRec * Args, const int Args_Size
		);
	__fastcall Exception(int Ident, Extended Dummy);
	__fastcall Exception(int Ident, const System::TVarRec * Args, const int Args_Size);
	__fastcall Exception(const System::AnsiString Msg, int AHelpContext);
	__fastcall Exception(const System::AnsiString Msg, const System::TVarRec * Args, const int Args_Size
		, int AHelpContext);
	__fastcall Exception(int Ident, int AHelpContext);
	__fastcall Exception(int Ident, const System::TVarRec * Args, const int Args_Size, int AHelpContext
		);
	__property int HelpContext = {read=FHelpContext, write=FHelpContext, nodefault};
	__property System::AnsiString Message = {read=FMessage, write=FMessage};
public:
	/* TObject.Destroy */ __fastcall virtual ~Exception(void) { }
	
};

typedef System::TMetaClass*ExceptClass;

class DELPHICLASS EAbort;
class PASCALIMPLEMENTATION EAbort : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EAbort(const System::AnsiString Msg) : Sysutils::Exception(Msg) { }
		
	/* Exception.CreateFmt */ __fastcall EAbort(const System::AnsiString Msg, const System::TVarRec * Args
		, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EAbort(int Ident, Extended Dummy) : Sysutils::Exception(Ident, 
		Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EAbort(int Ident, const System::TVarRec * Args, const int Args_Size
		) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EAbort(const System::AnsiString Msg, int AHelpContext) : Sysutils::
		Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EAbort(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EAbort(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EAbort(int Ident, const System::TVarRec * Args, const int 
		Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EAbort(void) { }
	
};

class DELPHICLASS EOutOfMemory;
class PASCALIMPLEMENTATION EOutOfMemory : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
private:
	bool AllowFree;
	
public:
	__fastcall virtual ~EOutOfMemory(void);
	virtual void __fastcall FreeInstance(void);
public:
	/* Exception.Create */ __fastcall EOutOfMemory(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EOutOfMemory(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EOutOfMemory(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EOutOfMemory(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EOutOfMemory(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EOutOfMemory(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EOutOfMemory(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EOutOfMemory(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
};

class DELPHICLASS EInOutError;
class PASCALIMPLEMENTATION EInOutError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	int ErrorCode;
public:
	/* Exception.Create */ __fastcall EInOutError(const System::AnsiString Msg) : Sysutils::Exception(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EInOutError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EInOutError(int Ident, Extended Dummy) : Sysutils::Exception(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EInOutError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EInOutError(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EInOutError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EInOutError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EInOutError(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EInOutError(void) { }
	
};

class DELPHICLASS EExternal;
class PASCALIMPLEMENTATION EExternal : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	_EXCEPTION_RECORD *ExceptionRecord;
public:
	/* Exception.Create */ __fastcall EExternal(const System::AnsiString Msg) : Sysutils::Exception(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EExternal(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EExternal(int Ident, Extended Dummy) : Sysutils::Exception(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EExternal(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EExternal(const System::AnsiString Msg, int AHelpContext) : Sysutils::
		Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EExternal(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EExternal(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EExternal(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EExternal(void) { }
	
};

class DELPHICLASS EExternalException;
class PASCALIMPLEMENTATION EExternalException : public Sysutils::EExternal 
{
	typedef Sysutils::EExternal inherited;
	
public:
	/* Exception.Create */ __fastcall EExternalException(const System::AnsiString Msg) : Sysutils::EExternal(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EExternalException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EExternal(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EExternalException(int Ident, Extended Dummy) : Sysutils::EExternal(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EExternalException(int Ident, const System::TVarRec * Args, 
		const int Args_Size) : Sysutils::EExternal(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EExternalException(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::EExternal(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EExternalException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EExternal(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EExternalException(int Ident, int AHelpContext) : Sysutils::
		EExternal(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EExternalException(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Sysutils::EExternal(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EExternalException(void) { }
	
};

class DELPHICLASS EIntError;
class PASCALIMPLEMENTATION EIntError : public Sysutils::EExternal 
{
	typedef Sysutils::EExternal inherited;
	
public:
	/* Exception.Create */ __fastcall EIntError(const System::AnsiString Msg) : Sysutils::EExternal(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EIntError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EExternal(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EIntError(int Ident, Extended Dummy) : Sysutils::EExternal(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EIntError(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::EExternal(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EIntError(const System::AnsiString Msg, int AHelpContext) : Sysutils::
		EExternal(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EIntError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EExternal(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EIntError(int Ident, int AHelpContext) : Sysutils::EExternal(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EIntError(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EExternal(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EIntError(void) { }
	
};

class DELPHICLASS EDivByZero;
class PASCALIMPLEMENTATION EDivByZero : public Sysutils::EIntError 
{
	typedef Sysutils::EIntError inherited;
	
public:
	/* Exception.Create */ __fastcall EDivByZero(const System::AnsiString Msg) : Sysutils::EIntError(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EDivByZero(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EIntError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EDivByZero(int Ident, Extended Dummy) : Sysutils::EIntError(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EDivByZero(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::EIntError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EDivByZero(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::EIntError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EDivByZero(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EIntError(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EDivByZero(int Ident, int AHelpContext) : Sysutils::EIntError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EDivByZero(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EIntError(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EDivByZero(void) { }
	
};

class DELPHICLASS ERangeError;
class PASCALIMPLEMENTATION ERangeError : public Sysutils::EIntError 
{
	typedef Sysutils::EIntError inherited;
	
public:
	/* Exception.Create */ __fastcall ERangeError(const System::AnsiString Msg) : Sysutils::EIntError(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall ERangeError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EIntError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall ERangeError(int Ident, Extended Dummy) : Sysutils::EIntError(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall ERangeError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::EIntError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall ERangeError(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::EIntError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall ERangeError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EIntError(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall ERangeError(int Ident, int AHelpContext) : Sysutils::EIntError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall ERangeError(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EIntError(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~ERangeError(void) { }
	
};

class DELPHICLASS EIntOverflow;
class PASCALIMPLEMENTATION EIntOverflow : public Sysutils::EIntError 
{
	typedef Sysutils::EIntError inherited;
	
public:
	/* Exception.Create */ __fastcall EIntOverflow(const System::AnsiString Msg) : Sysutils::EIntError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EIntOverflow(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EIntError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EIntOverflow(int Ident, Extended Dummy) : Sysutils::EIntError(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EIntOverflow(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::EIntError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EIntOverflow(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::EIntError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EIntOverflow(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EIntError(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EIntOverflow(int Ident, int AHelpContext) : Sysutils::EIntError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EIntOverflow(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EIntError(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EIntOverflow(void) { }
	
};

class DELPHICLASS EMathError;
class PASCALIMPLEMENTATION EMathError : public Sysutils::EExternal 
{
	typedef Sysutils::EExternal inherited;
	
public:
	/* Exception.Create */ __fastcall EMathError(const System::AnsiString Msg) : Sysutils::EExternal(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EMathError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EExternal(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EMathError(int Ident, Extended Dummy) : Sysutils::EExternal(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EMathError(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::EExternal(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EMathError(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::EExternal(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EMathError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EExternal(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EMathError(int Ident, int AHelpContext) : Sysutils::EExternal(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EMathError(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EExternal(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EMathError(void) { }
	
};

class DELPHICLASS EInvalidOp;
class PASCALIMPLEMENTATION EInvalidOp : public Sysutils::EMathError 
{
	typedef Sysutils::EMathError inherited;
	
public:
	/* Exception.Create */ __fastcall EInvalidOp(const System::AnsiString Msg) : Sysutils::EMathError(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EInvalidOp(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EMathError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EInvalidOp(int Ident, Extended Dummy) : Sysutils::EMathError(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EInvalidOp(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::EMathError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EInvalidOp(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::EMathError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EInvalidOp(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EMathError(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EInvalidOp(int Ident, int AHelpContext) : Sysutils::EMathError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EInvalidOp(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EMathError(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EInvalidOp(void) { }
	
};

class DELPHICLASS EZeroDivide;
class PASCALIMPLEMENTATION EZeroDivide : public Sysutils::EMathError 
{
	typedef Sysutils::EMathError inherited;
	
public:
	/* Exception.Create */ __fastcall EZeroDivide(const System::AnsiString Msg) : Sysutils::EMathError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EZeroDivide(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EMathError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EZeroDivide(int Ident, Extended Dummy) : Sysutils::EMathError(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EZeroDivide(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::EMathError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EZeroDivide(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::EMathError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EZeroDivide(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EMathError(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EZeroDivide(int Ident, int AHelpContext) : Sysutils::EMathError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EZeroDivide(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EMathError(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EZeroDivide(void) { }
	
};

class DELPHICLASS EOverflow;
class PASCALIMPLEMENTATION EOverflow : public Sysutils::EMathError 
{
	typedef Sysutils::EMathError inherited;
	
public:
	/* Exception.Create */ __fastcall EOverflow(const System::AnsiString Msg) : Sysutils::EMathError(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EOverflow(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EMathError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EOverflow(int Ident, Extended Dummy) : Sysutils::EMathError(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EOverflow(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::EMathError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EOverflow(const System::AnsiString Msg, int AHelpContext) : Sysutils::
		EMathError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EOverflow(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EMathError(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EOverflow(int Ident, int AHelpContext) : Sysutils::EMathError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EOverflow(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EMathError(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EOverflow(void) { }
	
};

class DELPHICLASS EUnderflow;
class PASCALIMPLEMENTATION EUnderflow : public Sysutils::EMathError 
{
	typedef Sysutils::EMathError inherited;
	
public:
	/* Exception.Create */ __fastcall EUnderflow(const System::AnsiString Msg) : Sysutils::EMathError(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EUnderflow(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EMathError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EUnderflow(int Ident, Extended Dummy) : Sysutils::EMathError(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EUnderflow(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::EMathError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EUnderflow(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::EMathError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EUnderflow(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EMathError(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EUnderflow(int Ident, int AHelpContext) : Sysutils::EMathError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EUnderflow(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EMathError(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EUnderflow(void) { }
	
};

class DELPHICLASS EInvalidPointer;
class PASCALIMPLEMENTATION EInvalidPointer : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EInvalidPointer(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EInvalidPointer(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EInvalidPointer(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EInvalidPointer(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EInvalidPointer(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EInvalidPointer(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EInvalidPointer(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EInvalidPointer(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EInvalidPointer(void) { }
	
};

class DELPHICLASS EInvalidCast;
class PASCALIMPLEMENTATION EInvalidCast : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EInvalidCast(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EInvalidCast(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EInvalidCast(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EInvalidCast(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EInvalidCast(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EInvalidCast(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EInvalidCast(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EInvalidCast(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EInvalidCast(void) { }
	
};

class DELPHICLASS EConvertError;
class PASCALIMPLEMENTATION EConvertError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EConvertError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EConvertError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EConvertError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EConvertError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EConvertError(const System::AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EConvertError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EConvertError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EConvertError(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EConvertError(void) { }
	
};

class DELPHICLASS EAccessViolation;
class PASCALIMPLEMENTATION EAccessViolation : public Sysutils::EExternal 
{
	typedef Sysutils::EExternal inherited;
	
public:
	/* Exception.Create */ __fastcall EAccessViolation(const System::AnsiString Msg) : Sysutils::EExternal(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EAccessViolation(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EExternal(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EAccessViolation(int Ident, Extended Dummy) : Sysutils::EExternal(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EAccessViolation(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::EExternal(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EAccessViolation(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::EExternal(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EAccessViolation(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EExternal(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EAccessViolation(int Ident, int AHelpContext) : Sysutils::
		EExternal(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EAccessViolation(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Sysutils::EExternal(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EAccessViolation(void) { }
	
};

class DELPHICLASS EPrivilege;
class PASCALIMPLEMENTATION EPrivilege : public Sysutils::EExternal 
{
	typedef Sysutils::EExternal inherited;
	
public:
	/* Exception.Create */ __fastcall EPrivilege(const System::AnsiString Msg) : Sysutils::EExternal(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EPrivilege(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EExternal(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EPrivilege(int Ident, Extended Dummy) : Sysutils::EExternal(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EPrivilege(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::EExternal(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EPrivilege(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::EExternal(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EPrivilege(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EExternal(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EPrivilege(int Ident, int AHelpContext) : Sysutils::EExternal(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EPrivilege(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EExternal(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EPrivilege(void) { }
	
};

class DELPHICLASS EStackOverflow;
class PASCALIMPLEMENTATION EStackOverflow : public Sysutils::EExternal 
{
	typedef Sysutils::EExternal inherited;
	
public:
	/* Exception.Create */ __fastcall EStackOverflow(const System::AnsiString Msg) : Sysutils::EExternal(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EStackOverflow(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EExternal(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EStackOverflow(int Ident, Extended Dummy) : Sysutils::EExternal(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EStackOverflow(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::EExternal(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EStackOverflow(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::EExternal(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EStackOverflow(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EExternal(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EStackOverflow(int Ident, int AHelpContext) : Sysutils::EExternal(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EStackOverflow(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::EExternal(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EStackOverflow(void) { }
	
};

class DELPHICLASS EControlC;
class PASCALIMPLEMENTATION EControlC : public Sysutils::EExternal 
{
	typedef Sysutils::EExternal inherited;
	
public:
	/* Exception.Create */ __fastcall EControlC(const System::AnsiString Msg) : Sysutils::EExternal(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EControlC(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::EExternal(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EControlC(int Ident, Extended Dummy) : Sysutils::EExternal(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EControlC(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::EExternal(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EControlC(const System::AnsiString Msg, int AHelpContext) : Sysutils::
		EExternal(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EControlC(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::EExternal(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EControlC(int Ident, int AHelpContext) : Sysutils::EExternal(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EControlC(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::EExternal(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EControlC(void) { }
	
};

class DELPHICLASS EVariantError;
class PASCALIMPLEMENTATION EVariantError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EVariantError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EVariantError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EVariantError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EVariantError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EVariantError(const System::AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EVariantError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EVariantError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EVariantError(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EVariantError(void) { }
	
};

class DELPHICLASS EPropReadOnly;
class PASCALIMPLEMENTATION EPropReadOnly : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EPropReadOnly(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EPropReadOnly(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EPropReadOnly(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EPropReadOnly(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EPropReadOnly(const System::AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EPropReadOnly(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EPropReadOnly(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EPropReadOnly(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EPropReadOnly(void) { }
	
};

class DELPHICLASS EPropWriteOnly;
class PASCALIMPLEMENTATION EPropWriteOnly : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EPropWriteOnly(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EPropWriteOnly(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EPropWriteOnly(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EPropWriteOnly(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EPropWriteOnly(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EPropWriteOnly(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EPropWriteOnly(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EPropWriteOnly(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EPropWriteOnly(void) { }
	
};

class DELPHICLASS EAssertionFailed;
class PASCALIMPLEMENTATION EAssertionFailed : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EAssertionFailed(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EAssertionFailed(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EAssertionFailed(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EAssertionFailed(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EAssertionFailed(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EAssertionFailed(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EAssertionFailed(int Ident, int AHelpContext) : Sysutils::
		Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EAssertionFailed(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EAssertionFailed(void) { }
	
};

class DELPHICLASS EAbstractError;
class PASCALIMPLEMENTATION EAbstractError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EAbstractError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EAbstractError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EAbstractError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EAbstractError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EAbstractError(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EAbstractError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EAbstractError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EAbstractError(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EAbstractError(void) { }
	
};

class DELPHICLASS EIntfCastError;
class PASCALIMPLEMENTATION EIntfCastError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EIntfCastError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EIntfCastError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EIntfCastError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EIntfCastError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EIntfCastError(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EIntfCastError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EIntfCastError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EIntfCastError(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EIntfCastError(void) { }
	
};

class DELPHICLASS EInvalidContainer;
class PASCALIMPLEMENTATION EInvalidContainer : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EInvalidContainer(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EInvalidContainer(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EInvalidContainer(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EInvalidContainer(int Ident, const System::TVarRec * Args, 
		const int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EInvalidContainer(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EInvalidContainer(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EInvalidContainer(int Ident, int AHelpContext) : Sysutils::
		Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EInvalidContainer(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EInvalidContainer(void) { }
	
};

class DELPHICLASS EInvalidInsert;
class PASCALIMPLEMENTATION EInvalidInsert : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EInvalidInsert(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EInvalidInsert(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EInvalidInsert(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EInvalidInsert(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EInvalidInsert(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EInvalidInsert(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EInvalidInsert(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EInvalidInsert(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EInvalidInsert(void) { }
	
};

class DELPHICLASS EPackageError;
class PASCALIMPLEMENTATION EPackageError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EPackageError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EPackageError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EPackageError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EPackageError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EPackageError(const System::AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EPackageError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EPackageError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EPackageError(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EPackageError(void) { }
	
};

class DELPHICLASS EWin32Error;
class PASCALIMPLEMENTATION EWin32Error : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	int ErrorCode;
public:
	/* Exception.Create */ __fastcall EWin32Error(const System::AnsiString Msg) : Sysutils::Exception(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EWin32Error(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EWin32Error(int Ident, Extended Dummy) : Sysutils::Exception(Ident
		, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EWin32Error(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EWin32Error(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EWin32Error(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EWin32Error(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EWin32Error(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EWin32Error(void) { }
	
};

typedef Word TDayTable[12];

typedef TDayTable *PDayTable;

enum SysUtils__43 { rfReplaceAll, rfIgnoreCase };

typedef Set<SysUtils__43, rfReplaceAll, rfIgnoreCase>  TReplaceFlags;

enum TNameType { ntContainsUnit, ntRequiresPackage };

typedef void __fastcall (*TPackageInfoProc)(const System::AnsiString Name, TNameType NameType, Byte 
	Flags, void * Param);

typedef bool __fastcall (*TTerminateProc)(void);

//-- var, const, procedure ---------------------------------------------------
#define fmOpenRead (Byte)(0)
#define fmOpenWrite (Byte)(1)
#define fmOpenReadWrite (Byte)(2)
#define fmShareCompat (Byte)(0)
#define fmShareExclusive (Byte)(16)
#define fmShareDenyWrite (Byte)(32)
#define fmShareDenyRead (Byte)(48)
#define fmShareDenyNone (Byte)(64)
#define faReadOnly (Byte)(1)
#define faHidden (Byte)(2)
#define faSysFile (Byte)(4)
#define faVolumeID (Byte)(8)
#define faDirectory (Byte)(16)
#define faArchive (Byte)(32)
#define faAnyFile (Byte)(63)
#define fmClosed (int)(55216)
#define fmInput (int)(55217)
#define fmOutput (int)(55218)
#define fmInOut (int)(55219)
#define SecsPerDay (int)(86400)
#define MSecsPerDay (int)(86400000)
#define DateDelta (int)(693594)
extern PACKAGE System::AnsiString EmptyStr;
extern PACKAGE System::AnsiString *NullStr;
extern PACKAGE int Win32Platform;
extern PACKAGE int Win32MajorVersion;
extern PACKAGE int Win32MinorVersion;
extern PACKAGE int Win32BuildNumber;
extern PACKAGE System::AnsiString Win32CSDVersion;
extern PACKAGE System::AnsiString CurrencyString;
extern PACKAGE Byte CurrencyFormat;
extern PACKAGE Byte NegCurrFormat;
extern PACKAGE char ThousandSeparator;
extern PACKAGE char DecimalSeparator;
extern PACKAGE Byte CurrencyDecimals;
extern PACKAGE char DateSeparator;
extern PACKAGE System::AnsiString ShortDateFormat;
extern PACKAGE System::AnsiString LongDateFormat;
extern PACKAGE char TimeSeparator;
extern PACKAGE System::AnsiString TimeAMString;
extern PACKAGE System::AnsiString TimePMString;
extern PACKAGE System::AnsiString ShortTimeFormat;
extern PACKAGE System::AnsiString LongTimeFormat;
extern PACKAGE System::AnsiString ShortMonthNames[12];
extern PACKAGE System::AnsiString LongMonthNames[12];
extern PACKAGE System::AnsiString ShortDayNames[7];
extern PACKAGE System::AnsiString LongDayNames[7];
extern PACKAGE TSysLocale SysLocale;
extern PACKAGE System::AnsiString EraNames[7];
extern PACKAGE int EraYearOffsets[7];
extern PACKAGE Word MonthDays[2][12];
extern PACKAGE System::Set<char, 0, 255>  LeadBytes;
#define pfNeverBuild (Byte)(1)
#define pfDesignOnly (Byte)(2)
#define pfRunOnly (Byte)(4)
#define pfModuleTypeMask (int)(-1073741824)
#define pfExeModule (Byte)(0)
#define pfPackageModule (int)(1073741824)
#define pfLibraryModule (int)(0x80000000)
#define ufMainUnit (Byte)(1)
#define ufPackageUnit (Byte)(2)
#define ufWeakUnit (Byte)(4)
#define ufOrgWeakUnit (Byte)(8)
#define ufImplicitUnit (Byte)(16)
#define ufWeakPackageUnit (Byte)(6)
extern PACKAGE System::AnsiString HexDisplayPrefix;
extern PACKAGE void * __fastcall AllocMem(Cardinal Size);
extern PACKAGE void __fastcall AddExitProc(TProcedure Proc);
extern PACKAGE System::PAnsiString __fastcall NewStr(const System::AnsiString S);
extern PACKAGE void __fastcall DisposeStr(System::PAnsiString P);
extern PACKAGE void __fastcall AssignStr(System::PAnsiString &P, const System::AnsiString S);
extern PACKAGE void __fastcall AppendStr(System::AnsiString &Dest, const System::AnsiString S);
extern PACKAGE System::AnsiString __fastcall UpperCase(const System::AnsiString S);
extern PACKAGE System::AnsiString __fastcall LowerCase(const System::AnsiString S);
extern PACKAGE int __fastcall CompareStr(const System::AnsiString S1, const System::AnsiString S2);
extern PACKAGE bool __fastcall CompareMem(void * P1, void * P2, int Length);
extern PACKAGE int __fastcall CompareText(const System::AnsiString S1, const System::AnsiString S2);
	
extern PACKAGE System::AnsiString __fastcall AnsiUpperCase(const System::AnsiString S);
extern PACKAGE System::AnsiString __fastcall AnsiLowerCase(const System::AnsiString S);
extern PACKAGE int __fastcall AnsiCompareStr(const System::AnsiString S1, const System::AnsiString S2
	);
extern PACKAGE int __fastcall AnsiCompareText(const System::AnsiString S1, const System::AnsiString 
	S2);
extern PACKAGE int __fastcall AnsiStrComp(char * S1, char * S2);
extern PACKAGE int __fastcall AnsiStrIComp(char * S1, char * S2);
extern PACKAGE int __fastcall AnsiStrLComp(char * S1, char * S2, Cardinal MaxLen);
extern PACKAGE int __fastcall AnsiStrLIComp(char * S1, char * S2, Cardinal MaxLen);
extern PACKAGE char * __fastcall AnsiStrLower(char * Str);
extern PACKAGE char * __fastcall AnsiStrUpper(char * Str);
extern PACKAGE System::AnsiString __fastcall Trim(const System::AnsiString S);
extern PACKAGE System::AnsiString __fastcall TrimLeft(const System::AnsiString S);
extern PACKAGE System::AnsiString __fastcall TrimRight(const System::AnsiString S);
extern PACKAGE System::AnsiString __fastcall QuotedStr(const System::AnsiString S);
extern PACKAGE System::AnsiString __fastcall AnsiQuotedStr(const System::AnsiString S, char Quote);
extern PACKAGE System::AnsiString __fastcall AnsiExtractQuotedStr(char * &Src, char Quote);
extern PACKAGE System::AnsiString __fastcall AdjustLineBreaks(const System::AnsiString S);
extern PACKAGE bool __fastcall IsValidIdent(const System::AnsiString Ident);
extern PACKAGE System::AnsiString __fastcall IntToStr(int Value);
extern PACKAGE System::AnsiString __fastcall IntToHex(int Value, int Digits);
extern PACKAGE int __fastcall StrToInt(const System::AnsiString S);
extern PACKAGE int __fastcall StrToIntDef(const System::AnsiString S, int Default);
extern PACKAGE System::AnsiString __fastcall LoadStr(int Ident);
extern PACKAGE System::AnsiString __fastcall FmtLoadStr(int Ident, const System::TVarRec * Args, const 
	int Args_Size);
extern PACKAGE int __fastcall FileOpen(const System::AnsiString FileName, int Mode);
extern PACKAGE int __fastcall FileCreate(const System::AnsiString FileName);
extern PACKAGE int __fastcall FileRead(int Handle, void *Buffer, int Count);
extern PACKAGE int __fastcall FileWrite(int Handle, const void *Buffer, int Count);
extern PACKAGE int __fastcall FileSeek(int Handle, int Offset, int Origin);
extern PACKAGE void __fastcall FileClose(int Handle);
extern PACKAGE int __fastcall FileAge(const System::AnsiString FileName);
extern PACKAGE bool __fastcall FileExists(const System::AnsiString FileName);
extern PACKAGE int __fastcall FileGetDate(int Handle);
extern PACKAGE int __fastcall FileSetDate(int Handle, int Age);
extern PACKAGE int __fastcall FileGetAttr(const System::AnsiString FileName);
extern PACKAGE int __fastcall FileSetAttr(const System::AnsiString FileName, int Attr);
extern PACKAGE int __fastcall FindFirst(const System::AnsiString Path, int Attr, TSearchRec &F);
extern PACKAGE int __fastcall FindNext(TSearchRec &F);
extern PACKAGE void __fastcall FindClose(TSearchRec &F);
extern PACKAGE bool __fastcall DeleteFile(const System::AnsiString FileName);
extern PACKAGE bool __fastcall RenameFile(const System::AnsiString OldName, const System::AnsiString 
	NewName);
extern PACKAGE char * __fastcall AnsiStrLastChar(char * P);
extern PACKAGE char * __fastcall AnsiLastChar(const System::AnsiString S);
extern PACKAGE int __fastcall LastDelimiter(const System::AnsiString Delimiters, const System::AnsiString 
	S);
extern PACKAGE System::AnsiString __fastcall ChangeFileExt(const System::AnsiString FileName, const 
	System::AnsiString Extension);
extern PACKAGE System::AnsiString __fastcall ExtractFilePath(const System::AnsiString FileName);
extern PACKAGE System::AnsiString __fastcall ExtractFileDir(const System::AnsiString FileName);
extern PACKAGE System::AnsiString __fastcall ExtractFileDrive(const System::AnsiString FileName);
extern PACKAGE System::AnsiString __fastcall ExtractFileName(const System::AnsiString FileName);
extern PACKAGE System::AnsiString __fastcall ExtractFileExt(const System::AnsiString FileName);
extern PACKAGE System::AnsiString __fastcall ExpandFileName(const System::AnsiString FileName);
extern PACKAGE System::AnsiString __fastcall ExpandUNCFileName(const System::AnsiString FileName);
extern PACKAGE System::AnsiString __fastcall ExtractRelativePath(const System::AnsiString BaseName, 
	const System::AnsiString DestName);
extern PACKAGE System::AnsiString __fastcall ExtractShortPathName(const System::AnsiString FileName)
	;
extern PACKAGE System::AnsiString __fastcall FileSearch(const System::AnsiString Name, const System::AnsiString 
	DirList);
extern PACKAGE int __fastcall DiskFree(Byte Drive);
extern PACKAGE int __fastcall DiskSize(Byte Drive);
extern PACKAGE System::TDateTime __fastcall FileDateToDateTime(int FileDate);
extern PACKAGE int __fastcall DateTimeToFileDate(System::TDateTime DateTime);
extern PACKAGE System::AnsiString __fastcall GetCurrentDir(void);
extern PACKAGE bool __fastcall SetCurrentDir(const System::AnsiString Dir);
extern PACKAGE bool __fastcall CreateDir(const System::AnsiString Dir);
extern PACKAGE bool __fastcall RemoveDir(const System::AnsiString Dir);
extern PACKAGE Cardinal __fastcall StrLen(char * Str);
extern PACKAGE char * __fastcall StrEnd(char * Str);
extern PACKAGE char * __fastcall StrMove(char * Dest, char * Source, Cardinal Count);
extern PACKAGE char * __fastcall StrCopy(char * Dest, char * Source);
extern PACKAGE char * __fastcall StrECopy(char * Dest, char * Source);
extern PACKAGE char * __fastcall StrLCopy(char * Dest, char * Source, Cardinal MaxLen);
extern PACKAGE char * __fastcall StrPCopy(char * Dest, const System::AnsiString Source);
extern PACKAGE char * __fastcall StrPLCopy(char * Dest, const System::AnsiString Source, Cardinal MaxLen
	);
extern PACKAGE char * __fastcall StrCat(char * Dest, char * Source);
extern PACKAGE char * __fastcall StrLCat(char * Dest, char * Source, Cardinal MaxLen);
extern PACKAGE int __fastcall StrComp(char * Str1, char * Str2);
extern PACKAGE int __fastcall StrIComp(char * Str1, char * Str2);
extern PACKAGE int __fastcall StrLComp(char * Str1, char * Str2, Cardinal MaxLen);
extern PACKAGE int __fastcall StrLIComp(char * Str1, char * Str2, Cardinal MaxLen);
extern PACKAGE char * __fastcall StrScan(char * Str, char Chr);
extern PACKAGE char * __fastcall StrRScan(char * Str, char Chr);
extern PACKAGE char * __fastcall StrPos(char * Str1, char * Str2);
extern PACKAGE char * __fastcall StrUpper(char * Str);
extern PACKAGE char * __fastcall StrLower(char * Str);
extern PACKAGE System::AnsiString __fastcall StrPas(char * Str);
extern PACKAGE char * __fastcall StrAlloc(Cardinal Size);
extern PACKAGE Cardinal __fastcall StrBufSize(char * Str);
extern PACKAGE char * __fastcall StrNew(char * Str);
extern PACKAGE void __fastcall StrDispose(char * Str);
extern PACKAGE Cardinal __fastcall FormatBuf(void *Buffer, Cardinal BufLen, const void *Format, Cardinal 
	FmtLen, const System::TVarRec * Args, const int Args_Size);
extern PACKAGE char * __fastcall StrFmt(char * Buffer, char * Format, const System::TVarRec * Args, 
	const int Args_Size);
extern PACKAGE char * __fastcall StrLFmt(char * Buffer, Cardinal MaxLen, char * Format, const System::TVarRec 
	* Args, const int Args_Size);
extern PACKAGE System::AnsiString __fastcall Format(const System::AnsiString Format, const System::TVarRec 
	* Args, const int Args_Size);
extern PACKAGE void __fastcall FmtStr(System::AnsiString &Result, const System::AnsiString Format, const 
	System::TVarRec * Args, const int Args_Size);
extern PACKAGE System::AnsiString __fastcall FloatToStr(Extended Value);
extern PACKAGE System::AnsiString __fastcall CurrToStr(System::Currency Value);
extern PACKAGE System::AnsiString __fastcall FloatToStrF(Extended Value, TFloatFormat Format, int Precision
	, int Digits);
extern PACKAGE System::AnsiString __fastcall CurrToStrF(System::Currency Value, TFloatFormat Format, 
	int Digits);
extern PACKAGE System::AnsiString __fastcall FormatFloat(const System::AnsiString Format, Extended Value
	);
extern PACKAGE System::AnsiString __fastcall FormatCurr(const System::AnsiString Format, System::Currency 
	Value);
extern PACKAGE Extended __fastcall StrToFloat(const System::AnsiString S);
extern PACKAGE System::Currency __fastcall StrToCurr(const System::AnsiString S);
extern PACKAGE TTimeStamp __fastcall DateTimeToTimeStamp(System::TDateTime DateTime);
extern PACKAGE System::TDateTime __fastcall TimeStampToDateTime(const TTimeStamp &TimeStamp);
extern PACKAGE TTimeStamp __fastcall MSecsToTimeStamp(System::Comp MSecs);
extern PACKAGE System::Comp __fastcall TimeStampToMSecs(const TTimeStamp &TimeStamp);
extern PACKAGE System::TDateTime __fastcall EncodeTime(Word Hour, Word Min, Word Sec, Word MSec);
extern PACKAGE void __fastcall DecodeTime(System::TDateTime Time, Word &Hour, Word &Min, Word &Sec, 
	Word &MSec);
extern PACKAGE bool __fastcall IsLeapYear(Word Year);
extern PACKAGE System::TDateTime __fastcall EncodeDate(Word Year, Word Month, Word Day);
extern PACKAGE void __fastcall DecodeDate(System::TDateTime Date, Word &Year, Word &Month, Word &Day
	);
extern PACKAGE void __fastcall DateTimeToSystemTime(System::TDateTime DateTime, _SYSTEMTIME &SystemTime
	);
extern PACKAGE System::TDateTime __fastcall SystemTimeToDateTime(const _SYSTEMTIME &SystemTime);
extern PACKAGE int __fastcall DayOfWeek(System::TDateTime Date);
extern PACKAGE System::TDateTime __fastcall Date(void);
extern PACKAGE System::TDateTime __fastcall Time(void);
extern PACKAGE System::TDateTime __fastcall Now(void);
extern PACKAGE System::TDateTime __fastcall IncMonth(const System::TDateTime Date, int NumberOfMonths
	);
extern PACKAGE void __fastcall DateTimeToString(System::AnsiString &Result, const System::AnsiString 
	Format, System::TDateTime DateTime);
extern PACKAGE System::AnsiString __fastcall DateToStr(System::TDateTime Date);
extern PACKAGE System::AnsiString __fastcall TimeToStr(System::TDateTime Time);
extern PACKAGE System::AnsiString __fastcall DateTimeToStr(System::TDateTime DateTime);
extern PACKAGE System::AnsiString __fastcall FormatDateTime(const System::AnsiString Format, System::TDateTime 
	DateTime);
extern PACKAGE System::TDateTime __fastcall StrToDate(const System::AnsiString S);
extern PACKAGE System::TDateTime __fastcall StrToTime(const System::AnsiString S);
extern PACKAGE System::TDateTime __fastcall StrToDateTime(const System::AnsiString S);
extern PACKAGE System::AnsiString __fastcall SysErrorMessage(int ErrorCode);
extern PACKAGE System::AnsiString __fastcall GetLocaleStr(int Locale, int LocaleType, const System::AnsiString 
	Default);
extern PACKAGE char __fastcall GetLocaleChar(int Locale, int LocaleType, char Default);
extern PACKAGE void __fastcall GetFormatSettings(void);
extern PACKAGE System::TObject* __fastcall ExceptObject(void);
extern PACKAGE void * __fastcall ExceptAddr(void);
extern PACKAGE int __fastcall ExceptionErrorMessage(System::TObject* ExceptObject, void * ExceptAddr
	, char * Buffer, int Size);
extern PACKAGE void __fastcall ShowException(System::TObject* ExceptObject, void * ExceptAddr);
extern PACKAGE void __fastcall Abort(void);
extern PACKAGE void __fastcall OutOfMemoryError(void);
extern PACKAGE void __fastcall Beep(void);
extern PACKAGE TMbcsByteType __fastcall ByteType(const System::AnsiString S, int Index);
extern PACKAGE TMbcsByteType __fastcall StrByteType(char * Str, Cardinal Index);
extern PACKAGE int __fastcall ByteToCharLen(const System::AnsiString S, int MaxLen);
extern PACKAGE int __fastcall ByteToCharIndex(const System::AnsiString S, int Index);
extern PACKAGE int __fastcall CharToByteIndex(const System::AnsiString S, int Index);
extern PACKAGE int __fastcall CharToByteLen(const System::AnsiString S, int MaxLen);
extern PACKAGE bool __fastcall IsPathDelimiter(const System::AnsiString S, int Index);
extern PACKAGE bool __fastcall IsDelimiter(const System::AnsiString Delimiters, const System::AnsiString 
	S, int Index);
extern PACKAGE int __fastcall AnsiPos(const System::AnsiString Substr, const System::AnsiString S);
extern PACKAGE int __fastcall AnsiCompareFileName(const System::AnsiString S1, const System::AnsiString 
	S2);
extern PACKAGE System::AnsiString __fastcall AnsiLowerCaseFileName(const System::AnsiString S);
extern PACKAGE System::AnsiString __fastcall AnsiUpperCaseFileName(const System::AnsiString S);
extern PACKAGE char * __fastcall AnsiStrPos(char * Str, char * SubStr);
extern PACKAGE char * __fastcall AnsiStrRScan(char * Str, char Chr);
extern PACKAGE char * __fastcall AnsiStrScan(char * Str, char Chr);
extern PACKAGE System::AnsiString __fastcall StringReplace(const System::AnsiString S, const System::AnsiString 
	OldPattern, const System::AnsiString NewPattern, TReplaceFlags Flags);
extern PACKAGE System::AnsiString __fastcall WrapText(const System::AnsiString Line, const System::AnsiString 
	BreakStr, const TSysCharSet &BreakChars, int MaxCol);
extern PACKAGE bool __fastcall FindCmdLineSwitch(const System::AnsiString Switch, const TSysCharSet 
	&SwitchChars, bool IgnoreCase);
extern PACKAGE void __fastcall InitializePackage(Windows::HINST Module);
extern PACKAGE void __fastcall FinalizePackage(Windows::HINST Module);
extern PACKAGE Windows::HINST __fastcall LoadPackage(const System::AnsiString Name);
extern PACKAGE void __fastcall UnloadPackage(Windows::HINST Module);
extern PACKAGE void __fastcall GetPackageInfo(Windows::HINST Module, void * Param, int &Flags, TPackageInfoProc 
	InfoProc);
extern PACKAGE System::AnsiString __fastcall GetPackageDescription(char * ModuleName);
extern PACKAGE void __fastcall RaiseLastWin32Error(void);
extern PACKAGE BOOL __fastcall Win32Check(BOOL RetVal);
extern PACKAGE void __fastcall AddTerminateProc(TTerminateProc TermProc);
extern PACKAGE bool __fastcall CallTerminateProcs(void);
extern PACKAGE int __fastcall GDAL(void);
extern PACKAGE void __fastcall RCS(void);
extern PACKAGE void __fastcall RPR(void);
extern PACKAGE int __fastcall FloatToText(char * Buffer, const void *Value, TFloatValue ValueType, TFloatFormat 
	Format, int Precision, int Digits);
extern PACKAGE int __fastcall FloatToTextFmt(char * Buffer, const void *Value, TFloatValue ValueType
	, char * Format);
extern PACKAGE void __fastcall FloatToDecimal(TFloatRec &Result, const void *Value, TFloatValue ValueType
	, int Precision, int Decimals);
extern PACKAGE bool __fastcall TextToFloat(char * Buffer, void *Value, TFloatValue ValueType);

}	/* namespace Sysutils */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Sysutils;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SysUtils
