#ifndef __VALIMP_CC
#define __VALIMP_CC
#pragma option push -b -a4 -Vx- -Ve- -w-inl -w-aus -w-sig

/***************************************************************************
 *
 * valimp.cc - Declarations for the Standard Library valarray
 *
 * $Id: valimp.cc,v 1.1 1996/09/25 00:47:56 philippe Exp $
 *
 ***************************************************************************
 *
 * (c) Copyright 1994, 1995 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 *
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 **************************************************************************/

#ifndef _RWSTD_NO_NAMESPACE
 #ifndef _RWSTD_NO_IMP_NAMESPACE
  namespace rwstd {
 #else
  namespace std {
 #endif
#endif


/*****************************************************************
*                                                                *
*                _RW_array<T> MEMBER FUNCTIONS                    *
*                                                                *
******************************************************************/

  template <class T>
  void
  _RW_array<T>::_initialize_with_value(const T& value, size_t size)
  {
      if ( _RW_length < size )
		_RW_resize_without_copy(size);

      for(size_t cpt=0; cpt<size; cpt++)
       _RW_storage[cpt] = value;
  }

   template <class T>
   void
   _RW_array<T>::_initialize_with_array(const T* pointer, size_t size)
   {
      if ( _RW_length < size )
		_RW_resize_without_copy(size);

      if ( valarray_traits_optimize<T>::optimize_copy() )
	   memcpy((void *)_RW_storage,(void*)pointer,size*sizeof(T));
      else
      {
        for(size_t cpt=0; cpt<size; cpt++)
	     _RW_storage[cpt] = pointer[cpt];
      }
    }

   template <class T>
   void 
   _RW_array<T>::_copy_memory_array(const _RW_array<T>& array)
   {
      if ( array._get_length() != _RW_length )
       _RW_resize_without_copy(array._get_length());

      if ( valarray_traits_optimize<T>::optimize_copy() )
       array._RW_copy(_RW_storage);
	  else
      {
        for(size_t tmp=0; tmp<_RW_length; tmp++)
         _RW_storage[tmp]= array[tmp];
	  }
    }


#ifndef _RWSTD_NO_NAMESPACE
}
#endif

#pragma option pop
#endif /* __VALIMP_CC */
