#ifndef __STD_LOC_VENDOR
#define __STD_LOC_VENDOR
#pragma option push -b -a4 -Vx- -Ve- -w-inl -w-aus -w-sig

/***************************************************************************
 *
 * vendor -- Vendor-supplied declarations for the Standard Library locale
 *           classes.
 *
 * $Id: vendor,v 1.10 1996/10/02 01:48:00 smithey Exp $
 *
 ***************************************************************************
 *
 * (c) Copyright 1994, 1995 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 *
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 ***************************************************************************
 *
 *
 **************************************************************************/


#include <rw/ctype>
#include <rw/numeral>

#ifndef _RWSTD_NO_NAMESPACE
namespace __rwstd {
#endif

// --------------------------------------------------------
// Implementation function template -- create_native_facet.
// --------------------------------------------------------

// Vendors must specialize this inline function template for each facet of the
// vendor-default native ("") locale that is different from the same facet of
// the classic locale.  Each specialization should construct and return a new
// instance of the requested native-behavior facet with an initial reference
// count of 1 (not the default 0!).

// Note that a specialization for ctype<char> must always be provided, because
// ctype<char> lacks a constructor with the signature used in the template.

inline ctype<char>* _RWSTDExport create_native_facet (ctype<char>*) {
  return new ctype<char>(NULL,false,1);
}

inline numpunct<char>* _RWSTDExport create_native_facet (numpunct<char>*) {
  return new numpunct_byname<char>("",1);
}

// The default template function for Facets not specialized above returns a
// facet with classic-locale behavior.

template <class Facet>
inline Facet* _RWSTDExport create_native_facet (Facet*) {
  return create_named_facet((Facet*)0,"",(size_t)1);
}

#ifndef _RWSTD_NO_NAMESPACE
} // namespace __rwstd
#endif

#pragma option pop
#endif // __STD_LOC_VENDOR
